package jp.juggler.subwaytooter.util;

import java.util.HashMap;

public class EmojiMap {
	public static final HashMap<String, String> _shortNameToUnicode = new HashMap<String, String>();
	public static final HashMap<String, String> _unicodeToShortName = new HashMap<String, String>();
	
	private static void _addEntry(String name,String unicode){
		_shortNameToUnicode.put(name,unicode);
		int c = unicode.charAt( 0 );
		if( unicode.length() == 1 &&  0 <= c && c <= 0x7f ){
			// ASCII文字列は絵文字とみなさない
		}else{
			// 他は絵文字フォントで囲いたい
			_unicodeToShortName.put(unicode,name);
		}
	}
	
	private static void init1(){
		_addEntry("+1", new String(new int[] {0x1f44d}, 0, 1));
		_addEntry("+1_tone1", new String(new int[] {0x1f44d,0x1f3fb}, 0, 2));
		_addEntry("+1_tone2", new String(new int[] {0x1f44d,0x1f3fc}, 0, 2));
		_addEntry("+1_tone3", new String(new int[] {0x1f44d,0x1f3fd}, 0, 2));
		_addEntry("+1_tone4", new String(new int[] {0x1f44d,0x1f3fe}, 0, 2));
		_addEntry("+1_tone5", new String(new int[] {0x1f44d,0x1f3ff}, 0, 2));
		_addEntry("-1", new String(new int[] {0x1f44e}, 0, 1));
		_addEntry("-1_tone1", new String(new int[] {0x1f44e,0x1f3fb}, 0, 2));
		_addEntry("-1_tone2", new String(new int[] {0x1f44e,0x1f3fc}, 0, 2));
		_addEntry("-1_tone3", new String(new int[] {0x1f44e,0x1f3fd}, 0, 2));
		_addEntry("-1_tone4", new String(new int[] {0x1f44e,0x1f3fe}, 0, 2));
		_addEntry("-1_tone5", new String(new int[] {0x1f44e,0x1f3ff}, 0, 2));
		_addEntry("100", new String(new int[] {0x1f4af}, 0, 1));
		_addEntry("1234", new String(new int[] {0x1f522}, 0, 1));
		_addEntry("8ball", new String(new int[] {0x1f3b1}, 0, 1));
		_addEntry("a", new String(new int[] {0x1f170}, 0, 1));
		_addEntry("ab", new String(new int[] {0x1f18e}, 0, 1));
		_addEntry("abc", new String(new int[] {0x1f524}, 0, 1));
		_addEntry("abcd", new String(new int[] {0x1f521}, 0, 1));
		_addEntry("ac", new String(new int[] {0x1f1e6,0x1f1e8}, 0, 2));
		_addEntry("accept", new String(new int[] {0x1f251}, 0, 1));
		_addEntry("ad", new String(new int[] {0x1f1e6,0x1f1e9}, 0, 2));
		_addEntry("admission_tickets", new String(new int[] {0x1f39f}, 0, 1));
		_addEntry("ae", new String(new int[] {0x1f1e6,0x1f1ea}, 0, 2));
		_addEntry("aerial_tramway", new String(new int[] {0x1f6a1}, 0, 1));
		_addEntry("af", new String(new int[] {0x1f1e6,0x1f1eb}, 0, 2));
		_addEntry("ag", new String(new int[] {0x1f1e6,0x1f1ec}, 0, 2));
		_addEntry("ai", new String(new int[] {0x1f1e6,0x1f1ee}, 0, 2));
		_addEntry("airplane", new String(new int[] {0x2708}, 0, 1));
		_addEntry("airplane_arriving", new String(new int[] {0x1f6ec}, 0, 1));
		_addEntry("airplane_departure", new String(new int[] {0x1f6eb}, 0, 1));
		_addEntry("airplane_small", new String(new int[] {0x1f6e9}, 0, 1));
		_addEntry("al", new String(new int[] {0x1f1e6,0x1f1f1}, 0, 2));
		_addEntry("alarm_clock", new String(new int[] {0x23f0}, 0, 1));
		_addEntry("alembic", new String(new int[] {0x2697}, 0, 1));
		_addEntry("alien", new String(new int[] {0x1f47d}, 0, 1));
		_addEntry("am", new String(new int[] {0x1f1e6,0x1f1f2}, 0, 2));
		_addEntry("ambulance", new String(new int[] {0x1f691}, 0, 1));
		_addEntry("amphora", new String(new int[] {0x1f3fa}, 0, 1));
		_addEntry("anchor", new String(new int[] {0x2693}, 0, 1));
		_addEntry("angel", new String(new int[] {0x1f47c}, 0, 1));
		_addEntry("angel_tone1", new String(new int[] {0x1f47c,0x1f3fb}, 0, 2));
		_addEntry("angel_tone2", new String(new int[] {0x1f47c,0x1f3fc}, 0, 2));
		_addEntry("angel_tone3", new String(new int[] {0x1f47c,0x1f3fd}, 0, 2));
		_addEntry("angel_tone4", new String(new int[] {0x1f47c,0x1f3fe}, 0, 2));
		_addEntry("angel_tone5", new String(new int[] {0x1f47c,0x1f3ff}, 0, 2));
		_addEntry("anger", new String(new int[] {0x1f4a2}, 0, 1));
		_addEntry("anger_right", new String(new int[] {0x1f5ef}, 0, 1));
		_addEntry("angry", new String(new int[] {0x1f620}, 0, 1));
		_addEntry("anguished", new String(new int[] {0x1f627}, 0, 1));
		_addEntry("ant", new String(new int[] {0x1f41c}, 0, 1));
		_addEntry("ao", new String(new int[] {0x1f1e6,0x1f1f4}, 0, 2));
		_addEntry("apple", new String(new int[] {0x1f34e}, 0, 1));
		_addEntry("aq", new String(new int[] {0x1f1e6,0x1f1f6}, 0, 2));
		_addEntry("aquarius", new String(new int[] {0x2652}, 0, 1));
		_addEntry("ar", new String(new int[] {0x1f1e6,0x1f1f7}, 0, 2));
		_addEntry("archery", new String(new int[] {0x1f3f9}, 0, 1));
		_addEntry("aries", new String(new int[] {0x2648}, 0, 1));
		_addEntry("arrow_backward", new String(new int[] {0x25c0}, 0, 1));
		_addEntry("arrow_double_down", new String(new int[] {0x23ec}, 0, 1));
		_addEntry("arrow_double_up", new String(new int[] {0x23eb}, 0, 1));
		_addEntry("arrow_down", new String(new int[] {0x2b07}, 0, 1));
		_addEntry("arrow_down_small", new String(new int[] {0x1f53d}, 0, 1));
		_addEntry("arrow_forward", new String(new int[] {0x25b6}, 0, 1));
		_addEntry("arrow_heading_down", new String(new int[] {0x2935}, 0, 1));
		_addEntry("arrow_heading_up", new String(new int[] {0x2934}, 0, 1));
		_addEntry("arrow_left", new String(new int[] {0x2b05}, 0, 1));
		_addEntry("arrow_lower_left", new String(new int[] {0x2199}, 0, 1));
		_addEntry("arrow_lower_right", new String(new int[] {0x2198}, 0, 1));
		_addEntry("arrow_right", new String(new int[] {0x27a1}, 0, 1));
		_addEntry("arrow_right_hook", new String(new int[] {0x21aa}, 0, 1));
		_addEntry("arrow_up", new String(new int[] {0x2b06}, 0, 1));
		_addEntry("arrow_up_down", new String(new int[] {0x2195}, 0, 1));
		_addEntry("arrow_up_small", new String(new int[] {0x1f53c}, 0, 1));
		_addEntry("arrow_upper_left", new String(new int[] {0x2196}, 0, 1));
		_addEntry("arrow_upper_right", new String(new int[] {0x2197}, 0, 1));
		_addEntry("arrows_clockwise", new String(new int[] {0x1f503}, 0, 1));
		_addEntry("arrows_counterclockwise", new String(new int[] {0x1f504}, 0, 1));
		_addEntry("art", new String(new int[] {0x1f3a8}, 0, 1));
		_addEntry("articulated_lorry", new String(new int[] {0x1f69b}, 0, 1));
		_addEntry("as", new String(new int[] {0x1f1e6,0x1f1f8}, 0, 2));
		_addEntry("asterisk", new String(new int[] {0x002a,0x20e3}, 0, 2));
		_addEntry("asterisk_symbol", new String(new int[] {0x002a}, 0, 1));
		_addEntry("astonished", new String(new int[] {0x1f632}, 0, 1));
		_addEntry("at", new String(new int[] {0x1f1e6,0x1f1f9}, 0, 2));
		_addEntry("athletic_shoe", new String(new int[] {0x1f45f}, 0, 1));
		_addEntry("atm", new String(new int[] {0x1f3e7}, 0, 1));
		_addEntry("atom", new String(new int[] {0x269b}, 0, 1));
		_addEntry("atom_symbol", new String(new int[] {0x269b}, 0, 1));
		_addEntry("au", new String(new int[] {0x1f1e6,0x1f1fa}, 0, 2));
		_addEntry("avocado", new String(new int[] {0x1f951}, 0, 1));
		_addEntry("aw", new String(new int[] {0x1f1e6,0x1f1fc}, 0, 2));
		_addEntry("ax", new String(new int[] {0x1f1e6,0x1f1fd}, 0, 2));
		_addEntry("az", new String(new int[] {0x1f1e6,0x1f1ff}, 0, 2));
		_addEntry("b", new String(new int[] {0x1f171}, 0, 1));
		_addEntry("ba", new String(new int[] {0x1f1e7,0x1f1e6}, 0, 2));
		_addEntry("baby", new String(new int[] {0x1f476}, 0, 1));
		_addEntry("baby_bottle", new String(new int[] {0x1f37c}, 0, 1));
		_addEntry("baby_chick", new String(new int[] {0x1f424}, 0, 1));
		_addEntry("baby_symbol", new String(new int[] {0x1f6bc}, 0, 1));
		_addEntry("baby_tone1", new String(new int[] {0x1f476,0x1f3fb}, 0, 2));
	}
	private static void init2(){
		_addEntry("baby_tone2", new String(new int[] {0x1f476,0x1f3fc}, 0, 2));
		_addEntry("baby_tone3", new String(new int[] {0x1f476,0x1f3fd}, 0, 2));
		_addEntry("baby_tone4", new String(new int[] {0x1f476,0x1f3fe}, 0, 2));
		_addEntry("baby_tone5", new String(new int[] {0x1f476,0x1f3ff}, 0, 2));
		_addEntry("back", new String(new int[] {0x1f519}, 0, 1));
		_addEntry("back_of_hand", new String(new int[] {0x1f91a}, 0, 1));
		_addEntry("back_of_hand_tone1", new String(new int[] {0x1f91a,0x1f3fb}, 0, 2));
		_addEntry("back_of_hand_tone2", new String(new int[] {0x1f91a,0x1f3fc}, 0, 2));
		_addEntry("back_of_hand_tone3", new String(new int[] {0x1f91a,0x1f3fd}, 0, 2));
		_addEntry("back_of_hand_tone4", new String(new int[] {0x1f91a,0x1f3fe}, 0, 2));
		_addEntry("back_of_hand_tone5", new String(new int[] {0x1f91a,0x1f3ff}, 0, 2));
		_addEntry("bacon", new String(new int[] {0x1f953}, 0, 1));
		_addEntry("badminton", new String(new int[] {0x1f3f8}, 0, 1));
		_addEntry("baggage_claim", new String(new int[] {0x1f6c4}, 0, 1));
		_addEntry("baguette_bread", new String(new int[] {0x1f956}, 0, 1));
		_addEntry("balloon", new String(new int[] {0x1f388}, 0, 1));
		_addEntry("ballot_box", new String(new int[] {0x1f5f3}, 0, 1));
		_addEntry("ballot_box_with_ballot", new String(new int[] {0x1f5f3}, 0, 1));
		_addEntry("ballot_box_with_check", new String(new int[] {0x2611}, 0, 1));
		_addEntry("bamboo", new String(new int[] {0x1f38d}, 0, 1));
		_addEntry("banana", new String(new int[] {0x1f34c}, 0, 1));
		_addEntry("bangbang", new String(new int[] {0x203c}, 0, 1));
		_addEntry("bank", new String(new int[] {0x1f3e6}, 0, 1));
		_addEntry("bar_chart", new String(new int[] {0x1f4ca}, 0, 1));
		_addEntry("barber", new String(new int[] {0x1f488}, 0, 1));
		_addEntry("baseball", new String(new int[] {0x26be}, 0, 1));
		_addEntry("basketball", new String(new int[] {0x1f3c0}, 0, 1));
		_addEntry("basketball_player", new String(new int[] {0x26f9}, 0, 1));
		_addEntry("basketball_player_tone1", new String(new int[] {0x26f9,0x1f3fb}, 0, 2));
		_addEntry("basketball_player_tone2", new String(new int[] {0x26f9,0x1f3fc}, 0, 2));
		_addEntry("basketball_player_tone3", new String(new int[] {0x26f9,0x1f3fd}, 0, 2));
		_addEntry("basketball_player_tone4", new String(new int[] {0x26f9,0x1f3fe}, 0, 2));
		_addEntry("basketball_player_tone5", new String(new int[] {0x26f9,0x1f3ff}, 0, 2));
		_addEntry("bat", new String(new int[] {0x1f987}, 0, 1));
		_addEntry("bath", new String(new int[] {0x1f6c0}, 0, 1));
		_addEntry("bath_tone1", new String(new int[] {0x1f6c0,0x1f3fb}, 0, 2));
		_addEntry("bath_tone2", new String(new int[] {0x1f6c0,0x1f3fc}, 0, 2));
		_addEntry("bath_tone3", new String(new int[] {0x1f6c0,0x1f3fd}, 0, 2));
		_addEntry("bath_tone4", new String(new int[] {0x1f6c0,0x1f3fe}, 0, 2));
		_addEntry("bath_tone5", new String(new int[] {0x1f6c0,0x1f3ff}, 0, 2));
		_addEntry("bathtub", new String(new int[] {0x1f6c1}, 0, 1));
		_addEntry("battery", new String(new int[] {0x1f50b}, 0, 1));
		_addEntry("bb", new String(new int[] {0x1f1e7,0x1f1e7}, 0, 2));
		_addEntry("bd", new String(new int[] {0x1f1e7,0x1f1e9}, 0, 2));
		_addEntry("be", new String(new int[] {0x1f1e7,0x1f1ea}, 0, 2));
		_addEntry("beach", new String(new int[] {0x1f3d6}, 0, 1));
		_addEntry("beach_umbrella", new String(new int[] {0x26f1}, 0, 1));
		_addEntry("beach_with_umbrella", new String(new int[] {0x1f3d6}, 0, 1));
		_addEntry("bear", new String(new int[] {0x1f43b}, 0, 1));
		_addEntry("bed", new String(new int[] {0x1f6cf}, 0, 1));
		_addEntry("bee", new String(new int[] {0x1f41d}, 0, 1));
		_addEntry("beer", new String(new int[] {0x1f37a}, 0, 1));
		_addEntry("beers", new String(new int[] {0x1f37b}, 0, 1));
		_addEntry("beetle", new String(new int[] {0x1f41e}, 0, 1));
		_addEntry("beginner", new String(new int[] {0x1f530}, 0, 1));
		_addEntry("bell", new String(new int[] {0x1f514}, 0, 1));
		_addEntry("bellhop", new String(new int[] {0x1f6ce}, 0, 1));
		_addEntry("bellhop_bell", new String(new int[] {0x1f6ce}, 0, 1));
		_addEntry("bento", new String(new int[] {0x1f371}, 0, 1));
		_addEntry("bf", new String(new int[] {0x1f1e7,0x1f1eb}, 0, 2));
		_addEntry("bg", new String(new int[] {0x1f1e7,0x1f1ec}, 0, 2));
		_addEntry("bh", new String(new int[] {0x1f1e7,0x1f1ed}, 0, 2));
		_addEntry("bi", new String(new int[] {0x1f1e7,0x1f1ee}, 0, 2));
		_addEntry("bicyclist", new String(new int[] {0x1f6b4}, 0, 1));
		_addEntry("bicyclist_tone1", new String(new int[] {0x1f6b4,0x1f3fb}, 0, 2));
		_addEntry("bicyclist_tone2", new String(new int[] {0x1f6b4,0x1f3fc}, 0, 2));
		_addEntry("bicyclist_tone3", new String(new int[] {0x1f6b4,0x1f3fd}, 0, 2));
		_addEntry("bicyclist_tone4", new String(new int[] {0x1f6b4,0x1f3fe}, 0, 2));
		_addEntry("bicyclist_tone5", new String(new int[] {0x1f6b4,0x1f3ff}, 0, 2));
		_addEntry("bike", new String(new int[] {0x1f6b2}, 0, 1));
		_addEntry("bikini", new String(new int[] {0x1f459}, 0, 1));
		_addEntry("biohazard", new String(new int[] {0x2623}, 0, 1));
		_addEntry("biohazard_sign", new String(new int[] {0x2623}, 0, 1));
		_addEntry("bird", new String(new int[] {0x1f426}, 0, 1));
		_addEntry("birthday", new String(new int[] {0x1f382}, 0, 1));
		_addEntry("bj", new String(new int[] {0x1f1e7,0x1f1ef}, 0, 2));
		_addEntry("bl", new String(new int[] {0x1f1e7,0x1f1f1}, 0, 2));
		_addEntry("black_circle", new String(new int[] {0x26ab}, 0, 1));
		_addEntry("black_heart", new String(new int[] {0x1f5a4}, 0, 1));
		_addEntry("black_joker", new String(new int[] {0x1f0cf}, 0, 1));
		_addEntry("black_large_square", new String(new int[] {0x2b1b}, 0, 1));
		_addEntry("black_medium_small_square", new String(new int[] {0x25fe}, 0, 1));
		_addEntry("black_medium_square", new String(new int[] {0x25fc}, 0, 1));
		_addEntry("black_nib", new String(new int[] {0x2712}, 0, 1));
		_addEntry("black_small_square", new String(new int[] {0x25aa}, 0, 1));
		_addEntry("black_square_button", new String(new int[] {0x1f532}, 0, 1));
		_addEntry("blond-haired_man", new String(new int[] {0x1f471,0x2642}, 0, 2));
		_addEntry("blond-haired_man_dark_skin_tone", new String(new int[] {0x1f471,0x1f3ff,0x2642}, 0, 3));
		_addEntry("blond-haired_man_light_skin_tone", new String(new int[] {0x1f471,0x1f3fb,0x2642}, 0, 3));
		_addEntry("blond-haired_man_medium_dark_skin_tone", new String(new int[] {0x1f471,0x1f3fe,0x2642}, 0, 3));
		_addEntry("blond-haired_man_medium_light_skin_tone", new String(new int[] {0x1f471,0x1f3fc,0x2642}, 0, 3));
		_addEntry("blond-haired_man_medium_skin_tone", new String(new int[] {0x1f471,0x1f3fd,0x2642}, 0, 3));
		_addEntry("blond-haired_man_tone1", new String(new int[] {0x1f471,0x1f3fb,0x2642}, 0, 3));
		_addEntry("blond-haired_man_tone2", new String(new int[] {0x1f471,0x1f3fc,0x2642}, 0, 3));
		_addEntry("blond-haired_man_tone3", new String(new int[] {0x1f471,0x1f3fd,0x2642}, 0, 3));
		_addEntry("blond-haired_man_tone4", new String(new int[] {0x1f471,0x1f3fe,0x2642}, 0, 3));
		_addEntry("blond-haired_man_tone5", new String(new int[] {0x1f471,0x1f3ff,0x2642}, 0, 3));
		_addEntry("blond-haired_woman", new String(new int[] {0x1f471,0x2640}, 0, 2));
		_addEntry("blond-haired_woman_dark_skin_tone", new String(new int[] {0x1f471,0x1f3ff,0x2640}, 0, 3));
		_addEntry("blond-haired_woman_light_skin_tone", new String(new int[] {0x1f471,0x1f3fb,0x2640}, 0, 3));
		_addEntry("blond-haired_woman_medium_dark_skin_tone", new String(new int[] {0x1f471,0x1f3fe,0x2640}, 0, 3));
	}
	private static void init3(){
		_addEntry("blond-haired_woman_medium_light_skin_tone", new String(new int[] {0x1f471,0x1f3fc,0x2640}, 0, 3));
		_addEntry("blond-haired_woman_medium_skin_tone", new String(new int[] {0x1f471,0x1f3fd,0x2640}, 0, 3));
		_addEntry("blond-haired_woman_tone1", new String(new int[] {0x1f471,0x1f3fb,0x2640}, 0, 3));
		_addEntry("blond-haired_woman_tone2", new String(new int[] {0x1f471,0x1f3fc,0x2640}, 0, 3));
		_addEntry("blond-haired_woman_tone3", new String(new int[] {0x1f471,0x1f3fd,0x2640}, 0, 3));
		_addEntry("blond-haired_woman_tone4", new String(new int[] {0x1f471,0x1f3fe,0x2640}, 0, 3));
		_addEntry("blond-haired_woman_tone5", new String(new int[] {0x1f471,0x1f3ff,0x2640}, 0, 3));
		_addEntry("blossom", new String(new int[] {0x1f33c}, 0, 1));
		_addEntry("blowfish", new String(new int[] {0x1f421}, 0, 1));
		_addEntry("blue_book", new String(new int[] {0x1f4d8}, 0, 1));
		_addEntry("blue_car", new String(new int[] {0x1f699}, 0, 1));
		_addEntry("blue_circle", new String(new int[] {0x1f535}, 0, 1));
		_addEntry("blue_heart", new String(new int[] {0x1f499}, 0, 1));
		_addEntry("blush", new String(new int[] {0x1f60a}, 0, 1));
		_addEntry("bm", new String(new int[] {0x1f1e7,0x1f1f2}, 0, 2));
		_addEntry("bn", new String(new int[] {0x1f1e7,0x1f1f3}, 0, 2));
		_addEntry("bo", new String(new int[] {0x1f1e7,0x1f1f4}, 0, 2));
		_addEntry("boar", new String(new int[] {0x1f417}, 0, 1));
		_addEntry("bomb", new String(new int[] {0x1f4a3}, 0, 1));
		_addEntry("book", new String(new int[] {0x1f4d6}, 0, 1));
		_addEntry("bookmark", new String(new int[] {0x1f516}, 0, 1));
		_addEntry("bookmark_tabs", new String(new int[] {0x1f4d1}, 0, 1));
		_addEntry("books", new String(new int[] {0x1f4da}, 0, 1));
		_addEntry("boom", new String(new int[] {0x1f4a5}, 0, 1));
		_addEntry("boot", new String(new int[] {0x1f462}, 0, 1));
		_addEntry("bottle_with_popping_cork", new String(new int[] {0x1f37e}, 0, 1));
		_addEntry("bouquet", new String(new int[] {0x1f490}, 0, 1));
		_addEntry("bow", new String(new int[] {0x1f647}, 0, 1));
		_addEntry("bow_and_arrow", new String(new int[] {0x1f3f9}, 0, 1));
		_addEntry("bow_tone1", new String(new int[] {0x1f647,0x1f3fb}, 0, 2));
		_addEntry("bow_tone2", new String(new int[] {0x1f647,0x1f3fc}, 0, 2));
		_addEntry("bow_tone3", new String(new int[] {0x1f647,0x1f3fd}, 0, 2));
		_addEntry("bow_tone4", new String(new int[] {0x1f647,0x1f3fe}, 0, 2));
		_addEntry("bow_tone5", new String(new int[] {0x1f647,0x1f3ff}, 0, 2));
		_addEntry("bowling", new String(new int[] {0x1f3b3}, 0, 1));
		_addEntry("boxing_glove", new String(new int[] {0x1f94a}, 0, 1));
		_addEntry("boxing_gloves", new String(new int[] {0x1f94a}, 0, 1));
		_addEntry("boy", new String(new int[] {0x1f466}, 0, 1));
		_addEntry("boy_tone1", new String(new int[] {0x1f466,0x1f3fb}, 0, 2));
		_addEntry("boy_tone2", new String(new int[] {0x1f466,0x1f3fc}, 0, 2));
		_addEntry("boy_tone3", new String(new int[] {0x1f466,0x1f3fd}, 0, 2));
		_addEntry("boy_tone4", new String(new int[] {0x1f466,0x1f3fe}, 0, 2));
		_addEntry("boy_tone5", new String(new int[] {0x1f466,0x1f3ff}, 0, 2));
		_addEntry("bq", new String(new int[] {0x1f1e7,0x1f1f6}, 0, 2));
		_addEntry("br", new String(new int[] {0x1f1e7,0x1f1f7}, 0, 2));
		_addEntry("bread", new String(new int[] {0x1f35e}, 0, 1));
		_addEntry("bride_with_veil", new String(new int[] {0x1f470}, 0, 1));
		_addEntry("bride_with_veil_tone1", new String(new int[] {0x1f470,0x1f3fb}, 0, 2));
		_addEntry("bride_with_veil_tone2", new String(new int[] {0x1f470,0x1f3fc}, 0, 2));
		_addEntry("bride_with_veil_tone3", new String(new int[] {0x1f470,0x1f3fd}, 0, 2));
		_addEntry("bride_with_veil_tone4", new String(new int[] {0x1f470,0x1f3fe}, 0, 2));
		_addEntry("bride_with_veil_tone5", new String(new int[] {0x1f470,0x1f3ff}, 0, 2));
		_addEntry("bridge_at_night", new String(new int[] {0x1f309}, 0, 1));
		_addEntry("briefcase", new String(new int[] {0x1f4bc}, 0, 1));
		_addEntry("broken_heart", new String(new int[] {0x1f494}, 0, 1));
		_addEntry("bs", new String(new int[] {0x1f1e7,0x1f1f8}, 0, 2));
		_addEntry("bt", new String(new int[] {0x1f1e7,0x1f1f9}, 0, 2));
		_addEntry("bug", new String(new int[] {0x1f41b}, 0, 1));
		_addEntry("building_construction", new String(new int[] {0x1f3d7}, 0, 1));
		_addEntry("bulb", new String(new int[] {0x1f4a1}, 0, 1));
		_addEntry("bullettrain_front", new String(new int[] {0x1f685}, 0, 1));
		_addEntry("bullettrain_side", new String(new int[] {0x1f684}, 0, 1));
		_addEntry("burrito", new String(new int[] {0x1f32f}, 0, 1));
		_addEntry("bus", new String(new int[] {0x1f68c}, 0, 1));
		_addEntry("busstop", new String(new int[] {0x1f68f}, 0, 1));
		_addEntry("bust_in_silhouette", new String(new int[] {0x1f464}, 0, 1));
		_addEntry("busts_in_silhouette", new String(new int[] {0x1f465}, 0, 1));
		_addEntry("butterfly", new String(new int[] {0x1f98b}, 0, 1));
		_addEntry("bv", new String(new int[] {0x1f1e7,0x1f1fb}, 0, 2));
		_addEntry("bw", new String(new int[] {0x1f1e7,0x1f1fc}, 0, 2));
		_addEntry("by", new String(new int[] {0x1f1e7,0x1f1fe}, 0, 2));
		_addEntry("bz", new String(new int[] {0x1f1e7,0x1f1ff}, 0, 2));
		_addEntry("ca", new String(new int[] {0x1f1e8,0x1f1e6}, 0, 2));
		_addEntry("cactus", new String(new int[] {0x1f335}, 0, 1));
		_addEntry("cake", new String(new int[] {0x1f370}, 0, 1));
		_addEntry("calendar", new String(new int[] {0x1f4c6}, 0, 1));
		_addEntry("calendar_spiral", new String(new int[] {0x1f5d3}, 0, 1));
		_addEntry("call_me", new String(new int[] {0x1f919}, 0, 1));
		_addEntry("call_me_hand", new String(new int[] {0x1f919}, 0, 1));
		_addEntry("call_me_hand_tone1", new String(new int[] {0x1f919,0x1f3fb}, 0, 2));
		_addEntry("call_me_hand_tone2", new String(new int[] {0x1f919,0x1f3fc}, 0, 2));
		_addEntry("call_me_hand_tone3", new String(new int[] {0x1f919,0x1f3fd}, 0, 2));
		_addEntry("call_me_hand_tone4", new String(new int[] {0x1f919,0x1f3fe}, 0, 2));
		_addEntry("call_me_hand_tone5", new String(new int[] {0x1f919,0x1f3ff}, 0, 2));
		_addEntry("call_me_tone1", new String(new int[] {0x1f919,0x1f3fb}, 0, 2));
		_addEntry("call_me_tone2", new String(new int[] {0x1f919,0x1f3fc}, 0, 2));
		_addEntry("call_me_tone3", new String(new int[] {0x1f919,0x1f3fd}, 0, 2));
		_addEntry("call_me_tone4", new String(new int[] {0x1f919,0x1f3fe}, 0, 2));
		_addEntry("call_me_tone5", new String(new int[] {0x1f919,0x1f3ff}, 0, 2));
		_addEntry("calling", new String(new int[] {0x1f4f2}, 0, 1));
		_addEntry("camel", new String(new int[] {0x1f42b}, 0, 1));
		_addEntry("camera", new String(new int[] {0x1f4f7}, 0, 1));
		_addEntry("camera_with_flash", new String(new int[] {0x1f4f8}, 0, 1));
		_addEntry("camping", new String(new int[] {0x1f3d5}, 0, 1));
		_addEntry("cancer", new String(new int[] {0x264b}, 0, 1));
		_addEntry("candle", new String(new int[] {0x1f56f}, 0, 1));
		_addEntry("candy", new String(new int[] {0x1f36c}, 0, 1));
		_addEntry("canoe", new String(new int[] {0x1f6f6}, 0, 1));
		_addEntry("capital_abcd", new String(new int[] {0x1f520}, 0, 1));
		_addEntry("capricorn", new String(new int[] {0x2651}, 0, 1));
		_addEntry("card_box", new String(new int[] {0x1f5c3}, 0, 1));
	}
	private static void init4(){
		_addEntry("card_file_box", new String(new int[] {0x1f5c3}, 0, 1));
		_addEntry("card_index", new String(new int[] {0x1f4c7}, 0, 1));
		_addEntry("card_index_dividers", new String(new int[] {0x1f5c2}, 0, 1));
		_addEntry("carousel_horse", new String(new int[] {0x1f3a0}, 0, 1));
		_addEntry("carrot", new String(new int[] {0x1f955}, 0, 1));
		_addEntry("cartwheel", new String(new int[] {0x1f938}, 0, 1));
		_addEntry("cartwheel_tone1", new String(new int[] {0x1f938,0x1f3fb}, 0, 2));
		_addEntry("cartwheel_tone2", new String(new int[] {0x1f938,0x1f3fc}, 0, 2));
		_addEntry("cartwheel_tone3", new String(new int[] {0x1f938,0x1f3fd}, 0, 2));
		_addEntry("cartwheel_tone4", new String(new int[] {0x1f938,0x1f3fe}, 0, 2));
		_addEntry("cartwheel_tone5", new String(new int[] {0x1f938,0x1f3ff}, 0, 2));
		_addEntry("cat", new String(new int[] {0x1f431}, 0, 1));
		_addEntry("cat2", new String(new int[] {0x1f408}, 0, 1));
		_addEntry("cc", new String(new int[] {0x1f1e8,0x1f1e8}, 0, 2));
		_addEntry("cd", new String(new int[] {0x1f4bf}, 0, 1));
		_addEntry("cf", new String(new int[] {0x1f1e8,0x1f1eb}, 0, 2));
		_addEntry("cg", new String(new int[] {0x1f1e8,0x1f1ec}, 0, 2));
		_addEntry("ch", new String(new int[] {0x1f1e8,0x1f1ed}, 0, 2));
		_addEntry("chains", new String(new int[] {0x26d3}, 0, 1));
		_addEntry("champagne", new String(new int[] {0x1f37e}, 0, 1));
		_addEntry("champagne_glass", new String(new int[] {0x1f942}, 0, 1));
		_addEntry("chart", new String(new int[] {0x1f4b9}, 0, 1));
		_addEntry("chart_with_downwards_trend", new String(new int[] {0x1f4c9}, 0, 1));
		_addEntry("chart_with_upwards_trend", new String(new int[] {0x1f4c8}, 0, 1));
		_addEntry("checkered_flag", new String(new int[] {0x1f3c1}, 0, 1));
		_addEntry("cheese", new String(new int[] {0x1f9c0}, 0, 1));
		_addEntry("cheese_wedge", new String(new int[] {0x1f9c0}, 0, 1));
		_addEntry("cherries", new String(new int[] {0x1f352}, 0, 1));
		_addEntry("cherry_blossom", new String(new int[] {0x1f338}, 0, 1));
		_addEntry("chestnut", new String(new int[] {0x1f330}, 0, 1));
		_addEntry("chicken", new String(new int[] {0x1f414}, 0, 1));
		_addEntry("children_crossing", new String(new int[] {0x1f6b8}, 0, 1));
		_addEntry("chile", new String(new int[] {0x1f1e8,0x1f1f1}, 0, 2));
		_addEntry("chipmunk", new String(new int[] {0x1f43f}, 0, 1));
		_addEntry("chocolate_bar", new String(new int[] {0x1f36b}, 0, 1));
		_addEntry("christmas_tree", new String(new int[] {0x1f384}, 0, 1));
		_addEntry("church", new String(new int[] {0x26ea}, 0, 1));
		_addEntry("ci", new String(new int[] {0x1f1e8,0x1f1ee}, 0, 2));
		_addEntry("cinema", new String(new int[] {0x1f3a6}, 0, 1));
		_addEntry("circus_tent", new String(new int[] {0x1f3aa}, 0, 1));
		_addEntry("city_dusk", new String(new int[] {0x1f306}, 0, 1));
		_addEntry("city_sunrise", new String(new int[] {0x1f307}, 0, 1));
		_addEntry("city_sunset", new String(new int[] {0x1f307}, 0, 1));
		_addEntry("cityscape", new String(new int[] {0x1f3d9}, 0, 1));
		_addEntry("ck", new String(new int[] {0x1f1e8,0x1f1f0}, 0, 2));
		_addEntry("cl", new String(new int[] {0x1f191}, 0, 1));
		_addEntry("clap", new String(new int[] {0x1f44f}, 0, 1));
		_addEntry("clap_tone1", new String(new int[] {0x1f44f,0x1f3fb}, 0, 2));
		_addEntry("clap_tone2", new String(new int[] {0x1f44f,0x1f3fc}, 0, 2));
		_addEntry("clap_tone3", new String(new int[] {0x1f44f,0x1f3fd}, 0, 2));
		_addEntry("clap_tone4", new String(new int[] {0x1f44f,0x1f3fe}, 0, 2));
		_addEntry("clap_tone5", new String(new int[] {0x1f44f,0x1f3ff}, 0, 2));
		_addEntry("clapper", new String(new int[] {0x1f3ac}, 0, 1));
		_addEntry("classical_building", new String(new int[] {0x1f3db}, 0, 1));
		_addEntry("clinking_glass", new String(new int[] {0x1f942}, 0, 1));
		_addEntry("clipboard", new String(new int[] {0x1f4cb}, 0, 1));
		_addEntry("clock", new String(new int[] {0x1f570}, 0, 1));
		_addEntry("clock1", new String(new int[] {0x1f550}, 0, 1));
		_addEntry("clock10", new String(new int[] {0x1f559}, 0, 1));
		_addEntry("clock1030", new String(new int[] {0x1f565}, 0, 1));
		_addEntry("clock11", new String(new int[] {0x1f55a}, 0, 1));
		_addEntry("clock1130", new String(new int[] {0x1f566}, 0, 1));
		_addEntry("clock12", new String(new int[] {0x1f55b}, 0, 1));
		_addEntry("clock1230", new String(new int[] {0x1f567}, 0, 1));
		_addEntry("clock130", new String(new int[] {0x1f55c}, 0, 1));
		_addEntry("clock2", new String(new int[] {0x1f551}, 0, 1));
		_addEntry("clock230", new String(new int[] {0x1f55d}, 0, 1));
		_addEntry("clock3", new String(new int[] {0x1f552}, 0, 1));
		_addEntry("clock330", new String(new int[] {0x1f55e}, 0, 1));
		_addEntry("clock4", new String(new int[] {0x1f553}, 0, 1));
		_addEntry("clock430", new String(new int[] {0x1f55f}, 0, 1));
		_addEntry("clock5", new String(new int[] {0x1f554}, 0, 1));
		_addEntry("clock530", new String(new int[] {0x1f560}, 0, 1));
		_addEntry("clock6", new String(new int[] {0x1f555}, 0, 1));
		_addEntry("clock630", new String(new int[] {0x1f561}, 0, 1));
		_addEntry("clock7", new String(new int[] {0x1f556}, 0, 1));
		_addEntry("clock730", new String(new int[] {0x1f562}, 0, 1));
		_addEntry("clock8", new String(new int[] {0x1f557}, 0, 1));
		_addEntry("clock830", new String(new int[] {0x1f563}, 0, 1));
		_addEntry("clock9", new String(new int[] {0x1f558}, 0, 1));
		_addEntry("clock930", new String(new int[] {0x1f564}, 0, 1));
		_addEntry("closed_book", new String(new int[] {0x1f4d5}, 0, 1));
		_addEntry("closed_lock_with_key", new String(new int[] {0x1f510}, 0, 1));
		_addEntry("closed_umbrella", new String(new int[] {0x1f302}, 0, 1));
		_addEntry("cloud", new String(new int[] {0x2601}, 0, 1));
		_addEntry("cloud_lightning", new String(new int[] {0x1f329}, 0, 1));
		_addEntry("cloud_rain", new String(new int[] {0x1f327}, 0, 1));
		_addEntry("cloud_snow", new String(new int[] {0x1f328}, 0, 1));
		_addEntry("cloud_tornado", new String(new int[] {0x1f32a}, 0, 1));
		_addEntry("cloud_with_lightning", new String(new int[] {0x1f329}, 0, 1));
		_addEntry("cloud_with_rain", new String(new int[] {0x1f327}, 0, 1));
		_addEntry("cloud_with_snow", new String(new int[] {0x1f328}, 0, 1));
		_addEntry("cloud_with_tornado", new String(new int[] {0x1f32a}, 0, 1));
		_addEntry("clown", new String(new int[] {0x1f921}, 0, 1));
		_addEntry("clown_face", new String(new int[] {0x1f921}, 0, 1));
		_addEntry("clubs", new String(new int[] {0x2663}, 0, 1));
		_addEntry("cm", new String(new int[] {0x1f1e8,0x1f1f2}, 0, 2));
		_addEntry("cn", new String(new int[] {0x1f1e8,0x1f1f3}, 0, 2));
		_addEntry("co", new String(new int[] {0x1f1e8,0x1f1f4}, 0, 2));
		_addEntry("cocktail", new String(new int[] {0x1f378}, 0, 1));
		_addEntry("coffee", new String(new int[] {0x2615}, 0, 1));
	}
	private static void init5(){
		_addEntry("coffin", new String(new int[] {0x26b0}, 0, 1));
		_addEntry("cold_sweat", new String(new int[] {0x1f630}, 0, 1));
		_addEntry("comet", new String(new int[] {0x2604}, 0, 1));
		_addEntry("compression", new String(new int[] {0x1f5dc}, 0, 1));
		_addEntry("computer", new String(new int[] {0x1f4bb}, 0, 1));
		_addEntry("confetti_ball", new String(new int[] {0x1f38a}, 0, 1));
		_addEntry("confounded", new String(new int[] {0x1f616}, 0, 1));
		_addEntry("confused", new String(new int[] {0x1f615}, 0, 1));
		_addEntry("congo", new String(new int[] {0x1f1e8,0x1f1e9}, 0, 2));
		_addEntry("congratulations", new String(new int[] {0x3297}, 0, 1));
		_addEntry("construction", new String(new int[] {0x1f6a7}, 0, 1));
		_addEntry("construction_site", new String(new int[] {0x1f3d7}, 0, 1));
		_addEntry("construction_worker", new String(new int[] {0x1f477}, 0, 1));
		_addEntry("construction_worker_tone1", new String(new int[] {0x1f477,0x1f3fb}, 0, 2));
		_addEntry("construction_worker_tone2", new String(new int[] {0x1f477,0x1f3fc}, 0, 2));
		_addEntry("construction_worker_tone3", new String(new int[] {0x1f477,0x1f3fd}, 0, 2));
		_addEntry("construction_worker_tone4", new String(new int[] {0x1f477,0x1f3fe}, 0, 2));
		_addEntry("construction_worker_tone5", new String(new int[] {0x1f477,0x1f3ff}, 0, 2));
		_addEntry("control_knobs", new String(new int[] {0x1f39b}, 0, 1));
		_addEntry("convenience_store", new String(new int[] {0x1f3ea}, 0, 1));
		_addEntry("cookie", new String(new int[] {0x1f36a}, 0, 1));
		_addEntry("cooking", new String(new int[] {0x1f373}, 0, 1));
		_addEntry("cool", new String(new int[] {0x1f192}, 0, 1));
		_addEntry("cop", new String(new int[] {0x1f46e}, 0, 1));
		_addEntry("cop_tone1", new String(new int[] {0x1f46e,0x1f3fb}, 0, 2));
		_addEntry("cop_tone2", new String(new int[] {0x1f46e,0x1f3fc}, 0, 2));
		_addEntry("cop_tone3", new String(new int[] {0x1f46e,0x1f3fd}, 0, 2));
		_addEntry("cop_tone4", new String(new int[] {0x1f46e,0x1f3fe}, 0, 2));
		_addEntry("cop_tone5", new String(new int[] {0x1f46e,0x1f3ff}, 0, 2));
		_addEntry("copyright", new String(new int[] {0x00a9}, 0, 1));
		_addEntry("corn", new String(new int[] {0x1f33d}, 0, 1));
		_addEntry("couch", new String(new int[] {0x1f6cb}, 0, 1));
		_addEntry("couch_and_lamp", new String(new int[] {0x1f6cb}, 0, 1));
		_addEntry("couple", new String(new int[] {0x1f46b}, 0, 1));
		_addEntry("couple_mm", new String(new int[] {0x1f468,0x2764,0x1f468}, 0, 3));
		_addEntry("couple_with_heart", new String(new int[] {0x1f491}, 0, 1));
		_addEntry("couple_with_heart_mm", new String(new int[] {0x1f468,0x2764,0x1f468}, 0, 3));
		_addEntry("couple_with_heart_woman_man", new String(new int[] {0x1f469,0x2764,0x1f468}, 0, 3));
		_addEntry("couple_with_heart_ww", new String(new int[] {0x1f469,0x2764,0x1f469}, 0, 3));
		_addEntry("couple_ww", new String(new int[] {0x1f469,0x2764,0x1f469}, 0, 3));
		_addEntry("couplekiss", new String(new int[] {0x1f48f}, 0, 1));
		_addEntry("couplekiss_mm", new String(new int[] {0x1f468,0x2764,0x1f48b,0x1f468}, 0, 4));
		_addEntry("couplekiss_ww", new String(new int[] {0x1f469,0x2764,0x1f48b,0x1f469}, 0, 4));
		_addEntry("cow", new String(new int[] {0x1f42e}, 0, 1));
		_addEntry("cow2", new String(new int[] {0x1f404}, 0, 1));
		_addEntry("cowboy", new String(new int[] {0x1f920}, 0, 1));
		_addEntry("cp", new String(new int[] {0x1f1e8,0x1f1f5}, 0, 2));
		_addEntry("cr", new String(new int[] {0x1f1e8,0x1f1f7}, 0, 2));
		_addEntry("crab", new String(new int[] {0x1f980}, 0, 1));
		_addEntry("crayon", new String(new int[] {0x1f58d}, 0, 1));
		_addEntry("credit_card", new String(new int[] {0x1f4b3}, 0, 1));
		_addEntry("crescent_moon", new String(new int[] {0x1f319}, 0, 1));
		_addEntry("cricket", new String(new int[] {0x1f3cf}, 0, 1));
		_addEntry("cricket_bat_ball", new String(new int[] {0x1f3cf}, 0, 1));
		_addEntry("crocodile", new String(new int[] {0x1f40a}, 0, 1));
		_addEntry("croissant", new String(new int[] {0x1f950}, 0, 1));
		_addEntry("cross", new String(new int[] {0x271d}, 0, 1));
		_addEntry("crossed_flags", new String(new int[] {0x1f38c}, 0, 1));
		_addEntry("crossed_swords", new String(new int[] {0x2694}, 0, 1));
		_addEntry("crown", new String(new int[] {0x1f451}, 0, 1));
		_addEntry("cruise_ship", new String(new int[] {0x1f6f3}, 0, 1));
		_addEntry("cry", new String(new int[] {0x1f622}, 0, 1));
		_addEntry("crying_cat_face", new String(new int[] {0x1f63f}, 0, 1));
		_addEntry("crystal_ball", new String(new int[] {0x1f52e}, 0, 1));
		_addEntry("cu", new String(new int[] {0x1f1e8,0x1f1fa}, 0, 2));
		_addEntry("cucumber", new String(new int[] {0x1f952}, 0, 1));
		_addEntry("cupid", new String(new int[] {0x1f498}, 0, 1));
		_addEntry("curly_loop", new String(new int[] {0x27b0}, 0, 1));
		_addEntry("currency_exchange", new String(new int[] {0x1f4b1}, 0, 1));
		_addEntry("curry", new String(new int[] {0x1f35b}, 0, 1));
		_addEntry("custard", new String(new int[] {0x1f36e}, 0, 1));
		_addEntry("customs", new String(new int[] {0x1f6c3}, 0, 1));
		_addEntry("cv", new String(new int[] {0x1f1e8,0x1f1fb}, 0, 2));
		_addEntry("cw", new String(new int[] {0x1f1e8,0x1f1fc}, 0, 2));
		_addEntry("cx", new String(new int[] {0x1f1e8,0x1f1fd}, 0, 2));
		_addEntry("cy", new String(new int[] {0x1f1e8,0x1f1fe}, 0, 2));
		_addEntry("cyclone", new String(new int[] {0x1f300}, 0, 1));
		_addEntry("cz", new String(new int[] {0x1f1e8,0x1f1ff}, 0, 2));
		_addEntry("dagger", new String(new int[] {0x1f5e1}, 0, 1));
		_addEntry("dagger_knife", new String(new int[] {0x1f5e1}, 0, 1));
		_addEntry("dancer", new String(new int[] {0x1f483}, 0, 1));
		_addEntry("dancer_tone1", new String(new int[] {0x1f483,0x1f3fb}, 0, 2));
		_addEntry("dancer_tone2", new String(new int[] {0x1f483,0x1f3fc}, 0, 2));
		_addEntry("dancer_tone3", new String(new int[] {0x1f483,0x1f3fd}, 0, 2));
		_addEntry("dancer_tone4", new String(new int[] {0x1f483,0x1f3fe}, 0, 2));
		_addEntry("dancer_tone5", new String(new int[] {0x1f483,0x1f3ff}, 0, 2));
		_addEntry("dancers", new String(new int[] {0x1f46f}, 0, 1));
		_addEntry("dango", new String(new int[] {0x1f361}, 0, 1));
		_addEntry("dark_sunglasses", new String(new int[] {0x1f576}, 0, 1));
		_addEntry("dart", new String(new int[] {0x1f3af}, 0, 1));
		_addEntry("dash", new String(new int[] {0x1f4a8}, 0, 1));
		_addEntry("date", new String(new int[] {0x1f4c5}, 0, 1));
		_addEntry("de", new String(new int[] {0x1f1e9,0x1f1ea}, 0, 2));
		_addEntry("deciduous_tree", new String(new int[] {0x1f333}, 0, 1));
		_addEntry("deer", new String(new int[] {0x1f98c}, 0, 1));
		_addEntry("department_store", new String(new int[] {0x1f3ec}, 0, 1));
		_addEntry("derelict_house_building", new String(new int[] {0x1f3da}, 0, 1));
		_addEntry("desert", new String(new int[] {0x1f3dc}, 0, 1));
		_addEntry("desert_island", new String(new int[] {0x1f3dd}, 0, 1));
		_addEntry("desktop", new String(new int[] {0x1f5a5}, 0, 1));
		_addEntry("desktop_computer", new String(new int[] {0x1f5a5}, 0, 1));
	}
	private static void init6(){
		_addEntry("dg", new String(new int[] {0x1f1e9,0x1f1ec}, 0, 2));
		_addEntry("diamond_shape_with_a_dot_inside", new String(new int[] {0x1f4a0}, 0, 1));
		_addEntry("diamonds", new String(new int[] {0x2666}, 0, 1));
		_addEntry("digit_eight", new String(new int[] {0x0038}, 0, 1));
		_addEntry("digit_five", new String(new int[] {0x0035}, 0, 1));
		_addEntry("digit_four", new String(new int[] {0x0034}, 0, 1));
		_addEntry("digit_nine", new String(new int[] {0x0039}, 0, 1));
		_addEntry("digit_one", new String(new int[] {0x0031}, 0, 1));
		_addEntry("digit_seven", new String(new int[] {0x0037}, 0, 1));
		_addEntry("digit_six", new String(new int[] {0x0036}, 0, 1));
		_addEntry("digit_three", new String(new int[] {0x0033}, 0, 1));
		_addEntry("digit_two", new String(new int[] {0x0032}, 0, 1));
		_addEntry("digit_zero", new String(new int[] {0x0030}, 0, 1));
		_addEntry("disappointed", new String(new int[] {0x1f61e}, 0, 1));
		_addEntry("disappointed_relieved", new String(new int[] {0x1f625}, 0, 1));
		_addEntry("dividers", new String(new int[] {0x1f5c2}, 0, 1));
		_addEntry("dizzy", new String(new int[] {0x1f4ab}, 0, 1));
		_addEntry("dizzy_face", new String(new int[] {0x1f635}, 0, 1));
		_addEntry("dj", new String(new int[] {0x1f1e9,0x1f1ef}, 0, 2));
		_addEntry("dk", new String(new int[] {0x1f1e9,0x1f1f0}, 0, 2));
		_addEntry("dm", new String(new int[] {0x1f1e9,0x1f1f2}, 0, 2));
		_addEntry("do", new String(new int[] {0x1f1e9,0x1f1f4}, 0, 2));
		_addEntry("do_not_litter", new String(new int[] {0x1f6af}, 0, 1));
		_addEntry("dog", new String(new int[] {0x1f436}, 0, 1));
		_addEntry("dog2", new String(new int[] {0x1f415}, 0, 1));
		_addEntry("dollar", new String(new int[] {0x1f4b5}, 0, 1));
		_addEntry("dolls", new String(new int[] {0x1f38e}, 0, 1));
		_addEntry("dolphin", new String(new int[] {0x1f42c}, 0, 1));
		_addEntry("door", new String(new int[] {0x1f6aa}, 0, 1));
		_addEntry("double_vertical_bar", new String(new int[] {0x23f8}, 0, 1));
		_addEntry("doughnut", new String(new int[] {0x1f369}, 0, 1));
		_addEntry("dove", new String(new int[] {0x1f54a}, 0, 1));
		_addEntry("dove_of_peace", new String(new int[] {0x1f54a}, 0, 1));
		_addEntry("dragon", new String(new int[] {0x1f409}, 0, 1));
		_addEntry("dragon_face", new String(new int[] {0x1f432}, 0, 1));
		_addEntry("dress", new String(new int[] {0x1f457}, 0, 1));
		_addEntry("dromedary_camel", new String(new int[] {0x1f42a}, 0, 1));
		_addEntry("drool", new String(new int[] {0x1f924}, 0, 1));
		_addEntry("drooling_face", new String(new int[] {0x1f924}, 0, 1));
		_addEntry("droplet", new String(new int[] {0x1f4a7}, 0, 1));
		_addEntry("drum", new String(new int[] {0x1f941}, 0, 1));
		_addEntry("drum_with_drumsticks", new String(new int[] {0x1f941}, 0, 1));
		_addEntry("duck", new String(new int[] {0x1f986}, 0, 1));
		_addEntry("dvd", new String(new int[] {0x1f4c0}, 0, 1));
		_addEntry("dz", new String(new int[] {0x1f1e9,0x1f1ff}, 0, 2));
		_addEntry("e-mail", new String(new int[] {0x1f4e7}, 0, 1));
		_addEntry("ea", new String(new int[] {0x1f1ea,0x1f1e6}, 0, 2));
		_addEntry("eagle", new String(new int[] {0x1f985}, 0, 1));
		_addEntry("ear", new String(new int[] {0x1f442}, 0, 1));
		_addEntry("ear_of_rice", new String(new int[] {0x1f33e}, 0, 1));
		_addEntry("ear_tone1", new String(new int[] {0x1f442,0x1f3fb}, 0, 2));
		_addEntry("ear_tone2", new String(new int[] {0x1f442,0x1f3fc}, 0, 2));
		_addEntry("ear_tone3", new String(new int[] {0x1f442,0x1f3fd}, 0, 2));
		_addEntry("ear_tone4", new String(new int[] {0x1f442,0x1f3fe}, 0, 2));
		_addEntry("ear_tone5", new String(new int[] {0x1f442,0x1f3ff}, 0, 2));
		_addEntry("earth_africa", new String(new int[] {0x1f30d}, 0, 1));
		_addEntry("earth_americas", new String(new int[] {0x1f30e}, 0, 1));
		_addEntry("earth_asia", new String(new int[] {0x1f30f}, 0, 1));
		_addEntry("ec", new String(new int[] {0x1f1ea,0x1f1e8}, 0, 2));
		_addEntry("ee", new String(new int[] {0x1f1ea,0x1f1ea}, 0, 2));
		_addEntry("eg", new String(new int[] {0x1f1ea,0x1f1ec}, 0, 2));
		_addEntry("egg", new String(new int[] {0x1f95a}, 0, 1));
		_addEntry("eggplant", new String(new int[] {0x1f346}, 0, 1));
		_addEntry("eh", new String(new int[] {0x1f1ea,0x1f1ed}, 0, 2));
		_addEntry("eight", new String(new int[] {0x0038,0x20e3}, 0, 2));
		_addEntry("eight_pointed_black_star", new String(new int[] {0x2734}, 0, 1));
		_addEntry("eight_spoked_asterisk", new String(new int[] {0x2733}, 0, 1));
		_addEntry("eject", new String(new int[] {0x23cf}, 0, 1));
		_addEntry("eject_symbol", new String(new int[] {0x23cf}, 0, 1));
		_addEntry("electric_plug", new String(new int[] {0x1f50c}, 0, 1));
		_addEntry("elephant", new String(new int[] {0x1f418}, 0, 1));
		_addEntry("email", new String(new int[] {0x1f4e7}, 0, 1));
		_addEntry("end", new String(new int[] {0x1f51a}, 0, 1));
		_addEntry("envelope", new String(new int[] {0x2709}, 0, 1));
		_addEntry("envelope_with_arrow", new String(new int[] {0x1f4e9}, 0, 1));
		_addEntry("er", new String(new int[] {0x1f1ea,0x1f1f7}, 0, 2));
		_addEntry("es", new String(new int[] {0x1f1ea,0x1f1f8}, 0, 2));
		_addEntry("et", new String(new int[] {0x1f1ea,0x1f1f9}, 0, 2));
		_addEntry("eu", new String(new int[] {0x1f1ea,0x1f1fa}, 0, 2));
		_addEntry("euro", new String(new int[] {0x1f4b6}, 0, 1));
		_addEntry("european_castle", new String(new int[] {0x1f3f0}, 0, 1));
		_addEntry("european_post_office", new String(new int[] {0x1f3e4}, 0, 1));
		_addEntry("evergreen_tree", new String(new int[] {0x1f332}, 0, 1));
		_addEntry("exclamation", new String(new int[] {0x2757}, 0, 1));
		_addEntry("expecting_woman", new String(new int[] {0x1f930}, 0, 1));
		_addEntry("expecting_woman_tone1", new String(new int[] {0x1f930,0x1f3fb}, 0, 2));
		_addEntry("expecting_woman_tone2", new String(new int[] {0x1f930,0x1f3fc}, 0, 2));
		_addEntry("expecting_woman_tone3", new String(new int[] {0x1f930,0x1f3fd}, 0, 2));
		_addEntry("expecting_woman_tone4", new String(new int[] {0x1f930,0x1f3fe}, 0, 2));
		_addEntry("expecting_woman_tone5", new String(new int[] {0x1f930,0x1f3ff}, 0, 2));
		_addEntry("expressionless", new String(new int[] {0x1f611}, 0, 1));
		_addEntry("eye", new String(new int[] {0x1f441}, 0, 1));
		_addEntry("eye_in_speech_bubble", new String(new int[] {0x1f441,0x1f5e8}, 0, 2));
		_addEntry("eyeglasses", new String(new int[] {0x1f453}, 0, 1));
		_addEntry("eyes", new String(new int[] {0x1f440}, 0, 1));
		_addEntry("face_palm", new String(new int[] {0x1f926}, 0, 1));
		_addEntry("face_palm_tone1", new String(new int[] {0x1f926,0x1f3fb}, 0, 2));
		_addEntry("face_palm_tone2", new String(new int[] {0x1f926,0x1f3fc}, 0, 2));
		_addEntry("face_palm_tone3", new String(new int[] {0x1f926,0x1f3fd}, 0, 2));
		_addEntry("face_palm_tone4", new String(new int[] {0x1f926,0x1f3fe}, 0, 2));
		_addEntry("face_palm_tone5", new String(new int[] {0x1f926,0x1f3ff}, 0, 2));
	}
	private static void init7(){
		_addEntry("face_with_cowboy_hat", new String(new int[] {0x1f920}, 0, 1));
		_addEntry("face_with_head_bandage", new String(new int[] {0x1f915}, 0, 1));
		_addEntry("face_with_rolling_eyes", new String(new int[] {0x1f644}, 0, 1));
		_addEntry("face_with_thermometer", new String(new int[] {0x1f912}, 0, 1));
		_addEntry("facepalm", new String(new int[] {0x1f926}, 0, 1));
		_addEntry("facepalm_tone1", new String(new int[] {0x1f926,0x1f3fb}, 0, 2));
		_addEntry("facepalm_tone2", new String(new int[] {0x1f926,0x1f3fc}, 0, 2));
		_addEntry("facepalm_tone3", new String(new int[] {0x1f926,0x1f3fd}, 0, 2));
		_addEntry("facepalm_tone4", new String(new int[] {0x1f926,0x1f3fe}, 0, 2));
		_addEntry("facepalm_tone5", new String(new int[] {0x1f926,0x1f3ff}, 0, 2));
		_addEntry("factory", new String(new int[] {0x1f3ed}, 0, 1));
		_addEntry("fallen_leaf", new String(new int[] {0x1f342}, 0, 1));
		_addEntry("family", new String(new int[] {0x1f46a}, 0, 1));
		_addEntry("family_man_boy", new String(new int[] {0x1f468,0x1f466}, 0, 2));
		_addEntry("family_man_boy_boy", new String(new int[] {0x1f468,0x1f466,0x1f466}, 0, 3));
		_addEntry("family_man_girl", new String(new int[] {0x1f468,0x1f467}, 0, 2));
		_addEntry("family_man_girl_boy", new String(new int[] {0x1f468,0x1f467,0x1f466}, 0, 3));
		_addEntry("family_man_girl_girl", new String(new int[] {0x1f468,0x1f467,0x1f467}, 0, 3));
		_addEntry("family_man_woman_boy", new String(new int[] {0x1f468,0x1f469,0x1f466}, 0, 3));
		_addEntry("family_mmb", new String(new int[] {0x1f468,0x1f468,0x1f466}, 0, 3));
		_addEntry("family_mmbb", new String(new int[] {0x1f468,0x1f468,0x1f466,0x1f466}, 0, 4));
		_addEntry("family_mmg", new String(new int[] {0x1f468,0x1f468,0x1f467}, 0, 3));
		_addEntry("family_mmgb", new String(new int[] {0x1f468,0x1f468,0x1f467,0x1f466}, 0, 4));
		_addEntry("family_mmgg", new String(new int[] {0x1f468,0x1f468,0x1f467,0x1f467}, 0, 4));
		_addEntry("family_mwbb", new String(new int[] {0x1f468,0x1f469,0x1f466,0x1f466}, 0, 4));
		_addEntry("family_mwg", new String(new int[] {0x1f468,0x1f469,0x1f467}, 0, 3));
		_addEntry("family_mwgb", new String(new int[] {0x1f468,0x1f469,0x1f467,0x1f466}, 0, 4));
		_addEntry("family_mwgg", new String(new int[] {0x1f468,0x1f469,0x1f467,0x1f467}, 0, 4));
		_addEntry("family_woman_boy", new String(new int[] {0x1f469,0x1f466}, 0, 2));
		_addEntry("family_woman_boy_boy", new String(new int[] {0x1f469,0x1f466,0x1f466}, 0, 3));
		_addEntry("family_woman_girl", new String(new int[] {0x1f469,0x1f467}, 0, 2));
		_addEntry("family_woman_girl_boy", new String(new int[] {0x1f469,0x1f467,0x1f466}, 0, 3));
		_addEntry("family_woman_girl_girl", new String(new int[] {0x1f469,0x1f467,0x1f467}, 0, 3));
		_addEntry("family_wwb", new String(new int[] {0x1f469,0x1f469,0x1f466}, 0, 3));
		_addEntry("family_wwbb", new String(new int[] {0x1f469,0x1f469,0x1f466,0x1f466}, 0, 4));
		_addEntry("family_wwg", new String(new int[] {0x1f469,0x1f469,0x1f467}, 0, 3));
		_addEntry("family_wwgb", new String(new int[] {0x1f469,0x1f469,0x1f467,0x1f466}, 0, 4));
		_addEntry("family_wwgg", new String(new int[] {0x1f469,0x1f469,0x1f467,0x1f467}, 0, 4));
		_addEntry("fast_forward", new String(new int[] {0x23e9}, 0, 1));
		_addEntry("fax", new String(new int[] {0x1f4e0}, 0, 1));
		_addEntry("fearful", new String(new int[] {0x1f628}, 0, 1));
		_addEntry("feet", new String(new int[] {0x1f43e}, 0, 1));
		_addEntry("female_sign", new String(new int[] {0x2640}, 0, 1));
		_addEntry("fencer", new String(new int[] {0x1f93a}, 0, 1));
		_addEntry("fencing", new String(new int[] {0x1f93a}, 0, 1));
		_addEntry("ferris_wheel", new String(new int[] {0x1f3a1}, 0, 1));
		_addEntry("ferry", new String(new int[] {0x26f4}, 0, 1));
		_addEntry("fi", new String(new int[] {0x1f1eb,0x1f1ee}, 0, 2));
		_addEntry("field_hockey", new String(new int[] {0x1f3d1}, 0, 1));
		_addEntry("file_cabinet", new String(new int[] {0x1f5c4}, 0, 1));
		_addEntry("file_folder", new String(new int[] {0x1f4c1}, 0, 1));
		_addEntry("film_frames", new String(new int[] {0x1f39e}, 0, 1));
		_addEntry("film_projector", new String(new int[] {0x1f4fd}, 0, 1));
		_addEntry("fingers_crossed", new String(new int[] {0x1f91e}, 0, 1));
		_addEntry("fingers_crossed_tone1", new String(new int[] {0x1f91e,0x1f3fb}, 0, 2));
		_addEntry("fingers_crossed_tone2", new String(new int[] {0x1f91e,0x1f3fc}, 0, 2));
		_addEntry("fingers_crossed_tone3", new String(new int[] {0x1f91e,0x1f3fd}, 0, 2));
		_addEntry("fingers_crossed_tone4", new String(new int[] {0x1f91e,0x1f3fe}, 0, 2));
		_addEntry("fingers_crossed_tone5", new String(new int[] {0x1f91e,0x1f3ff}, 0, 2));
		_addEntry("fire", new String(new int[] {0x1f525}, 0, 1));
		_addEntry("fire_engine", new String(new int[] {0x1f692}, 0, 1));
		_addEntry("fireworks", new String(new int[] {0x1f386}, 0, 1));
		_addEntry("first_place", new String(new int[] {0x1f947}, 0, 1));
		_addEntry("first_place_medal", new String(new int[] {0x1f947}, 0, 1));
		_addEntry("first_quarter_moon", new String(new int[] {0x1f313}, 0, 1));
		_addEntry("first_quarter_moon_with_face", new String(new int[] {0x1f31b}, 0, 1));
		_addEntry("fish", new String(new int[] {0x1f41f}, 0, 1));
		_addEntry("fish_cake", new String(new int[] {0x1f365}, 0, 1));
		_addEntry("fishing_pole_and_fish", new String(new int[] {0x1f3a3}, 0, 1));
		_addEntry("fist", new String(new int[] {0x270a}, 0, 1));
		_addEntry("fist_tone1", new String(new int[] {0x270a,0x1f3fb}, 0, 2));
		_addEntry("fist_tone2", new String(new int[] {0x270a,0x1f3fc}, 0, 2));
		_addEntry("fist_tone3", new String(new int[] {0x270a,0x1f3fd}, 0, 2));
		_addEntry("fist_tone4", new String(new int[] {0x270a,0x1f3fe}, 0, 2));
		_addEntry("fist_tone5", new String(new int[] {0x270a,0x1f3ff}, 0, 2));
		_addEntry("five", new String(new int[] {0x0035,0x20e3}, 0, 2));
		_addEntry("fj", new String(new int[] {0x1f1eb,0x1f1ef}, 0, 2));
		_addEntry("fk", new String(new int[] {0x1f1eb,0x1f1f0}, 0, 2));
		_addEntry("flag_ac", new String(new int[] {0x1f1e6,0x1f1e8}, 0, 2));
		_addEntry("flag_ad", new String(new int[] {0x1f1e6,0x1f1e9}, 0, 2));
		_addEntry("flag_ae", new String(new int[] {0x1f1e6,0x1f1ea}, 0, 2));
		_addEntry("flag_af", new String(new int[] {0x1f1e6,0x1f1eb}, 0, 2));
		_addEntry("flag_ag", new String(new int[] {0x1f1e6,0x1f1ec}, 0, 2));
		_addEntry("flag_ai", new String(new int[] {0x1f1e6,0x1f1ee}, 0, 2));
		_addEntry("flag_al", new String(new int[] {0x1f1e6,0x1f1f1}, 0, 2));
		_addEntry("flag_am", new String(new int[] {0x1f1e6,0x1f1f2}, 0, 2));
		_addEntry("flag_ao", new String(new int[] {0x1f1e6,0x1f1f4}, 0, 2));
		_addEntry("flag_aq", new String(new int[] {0x1f1e6,0x1f1f6}, 0, 2));
		_addEntry("flag_ar", new String(new int[] {0x1f1e6,0x1f1f7}, 0, 2));
		_addEntry("flag_as", new String(new int[] {0x1f1e6,0x1f1f8}, 0, 2));
		_addEntry("flag_at", new String(new int[] {0x1f1e6,0x1f1f9}, 0, 2));
		_addEntry("flag_au", new String(new int[] {0x1f1e6,0x1f1fa}, 0, 2));
		_addEntry("flag_aw", new String(new int[] {0x1f1e6,0x1f1fc}, 0, 2));
		_addEntry("flag_ax", new String(new int[] {0x1f1e6,0x1f1fd}, 0, 2));
		_addEntry("flag_az", new String(new int[] {0x1f1e6,0x1f1ff}, 0, 2));
		_addEntry("flag_ba", new String(new int[] {0x1f1e7,0x1f1e6}, 0, 2));
		_addEntry("flag_bb", new String(new int[] {0x1f1e7,0x1f1e7}, 0, 2));
		_addEntry("flag_bd", new String(new int[] {0x1f1e7,0x1f1e9}, 0, 2));
		_addEntry("flag_be", new String(new int[] {0x1f1e7,0x1f1ea}, 0, 2));
		_addEntry("flag_bf", new String(new int[] {0x1f1e7,0x1f1eb}, 0, 2));
		_addEntry("flag_bg", new String(new int[] {0x1f1e7,0x1f1ec}, 0, 2));
	}
	private static void init8(){
		_addEntry("flag_bh", new String(new int[] {0x1f1e7,0x1f1ed}, 0, 2));
		_addEntry("flag_bi", new String(new int[] {0x1f1e7,0x1f1ee}, 0, 2));
		_addEntry("flag_bj", new String(new int[] {0x1f1e7,0x1f1ef}, 0, 2));
		_addEntry("flag_bl", new String(new int[] {0x1f1e7,0x1f1f1}, 0, 2));
		_addEntry("flag_black", new String(new int[] {0x1f3f4}, 0, 1));
		_addEntry("flag_bm", new String(new int[] {0x1f1e7,0x1f1f2}, 0, 2));
		_addEntry("flag_bn", new String(new int[] {0x1f1e7,0x1f1f3}, 0, 2));
		_addEntry("flag_bo", new String(new int[] {0x1f1e7,0x1f1f4}, 0, 2));
		_addEntry("flag_bq", new String(new int[] {0x1f1e7,0x1f1f6}, 0, 2));
		_addEntry("flag_br", new String(new int[] {0x1f1e7,0x1f1f7}, 0, 2));
		_addEntry("flag_bs", new String(new int[] {0x1f1e7,0x1f1f8}, 0, 2));
		_addEntry("flag_bt", new String(new int[] {0x1f1e7,0x1f1f9}, 0, 2));
		_addEntry("flag_bv", new String(new int[] {0x1f1e7,0x1f1fb}, 0, 2));
		_addEntry("flag_bw", new String(new int[] {0x1f1e7,0x1f1fc}, 0, 2));
		_addEntry("flag_by", new String(new int[] {0x1f1e7,0x1f1fe}, 0, 2));
		_addEntry("flag_bz", new String(new int[] {0x1f1e7,0x1f1ff}, 0, 2));
		_addEntry("flag_ca", new String(new int[] {0x1f1e8,0x1f1e6}, 0, 2));
		_addEntry("flag_cc", new String(new int[] {0x1f1e8,0x1f1e8}, 0, 2));
		_addEntry("flag_cd", new String(new int[] {0x1f1e8,0x1f1e9}, 0, 2));
		_addEntry("flag_cf", new String(new int[] {0x1f1e8,0x1f1eb}, 0, 2));
		_addEntry("flag_cg", new String(new int[] {0x1f1e8,0x1f1ec}, 0, 2));
		_addEntry("flag_ch", new String(new int[] {0x1f1e8,0x1f1ed}, 0, 2));
		_addEntry("flag_ci", new String(new int[] {0x1f1e8,0x1f1ee}, 0, 2));
		_addEntry("flag_ck", new String(new int[] {0x1f1e8,0x1f1f0}, 0, 2));
		_addEntry("flag_cl", new String(new int[] {0x1f1e8,0x1f1f1}, 0, 2));
		_addEntry("flag_cm", new String(new int[] {0x1f1e8,0x1f1f2}, 0, 2));
		_addEntry("flag_cn", new String(new int[] {0x1f1e8,0x1f1f3}, 0, 2));
		_addEntry("flag_co", new String(new int[] {0x1f1e8,0x1f1f4}, 0, 2));
		_addEntry("flag_cp", new String(new int[] {0x1f1e8,0x1f1f5}, 0, 2));
		_addEntry("flag_cr", new String(new int[] {0x1f1e8,0x1f1f7}, 0, 2));
		_addEntry("flag_cu", new String(new int[] {0x1f1e8,0x1f1fa}, 0, 2));
		_addEntry("flag_cv", new String(new int[] {0x1f1e8,0x1f1fb}, 0, 2));
		_addEntry("flag_cw", new String(new int[] {0x1f1e8,0x1f1fc}, 0, 2));
		_addEntry("flag_cx", new String(new int[] {0x1f1e8,0x1f1fd}, 0, 2));
		_addEntry("flag_cy", new String(new int[] {0x1f1e8,0x1f1fe}, 0, 2));
		_addEntry("flag_cz", new String(new int[] {0x1f1e8,0x1f1ff}, 0, 2));
		_addEntry("flag_de", new String(new int[] {0x1f1e9,0x1f1ea}, 0, 2));
		_addEntry("flag_dg", new String(new int[] {0x1f1e9,0x1f1ec}, 0, 2));
		_addEntry("flag_dj", new String(new int[] {0x1f1e9,0x1f1ef}, 0, 2));
		_addEntry("flag_dk", new String(new int[] {0x1f1e9,0x1f1f0}, 0, 2));
		_addEntry("flag_dm", new String(new int[] {0x1f1e9,0x1f1f2}, 0, 2));
		_addEntry("flag_do", new String(new int[] {0x1f1e9,0x1f1f4}, 0, 2));
		_addEntry("flag_dz", new String(new int[] {0x1f1e9,0x1f1ff}, 0, 2));
		_addEntry("flag_ea", new String(new int[] {0x1f1ea,0x1f1e6}, 0, 2));
		_addEntry("flag_ec", new String(new int[] {0x1f1ea,0x1f1e8}, 0, 2));
		_addEntry("flag_ee", new String(new int[] {0x1f1ea,0x1f1ea}, 0, 2));
		_addEntry("flag_eg", new String(new int[] {0x1f1ea,0x1f1ec}, 0, 2));
		_addEntry("flag_eh", new String(new int[] {0x1f1ea,0x1f1ed}, 0, 2));
		_addEntry("flag_er", new String(new int[] {0x1f1ea,0x1f1f7}, 0, 2));
		_addEntry("flag_es", new String(new int[] {0x1f1ea,0x1f1f8}, 0, 2));
		_addEntry("flag_et", new String(new int[] {0x1f1ea,0x1f1f9}, 0, 2));
		_addEntry("flag_eu", new String(new int[] {0x1f1ea,0x1f1fa}, 0, 2));
		_addEntry("flag_fi", new String(new int[] {0x1f1eb,0x1f1ee}, 0, 2));
		_addEntry("flag_fj", new String(new int[] {0x1f1eb,0x1f1ef}, 0, 2));
		_addEntry("flag_fk", new String(new int[] {0x1f1eb,0x1f1f0}, 0, 2));
		_addEntry("flag_fm", new String(new int[] {0x1f1eb,0x1f1f2}, 0, 2));
		_addEntry("flag_fo", new String(new int[] {0x1f1eb,0x1f1f4}, 0, 2));
		_addEntry("flag_fr", new String(new int[] {0x1f1eb,0x1f1f7}, 0, 2));
		_addEntry("flag_ga", new String(new int[] {0x1f1ec,0x1f1e6}, 0, 2));
		_addEntry("flag_gb", new String(new int[] {0x1f1ec,0x1f1e7}, 0, 2));
		_addEntry("flag_gd", new String(new int[] {0x1f1ec,0x1f1e9}, 0, 2));
		_addEntry("flag_ge", new String(new int[] {0x1f1ec,0x1f1ea}, 0, 2));
		_addEntry("flag_gf", new String(new int[] {0x1f1ec,0x1f1eb}, 0, 2));
		_addEntry("flag_gg", new String(new int[] {0x1f1ec,0x1f1ec}, 0, 2));
		_addEntry("flag_gh", new String(new int[] {0x1f1ec,0x1f1ed}, 0, 2));
		_addEntry("flag_gi", new String(new int[] {0x1f1ec,0x1f1ee}, 0, 2));
		_addEntry("flag_gl", new String(new int[] {0x1f1ec,0x1f1f1}, 0, 2));
		_addEntry("flag_gm", new String(new int[] {0x1f1ec,0x1f1f2}, 0, 2));
		_addEntry("flag_gn", new String(new int[] {0x1f1ec,0x1f1f3}, 0, 2));
		_addEntry("flag_gp", new String(new int[] {0x1f1ec,0x1f1f5}, 0, 2));
		_addEntry("flag_gq", new String(new int[] {0x1f1ec,0x1f1f6}, 0, 2));
		_addEntry("flag_gr", new String(new int[] {0x1f1ec,0x1f1f7}, 0, 2));
		_addEntry("flag_gs", new String(new int[] {0x1f1ec,0x1f1f8}, 0, 2));
		_addEntry("flag_gt", new String(new int[] {0x1f1ec,0x1f1f9}, 0, 2));
		_addEntry("flag_gu", new String(new int[] {0x1f1ec,0x1f1fa}, 0, 2));
		_addEntry("flag_gw", new String(new int[] {0x1f1ec,0x1f1fc}, 0, 2));
		_addEntry("flag_gy", new String(new int[] {0x1f1ec,0x1f1fe}, 0, 2));
		_addEntry("flag_hk", new String(new int[] {0x1f1ed,0x1f1f0}, 0, 2));
		_addEntry("flag_hm", new String(new int[] {0x1f1ed,0x1f1f2}, 0, 2));
		_addEntry("flag_hn", new String(new int[] {0x1f1ed,0x1f1f3}, 0, 2));
		_addEntry("flag_hr", new String(new int[] {0x1f1ed,0x1f1f7}, 0, 2));
		_addEntry("flag_ht", new String(new int[] {0x1f1ed,0x1f1f9}, 0, 2));
		_addEntry("flag_hu", new String(new int[] {0x1f1ed,0x1f1fa}, 0, 2));
		_addEntry("flag_ic", new String(new int[] {0x1f1ee,0x1f1e8}, 0, 2));
		_addEntry("flag_id", new String(new int[] {0x1f1ee,0x1f1e9}, 0, 2));
		_addEntry("flag_ie", new String(new int[] {0x1f1ee,0x1f1ea}, 0, 2));
		_addEntry("flag_il", new String(new int[] {0x1f1ee,0x1f1f1}, 0, 2));
		_addEntry("flag_im", new String(new int[] {0x1f1ee,0x1f1f2}, 0, 2));
		_addEntry("flag_in", new String(new int[] {0x1f1ee,0x1f1f3}, 0, 2));
		_addEntry("flag_io", new String(new int[] {0x1f1ee,0x1f1f4}, 0, 2));
		_addEntry("flag_iq", new String(new int[] {0x1f1ee,0x1f1f6}, 0, 2));
		_addEntry("flag_ir", new String(new int[] {0x1f1ee,0x1f1f7}, 0, 2));
		_addEntry("flag_is", new String(new int[] {0x1f1ee,0x1f1f8}, 0, 2));
		_addEntry("flag_it", new String(new int[] {0x1f1ee,0x1f1f9}, 0, 2));
		_addEntry("flag_je", new String(new int[] {0x1f1ef,0x1f1ea}, 0, 2));
		_addEntry("flag_jm", new String(new int[] {0x1f1ef,0x1f1f2}, 0, 2));
		_addEntry("flag_jo", new String(new int[] {0x1f1ef,0x1f1f4}, 0, 2));
		_addEntry("flag_jp", new String(new int[] {0x1f1ef,0x1f1f5}, 0, 2));
		_addEntry("flag_ke", new String(new int[] {0x1f1f0,0x1f1ea}, 0, 2));
		_addEntry("flag_kg", new String(new int[] {0x1f1f0,0x1f1ec}, 0, 2));
		_addEntry("flag_kh", new String(new int[] {0x1f1f0,0x1f1ed}, 0, 2));
	}
	private static void init9(){
		_addEntry("flag_ki", new String(new int[] {0x1f1f0,0x1f1ee}, 0, 2));
		_addEntry("flag_km", new String(new int[] {0x1f1f0,0x1f1f2}, 0, 2));
		_addEntry("flag_kn", new String(new int[] {0x1f1f0,0x1f1f3}, 0, 2));
		_addEntry("flag_kp", new String(new int[] {0x1f1f0,0x1f1f5}, 0, 2));
		_addEntry("flag_kr", new String(new int[] {0x1f1f0,0x1f1f7}, 0, 2));
		_addEntry("flag_kw", new String(new int[] {0x1f1f0,0x1f1fc}, 0, 2));
		_addEntry("flag_ky", new String(new int[] {0x1f1f0,0x1f1fe}, 0, 2));
		_addEntry("flag_kz", new String(new int[] {0x1f1f0,0x1f1ff}, 0, 2));
		_addEntry("flag_la", new String(new int[] {0x1f1f1,0x1f1e6}, 0, 2));
		_addEntry("flag_lb", new String(new int[] {0x1f1f1,0x1f1e7}, 0, 2));
		_addEntry("flag_lc", new String(new int[] {0x1f1f1,0x1f1e8}, 0, 2));
		_addEntry("flag_li", new String(new int[] {0x1f1f1,0x1f1ee}, 0, 2));
		_addEntry("flag_lk", new String(new int[] {0x1f1f1,0x1f1f0}, 0, 2));
		_addEntry("flag_lr", new String(new int[] {0x1f1f1,0x1f1f7}, 0, 2));
		_addEntry("flag_ls", new String(new int[] {0x1f1f1,0x1f1f8}, 0, 2));
		_addEntry("flag_lt", new String(new int[] {0x1f1f1,0x1f1f9}, 0, 2));
		_addEntry("flag_lu", new String(new int[] {0x1f1f1,0x1f1fa}, 0, 2));
		_addEntry("flag_lv", new String(new int[] {0x1f1f1,0x1f1fb}, 0, 2));
		_addEntry("flag_ly", new String(new int[] {0x1f1f1,0x1f1fe}, 0, 2));
		_addEntry("flag_ma", new String(new int[] {0x1f1f2,0x1f1e6}, 0, 2));
		_addEntry("flag_mc", new String(new int[] {0x1f1f2,0x1f1e8}, 0, 2));
		_addEntry("flag_md", new String(new int[] {0x1f1f2,0x1f1e9}, 0, 2));
		_addEntry("flag_me", new String(new int[] {0x1f1f2,0x1f1ea}, 0, 2));
		_addEntry("flag_mf", new String(new int[] {0x1f1f2,0x1f1eb}, 0, 2));
		_addEntry("flag_mg", new String(new int[] {0x1f1f2,0x1f1ec}, 0, 2));
		_addEntry("flag_mh", new String(new int[] {0x1f1f2,0x1f1ed}, 0, 2));
		_addEntry("flag_mk", new String(new int[] {0x1f1f2,0x1f1f0}, 0, 2));
		_addEntry("flag_ml", new String(new int[] {0x1f1f2,0x1f1f1}, 0, 2));
		_addEntry("flag_mm", new String(new int[] {0x1f1f2,0x1f1f2}, 0, 2));
		_addEntry("flag_mn", new String(new int[] {0x1f1f2,0x1f1f3}, 0, 2));
		_addEntry("flag_mo", new String(new int[] {0x1f1f2,0x1f1f4}, 0, 2));
		_addEntry("flag_mp", new String(new int[] {0x1f1f2,0x1f1f5}, 0, 2));
		_addEntry("flag_mq", new String(new int[] {0x1f1f2,0x1f1f6}, 0, 2));
		_addEntry("flag_mr", new String(new int[] {0x1f1f2,0x1f1f7}, 0, 2));
		_addEntry("flag_ms", new String(new int[] {0x1f1f2,0x1f1f8}, 0, 2));
		_addEntry("flag_mt", new String(new int[] {0x1f1f2,0x1f1f9}, 0, 2));
		_addEntry("flag_mu", new String(new int[] {0x1f1f2,0x1f1fa}, 0, 2));
		_addEntry("flag_mv", new String(new int[] {0x1f1f2,0x1f1fb}, 0, 2));
		_addEntry("flag_mw", new String(new int[] {0x1f1f2,0x1f1fc}, 0, 2));
		_addEntry("flag_mx", new String(new int[] {0x1f1f2,0x1f1fd}, 0, 2));
		_addEntry("flag_my", new String(new int[] {0x1f1f2,0x1f1fe}, 0, 2));
		_addEntry("flag_mz", new String(new int[] {0x1f1f2,0x1f1ff}, 0, 2));
		_addEntry("flag_na", new String(new int[] {0x1f1f3,0x1f1e6}, 0, 2));
		_addEntry("flag_nc", new String(new int[] {0x1f1f3,0x1f1e8}, 0, 2));
		_addEntry("flag_ne", new String(new int[] {0x1f1f3,0x1f1ea}, 0, 2));
		_addEntry("flag_nf", new String(new int[] {0x1f1f3,0x1f1eb}, 0, 2));
		_addEntry("flag_ng", new String(new int[] {0x1f1f3,0x1f1ec}, 0, 2));
		_addEntry("flag_ni", new String(new int[] {0x1f1f3,0x1f1ee}, 0, 2));
		_addEntry("flag_nl", new String(new int[] {0x1f1f3,0x1f1f1}, 0, 2));
		_addEntry("flag_no", new String(new int[] {0x1f1f3,0x1f1f4}, 0, 2));
		_addEntry("flag_np", new String(new int[] {0x1f1f3,0x1f1f5}, 0, 2));
		_addEntry("flag_nr", new String(new int[] {0x1f1f3,0x1f1f7}, 0, 2));
		_addEntry("flag_nu", new String(new int[] {0x1f1f3,0x1f1fa}, 0, 2));
		_addEntry("flag_nz", new String(new int[] {0x1f1f3,0x1f1ff}, 0, 2));
		_addEntry("flag_om", new String(new int[] {0x1f1f4,0x1f1f2}, 0, 2));
		_addEntry("flag_pa", new String(new int[] {0x1f1f5,0x1f1e6}, 0, 2));
		_addEntry("flag_pe", new String(new int[] {0x1f1f5,0x1f1ea}, 0, 2));
		_addEntry("flag_pf", new String(new int[] {0x1f1f5,0x1f1eb}, 0, 2));
		_addEntry("flag_pg", new String(new int[] {0x1f1f5,0x1f1ec}, 0, 2));
		_addEntry("flag_ph", new String(new int[] {0x1f1f5,0x1f1ed}, 0, 2));
		_addEntry("flag_pk", new String(new int[] {0x1f1f5,0x1f1f0}, 0, 2));
		_addEntry("flag_pl", new String(new int[] {0x1f1f5,0x1f1f1}, 0, 2));
		_addEntry("flag_pm", new String(new int[] {0x1f1f5,0x1f1f2}, 0, 2));
		_addEntry("flag_pn", new String(new int[] {0x1f1f5,0x1f1f3}, 0, 2));
		_addEntry("flag_pr", new String(new int[] {0x1f1f5,0x1f1f7}, 0, 2));
		_addEntry("flag_ps", new String(new int[] {0x1f1f5,0x1f1f8}, 0, 2));
		_addEntry("flag_pt", new String(new int[] {0x1f1f5,0x1f1f9}, 0, 2));
		_addEntry("flag_pw", new String(new int[] {0x1f1f5,0x1f1fc}, 0, 2));
		_addEntry("flag_py", new String(new int[] {0x1f1f5,0x1f1fe}, 0, 2));
		_addEntry("flag_qa", new String(new int[] {0x1f1f6,0x1f1e6}, 0, 2));
		_addEntry("flag_re", new String(new int[] {0x1f1f7,0x1f1ea}, 0, 2));
		_addEntry("flag_ro", new String(new int[] {0x1f1f7,0x1f1f4}, 0, 2));
		_addEntry("flag_rs", new String(new int[] {0x1f1f7,0x1f1f8}, 0, 2));
		_addEntry("flag_ru", new String(new int[] {0x1f1f7,0x1f1fa}, 0, 2));
		_addEntry("flag_rw", new String(new int[] {0x1f1f7,0x1f1fc}, 0, 2));
		_addEntry("flag_sa", new String(new int[] {0x1f1f8,0x1f1e6}, 0, 2));
		_addEntry("flag_sb", new String(new int[] {0x1f1f8,0x1f1e7}, 0, 2));
		_addEntry("flag_sc", new String(new int[] {0x1f1f8,0x1f1e8}, 0, 2));
		_addEntry("flag_sd", new String(new int[] {0x1f1f8,0x1f1e9}, 0, 2));
		_addEntry("flag_se", new String(new int[] {0x1f1f8,0x1f1ea}, 0, 2));
		_addEntry("flag_sg", new String(new int[] {0x1f1f8,0x1f1ec}, 0, 2));
		_addEntry("flag_sh", new String(new int[] {0x1f1f8,0x1f1ed}, 0, 2));
		_addEntry("flag_si", new String(new int[] {0x1f1f8,0x1f1ee}, 0, 2));
		_addEntry("flag_sj", new String(new int[] {0x1f1f8,0x1f1ef}, 0, 2));
		_addEntry("flag_sk", new String(new int[] {0x1f1f8,0x1f1f0}, 0, 2));
		_addEntry("flag_sl", new String(new int[] {0x1f1f8,0x1f1f1}, 0, 2));
		_addEntry("flag_sm", new String(new int[] {0x1f1f8,0x1f1f2}, 0, 2));
		_addEntry("flag_sn", new String(new int[] {0x1f1f8,0x1f1f3}, 0, 2));
		_addEntry("flag_so", new String(new int[] {0x1f1f8,0x1f1f4}, 0, 2));
		_addEntry("flag_sr", new String(new int[] {0x1f1f8,0x1f1f7}, 0, 2));
		_addEntry("flag_ss", new String(new int[] {0x1f1f8,0x1f1f8}, 0, 2));
		_addEntry("flag_st", new String(new int[] {0x1f1f8,0x1f1f9}, 0, 2));
		_addEntry("flag_sv", new String(new int[] {0x1f1f8,0x1f1fb}, 0, 2));
		_addEntry("flag_sx", new String(new int[] {0x1f1f8,0x1f1fd}, 0, 2));
		_addEntry("flag_sy", new String(new int[] {0x1f1f8,0x1f1fe}, 0, 2));
		_addEntry("flag_sz", new String(new int[] {0x1f1f8,0x1f1ff}, 0, 2));
		_addEntry("flag_ta", new String(new int[] {0x1f1f9,0x1f1e6}, 0, 2));
		_addEntry("flag_tc", new String(new int[] {0x1f1f9,0x1f1e8}, 0, 2));
		_addEntry("flag_td", new String(new int[] {0x1f1f9,0x1f1e9}, 0, 2));
		_addEntry("flag_tf", new String(new int[] {0x1f1f9,0x1f1eb}, 0, 2));
		_addEntry("flag_tg", new String(new int[] {0x1f1f9,0x1f1ec}, 0, 2));
	}
	private static void init10(){
		_addEntry("flag_th", new String(new int[] {0x1f1f9,0x1f1ed}, 0, 2));
		_addEntry("flag_tj", new String(new int[] {0x1f1f9,0x1f1ef}, 0, 2));
		_addEntry("flag_tk", new String(new int[] {0x1f1f9,0x1f1f0}, 0, 2));
		_addEntry("flag_tl", new String(new int[] {0x1f1f9,0x1f1f1}, 0, 2));
		_addEntry("flag_tm", new String(new int[] {0x1f1f9,0x1f1f2}, 0, 2));
		_addEntry("flag_tn", new String(new int[] {0x1f1f9,0x1f1f3}, 0, 2));
		_addEntry("flag_to", new String(new int[] {0x1f1f9,0x1f1f4}, 0, 2));
		_addEntry("flag_tr", new String(new int[] {0x1f1f9,0x1f1f7}, 0, 2));
		_addEntry("flag_tt", new String(new int[] {0x1f1f9,0x1f1f9}, 0, 2));
		_addEntry("flag_tv", new String(new int[] {0x1f1f9,0x1f1fb}, 0, 2));
		_addEntry("flag_tw", new String(new int[] {0x1f1f9,0x1f1fc}, 0, 2));
		_addEntry("flag_tz", new String(new int[] {0x1f1f9,0x1f1ff}, 0, 2));
		_addEntry("flag_ua", new String(new int[] {0x1f1fa,0x1f1e6}, 0, 2));
		_addEntry("flag_ug", new String(new int[] {0x1f1fa,0x1f1ec}, 0, 2));
		_addEntry("flag_um", new String(new int[] {0x1f1fa,0x1f1f2}, 0, 2));
		_addEntry("flag_us", new String(new int[] {0x1f1fa,0x1f1f8}, 0, 2));
		_addEntry("flag_uy", new String(new int[] {0x1f1fa,0x1f1fe}, 0, 2));
		_addEntry("flag_uz", new String(new int[] {0x1f1fa,0x1f1ff}, 0, 2));
		_addEntry("flag_va", new String(new int[] {0x1f1fb,0x1f1e6}, 0, 2));
		_addEntry("flag_vc", new String(new int[] {0x1f1fb,0x1f1e8}, 0, 2));
		_addEntry("flag_ve", new String(new int[] {0x1f1fb,0x1f1ea}, 0, 2));
		_addEntry("flag_vg", new String(new int[] {0x1f1fb,0x1f1ec}, 0, 2));
		_addEntry("flag_vi", new String(new int[] {0x1f1fb,0x1f1ee}, 0, 2));
		_addEntry("flag_vn", new String(new int[] {0x1f1fb,0x1f1f3}, 0, 2));
		_addEntry("flag_vu", new String(new int[] {0x1f1fb,0x1f1fa}, 0, 2));
		_addEntry("flag_wf", new String(new int[] {0x1f1fc,0x1f1eb}, 0, 2));
		_addEntry("flag_white", new String(new int[] {0x1f3f3}, 0, 1));
		_addEntry("flag_ws", new String(new int[] {0x1f1fc,0x1f1f8}, 0, 2));
		_addEntry("flag_xk", new String(new int[] {0x1f1fd,0x1f1f0}, 0, 2));
		_addEntry("flag_ye", new String(new int[] {0x1f1fe,0x1f1ea}, 0, 2));
		_addEntry("flag_yt", new String(new int[] {0x1f1fe,0x1f1f9}, 0, 2));
		_addEntry("flag_za", new String(new int[] {0x1f1ff,0x1f1e6}, 0, 2));
		_addEntry("flag_zm", new String(new int[] {0x1f1ff,0x1f1f2}, 0, 2));
		_addEntry("flag_zw", new String(new int[] {0x1f1ff,0x1f1fc}, 0, 2));
		_addEntry("flags", new String(new int[] {0x1f38f}, 0, 1));
		_addEntry("flame", new String(new int[] {0x1f525}, 0, 1));
		_addEntry("flan", new String(new int[] {0x1f36e}, 0, 1));
		_addEntry("flashlight", new String(new int[] {0x1f526}, 0, 1));
		_addEntry("fleur-de-lis", new String(new int[] {0x269c}, 0, 1));
		_addEntry("floppy_disk", new String(new int[] {0x1f4be}, 0, 1));
		_addEntry("flower_playing_cards", new String(new int[] {0x1f3b4}, 0, 1));
		_addEntry("flushed", new String(new int[] {0x1f633}, 0, 1));
		_addEntry("fm", new String(new int[] {0x1f1eb,0x1f1f2}, 0, 2));
		_addEntry("fo", new String(new int[] {0x1f1eb,0x1f1f4}, 0, 2));
		_addEntry("fog", new String(new int[] {0x1f32b}, 0, 1));
		_addEntry("foggy", new String(new int[] {0x1f301}, 0, 1));
		_addEntry("football", new String(new int[] {0x1f3c8}, 0, 1));
		_addEntry("footprints", new String(new int[] {0x1f463}, 0, 1));
		_addEntry("fork_and_knife", new String(new int[] {0x1f374}, 0, 1));
		_addEntry("fork_and_knife_with_plate", new String(new int[] {0x1f37d}, 0, 1));
		_addEntry("fork_knife_plate", new String(new int[] {0x1f37d}, 0, 1));
		_addEntry("fountain", new String(new int[] {0x26f2}, 0, 1));
		_addEntry("four", new String(new int[] {0x0034,0x20e3}, 0, 2));
		_addEntry("four_leaf_clover", new String(new int[] {0x1f340}, 0, 1));
		_addEntry("fox", new String(new int[] {0x1f98a}, 0, 1));
		_addEntry("fox_face", new String(new int[] {0x1f98a}, 0, 1));
		_addEntry("fr", new String(new int[] {0x1f1eb,0x1f1f7}, 0, 2));
		_addEntry("frame_photo", new String(new int[] {0x1f5bc}, 0, 1));
		_addEntry("frame_with_picture", new String(new int[] {0x1f5bc}, 0, 1));
		_addEntry("free", new String(new int[] {0x1f193}, 0, 1));
		_addEntry("french_bread", new String(new int[] {0x1f956}, 0, 1));
		_addEntry("fried_shrimp", new String(new int[] {0x1f364}, 0, 1));
		_addEntry("fries", new String(new int[] {0x1f35f}, 0, 1));
		_addEntry("frog", new String(new int[] {0x1f438}, 0, 1));
		_addEntry("frowning", new String(new int[] {0x1f626}, 0, 1));
		_addEntry("frowning2", new String(new int[] {0x2639}, 0, 1));
		_addEntry("fuelpump", new String(new int[] {0x26fd}, 0, 1));
		_addEntry("full_moon", new String(new int[] {0x1f315}, 0, 1));
		_addEntry("full_moon_with_face", new String(new int[] {0x1f31d}, 0, 1));
		_addEntry("funeral_urn", new String(new int[] {0x26b1}, 0, 1));
		_addEntry("ga", new String(new int[] {0x1f1ec,0x1f1e6}, 0, 2));
		_addEntry("game_die", new String(new int[] {0x1f3b2}, 0, 1));
		_addEntry("gay_pride_flag", new String(new int[] {0x1f3f3,0x1f308}, 0, 2));
		_addEntry("gb", new String(new int[] {0x1f1ec,0x1f1e7}, 0, 2));
		_addEntry("gd", new String(new int[] {0x1f1ec,0x1f1e9}, 0, 2));
		_addEntry("ge", new String(new int[] {0x1f1ec,0x1f1ea}, 0, 2));
		_addEntry("gear", new String(new int[] {0x2699}, 0, 1));
		_addEntry("gem", new String(new int[] {0x1f48e}, 0, 1));
		_addEntry("gemini", new String(new int[] {0x264a}, 0, 1));
		_addEntry("gf", new String(new int[] {0x1f1ec,0x1f1eb}, 0, 2));
		_addEntry("gg", new String(new int[] {0x1f1ec,0x1f1ec}, 0, 2));
		_addEntry("gh", new String(new int[] {0x1f1ec,0x1f1ed}, 0, 2));
		_addEntry("ghost", new String(new int[] {0x1f47b}, 0, 1));
		_addEntry("gi", new String(new int[] {0x1f1ec,0x1f1ee}, 0, 2));
		_addEntry("gift", new String(new int[] {0x1f381}, 0, 1));
		_addEntry("gift_heart", new String(new int[] {0x1f49d}, 0, 1));
		_addEntry("girl", new String(new int[] {0x1f467}, 0, 1));
		_addEntry("girl_tone1", new String(new int[] {0x1f467,0x1f3fb}, 0, 2));
		_addEntry("girl_tone2", new String(new int[] {0x1f467,0x1f3fc}, 0, 2));
		_addEntry("girl_tone3", new String(new int[] {0x1f467,0x1f3fd}, 0, 2));
		_addEntry("girl_tone4", new String(new int[] {0x1f467,0x1f3fe}, 0, 2));
		_addEntry("girl_tone5", new String(new int[] {0x1f467,0x1f3ff}, 0, 2));
		_addEntry("gl", new String(new int[] {0x1f1ec,0x1f1f1}, 0, 2));
		_addEntry("glass_of_milk", new String(new int[] {0x1f95b}, 0, 1));
		_addEntry("globe_with_meridians", new String(new int[] {0x1f310}, 0, 1));
		_addEntry("gm", new String(new int[] {0x1f1ec,0x1f1f2}, 0, 2));
		_addEntry("gn", new String(new int[] {0x1f1ec,0x1f1f3}, 0, 2));
		_addEntry("goal", new String(new int[] {0x1f945}, 0, 1));
		_addEntry("goal_net", new String(new int[] {0x1f945}, 0, 1));
		_addEntry("goat", new String(new int[] {0x1f410}, 0, 1));
		_addEntry("golf", new String(new int[] {0x26f3}, 0, 1));
	}
	private static void init11(){
		_addEntry("golfer", new String(new int[] {0x1f3cc}, 0, 1));
		_addEntry("gorilla", new String(new int[] {0x1f98d}, 0, 1));
		_addEntry("gp", new String(new int[] {0x1f1ec,0x1f1f5}, 0, 2));
		_addEntry("gq", new String(new int[] {0x1f1ec,0x1f1f6}, 0, 2));
		_addEntry("gr", new String(new int[] {0x1f1ec,0x1f1f7}, 0, 2));
		_addEntry("grandma", new String(new int[] {0x1f475}, 0, 1));
		_addEntry("grandma_tone1", new String(new int[] {0x1f475,0x1f3fb}, 0, 2));
		_addEntry("grandma_tone2", new String(new int[] {0x1f475,0x1f3fc}, 0, 2));
		_addEntry("grandma_tone3", new String(new int[] {0x1f475,0x1f3fd}, 0, 2));
		_addEntry("grandma_tone4", new String(new int[] {0x1f475,0x1f3fe}, 0, 2));
		_addEntry("grandma_tone5", new String(new int[] {0x1f475,0x1f3ff}, 0, 2));
		_addEntry("grapes", new String(new int[] {0x1f347}, 0, 1));
		_addEntry("green_apple", new String(new int[] {0x1f34f}, 0, 1));
		_addEntry("green_book", new String(new int[] {0x1f4d7}, 0, 1));
		_addEntry("green_heart", new String(new int[] {0x1f49a}, 0, 1));
		_addEntry("green_salad", new String(new int[] {0x1f957}, 0, 1));
		_addEntry("grey_exclamation", new String(new int[] {0x2755}, 0, 1));
		_addEntry("grey_question", new String(new int[] {0x2754}, 0, 1));
		_addEntry("grimacing", new String(new int[] {0x1f62c}, 0, 1));
		_addEntry("grin", new String(new int[] {0x1f601}, 0, 1));
		_addEntry("grinning", new String(new int[] {0x1f600}, 0, 1));
		_addEntry("gs", new String(new int[] {0x1f1ec,0x1f1f8}, 0, 2));
		_addEntry("gt", new String(new int[] {0x1f1ec,0x1f1f9}, 0, 2));
		_addEntry("gu", new String(new int[] {0x1f1ec,0x1f1fa}, 0, 2));
		_addEntry("guardsman", new String(new int[] {0x1f482}, 0, 1));
		_addEntry("guardsman_tone1", new String(new int[] {0x1f482,0x1f3fb}, 0, 2));
		_addEntry("guardsman_tone2", new String(new int[] {0x1f482,0x1f3fc}, 0, 2));
		_addEntry("guardsman_tone3", new String(new int[] {0x1f482,0x1f3fd}, 0, 2));
		_addEntry("guardsman_tone4", new String(new int[] {0x1f482,0x1f3fe}, 0, 2));
		_addEntry("guardsman_tone5", new String(new int[] {0x1f482,0x1f3ff}, 0, 2));
		_addEntry("guitar", new String(new int[] {0x1f3b8}, 0, 1));
		_addEntry("gun", new String(new int[] {0x1f52b}, 0, 1));
		_addEntry("gw", new String(new int[] {0x1f1ec,0x1f1fc}, 0, 2));
		_addEntry("gy", new String(new int[] {0x1f1ec,0x1f1fe}, 0, 2));
		_addEntry("haircut", new String(new int[] {0x1f487}, 0, 1));
		_addEntry("haircut_tone1", new String(new int[] {0x1f487,0x1f3fb}, 0, 2));
		_addEntry("haircut_tone2", new String(new int[] {0x1f487,0x1f3fc}, 0, 2));
		_addEntry("haircut_tone3", new String(new int[] {0x1f487,0x1f3fd}, 0, 2));
		_addEntry("haircut_tone4", new String(new int[] {0x1f487,0x1f3fe}, 0, 2));
		_addEntry("haircut_tone5", new String(new int[] {0x1f487,0x1f3ff}, 0, 2));
		_addEntry("hamburger", new String(new int[] {0x1f354}, 0, 1));
		_addEntry("hammer", new String(new int[] {0x1f528}, 0, 1));
		_addEntry("hammer_and_pick", new String(new int[] {0x2692}, 0, 1));
		_addEntry("hammer_and_wrench", new String(new int[] {0x1f6e0}, 0, 1));
		_addEntry("hammer_pick", new String(new int[] {0x2692}, 0, 1));
		_addEntry("hamster", new String(new int[] {0x1f439}, 0, 1));
		_addEntry("hand_splayed", new String(new int[] {0x1f590}, 0, 1));
		_addEntry("hand_splayed_tone1", new String(new int[] {0x1f590,0x1f3fb}, 0, 2));
		_addEntry("hand_splayed_tone2", new String(new int[] {0x1f590,0x1f3fc}, 0, 2));
		_addEntry("hand_splayed_tone3", new String(new int[] {0x1f590,0x1f3fd}, 0, 2));
		_addEntry("hand_splayed_tone4", new String(new int[] {0x1f590,0x1f3fe}, 0, 2));
		_addEntry("hand_splayed_tone5", new String(new int[] {0x1f590,0x1f3ff}, 0, 2));
		_addEntry("hand_with_index_and_middle_finger_crossed", new String(new int[] {0x1f91e}, 0, 1));
		_addEntry("hand_with_index_and_middle_fingers_crossed_tone1", new String(new int[] {0x1f91e,0x1f3fb}, 0, 2));
		_addEntry("hand_with_index_and_middle_fingers_crossed_tone2", new String(new int[] {0x1f91e,0x1f3fc}, 0, 2));
		_addEntry("hand_with_index_and_middle_fingers_crossed_tone3", new String(new int[] {0x1f91e,0x1f3fd}, 0, 2));
		_addEntry("hand_with_index_and_middle_fingers_crossed_tone4", new String(new int[] {0x1f91e,0x1f3fe}, 0, 2));
		_addEntry("hand_with_index_and_middle_fingers_crossed_tone5", new String(new int[] {0x1f91e,0x1f3ff}, 0, 2));
		_addEntry("handbag", new String(new int[] {0x1f45c}, 0, 1));
		_addEntry("handball", new String(new int[] {0x1f93e}, 0, 1));
		_addEntry("handball_tone1", new String(new int[] {0x1f93e,0x1f3fb}, 0, 2));
		_addEntry("handball_tone2", new String(new int[] {0x1f93e,0x1f3fc}, 0, 2));
		_addEntry("handball_tone3", new String(new int[] {0x1f93e,0x1f3fd}, 0, 2));
		_addEntry("handball_tone4", new String(new int[] {0x1f93e,0x1f3fe}, 0, 2));
		_addEntry("handball_tone5", new String(new int[] {0x1f93e,0x1f3ff}, 0, 2));
		_addEntry("handshake", new String(new int[] {0x1f91d}, 0, 1));
		_addEntry("hankey", new String(new int[] {0x1f4a9}, 0, 1));
		_addEntry("hash", new String(new int[] {0x0023,0x20e3}, 0, 2));
		_addEntry("hatched_chick", new String(new int[] {0x1f425}, 0, 1));
		_addEntry("hatching_chick", new String(new int[] {0x1f423}, 0, 1));
		_addEntry("head_bandage", new String(new int[] {0x1f915}, 0, 1));
		_addEntry("headphones", new String(new int[] {0x1f3a7}, 0, 1));
		_addEntry("hear_no_evil", new String(new int[] {0x1f649}, 0, 1));
		_addEntry("heart", new String(new int[] {0x2764}, 0, 1));
		_addEntry("heart_decoration", new String(new int[] {0x1f49f}, 0, 1));
		_addEntry("heart_exclamation", new String(new int[] {0x2763}, 0, 1));
		_addEntry("heart_eyes", new String(new int[] {0x1f60d}, 0, 1));
		_addEntry("heart_eyes_cat", new String(new int[] {0x1f63b}, 0, 1));
		_addEntry("heartbeat", new String(new int[] {0x1f493}, 0, 1));
		_addEntry("heartpulse", new String(new int[] {0x1f497}, 0, 1));
		_addEntry("hearts", new String(new int[] {0x2665}, 0, 1));
		_addEntry("heavy_check_mark", new String(new int[] {0x2714}, 0, 1));
		_addEntry("heavy_division_sign", new String(new int[] {0x2797}, 0, 1));
		_addEntry("heavy_dollar_sign", new String(new int[] {0x1f4b2}, 0, 1));
		_addEntry("heavy_heart_exclamation_mark_ornament", new String(new int[] {0x2763}, 0, 1));
		_addEntry("heavy_minus_sign", new String(new int[] {0x2796}, 0, 1));
		_addEntry("heavy_multiplication_x", new String(new int[] {0x2716}, 0, 1));
		_addEntry("heavy_plus_sign", new String(new int[] {0x2795}, 0, 1));
		_addEntry("helicopter", new String(new int[] {0x1f681}, 0, 1));
		_addEntry("helmet_with_cross", new String(new int[] {0x26d1}, 0, 1));
		_addEntry("helmet_with_white_cross", new String(new int[] {0x26d1}, 0, 1));
		_addEntry("herb", new String(new int[] {0x1f33f}, 0, 1));
		_addEntry("hibiscus", new String(new int[] {0x1f33a}, 0, 1));
		_addEntry("high_brightness", new String(new int[] {0x1f506}, 0, 1));
		_addEntry("high_heel", new String(new int[] {0x1f460}, 0, 1));
		_addEntry("hk", new String(new int[] {0x1f1ed,0x1f1f0}, 0, 2));
		_addEntry("hm", new String(new int[] {0x1f1ed,0x1f1f2}, 0, 2));
		_addEntry("hn", new String(new int[] {0x1f1ed,0x1f1f3}, 0, 2));
		_addEntry("hockey", new String(new int[] {0x1f3d2}, 0, 1));
		_addEntry("hole", new String(new int[] {0x1f573}, 0, 1));
		_addEntry("homes", new String(new int[] {0x1f3d8}, 0, 1));
	}
	private static void init12(){
		_addEntry("honey_pot", new String(new int[] {0x1f36f}, 0, 1));
		_addEntry("horse", new String(new int[] {0x1f434}, 0, 1));
		_addEntry("horse_racing", new String(new int[] {0x1f3c7}, 0, 1));
		_addEntry("horse_racing_tone1", new String(new int[] {0x1f3c7,0x1f3fb}, 0, 2));
		_addEntry("horse_racing_tone2", new String(new int[] {0x1f3c7,0x1f3fc}, 0, 2));
		_addEntry("horse_racing_tone3", new String(new int[] {0x1f3c7,0x1f3fd}, 0, 2));
		_addEntry("horse_racing_tone4", new String(new int[] {0x1f3c7,0x1f3fe}, 0, 2));
		_addEntry("horse_racing_tone5", new String(new int[] {0x1f3c7,0x1f3ff}, 0, 2));
		_addEntry("hospital", new String(new int[] {0x1f3e5}, 0, 1));
		_addEntry("hot_dog", new String(new int[] {0x1f32d}, 0, 1));
		_addEntry("hot_pepper", new String(new int[] {0x1f336}, 0, 1));
		_addEntry("hotdog", new String(new int[] {0x1f32d}, 0, 1));
		_addEntry("hotel", new String(new int[] {0x1f3e8}, 0, 1));
		_addEntry("hotsprings", new String(new int[] {0x2668}, 0, 1));
		_addEntry("hourglass", new String(new int[] {0x231b}, 0, 1));
		_addEntry("hourglass_flowing_sand", new String(new int[] {0x23f3}, 0, 1));
		_addEntry("house", new String(new int[] {0x1f3e0}, 0, 1));
		_addEntry("house_abandoned", new String(new int[] {0x1f3da}, 0, 1));
		_addEntry("house_buildings", new String(new int[] {0x1f3d8}, 0, 1));
		_addEntry("house_with_garden", new String(new int[] {0x1f3e1}, 0, 1));
		_addEntry("hr", new String(new int[] {0x1f1ed,0x1f1f7}, 0, 2));
		_addEntry("ht", new String(new int[] {0x1f1ed,0x1f1f9}, 0, 2));
		_addEntry("hu", new String(new int[] {0x1f1ed,0x1f1fa}, 0, 2));
		_addEntry("hugging", new String(new int[] {0x1f917}, 0, 1));
		_addEntry("hugging_face", new String(new int[] {0x1f917}, 0, 1));
		_addEntry("hushed", new String(new int[] {0x1f62f}, 0, 1));
		_addEntry("ic", new String(new int[] {0x1f1ee,0x1f1e8}, 0, 2));
		_addEntry("ice_cream", new String(new int[] {0x1f368}, 0, 1));
		_addEntry("ice_skate", new String(new int[] {0x26f8}, 0, 1));
		_addEntry("icecream", new String(new int[] {0x1f366}, 0, 1));
		_addEntry("id", new String(new int[] {0x1f194}, 0, 1));
		_addEntry("ideograph_advantage", new String(new int[] {0x1f250}, 0, 1));
		_addEntry("ie", new String(new int[] {0x1f1ee,0x1f1ea}, 0, 2));
		_addEntry("il", new String(new int[] {0x1f1ee,0x1f1f1}, 0, 2));
		_addEntry("im", new String(new int[] {0x1f1ee,0x1f1f2}, 0, 2));
		_addEntry("imp", new String(new int[] {0x1f47f}, 0, 1));
		_addEntry("in", new String(new int[] {0x1f1ee,0x1f1f3}, 0, 2));
		_addEntry("inbox_tray", new String(new int[] {0x1f4e5}, 0, 1));
		_addEntry("incoming_envelope", new String(new int[] {0x1f4e8}, 0, 1));
		_addEntry("indonesia", new String(new int[] {0x1f1ee,0x1f1e9}, 0, 2));
		_addEntry("information_desk_person", new String(new int[] {0x1f481}, 0, 1));
		_addEntry("information_desk_person_tone1", new String(new int[] {0x1f481,0x1f3fb}, 0, 2));
		_addEntry("information_desk_person_tone2", new String(new int[] {0x1f481,0x1f3fc}, 0, 2));
		_addEntry("information_desk_person_tone3", new String(new int[] {0x1f481,0x1f3fd}, 0, 2));
		_addEntry("information_desk_person_tone4", new String(new int[] {0x1f481,0x1f3fe}, 0, 2));
		_addEntry("information_desk_person_tone5", new String(new int[] {0x1f481,0x1f3ff}, 0, 2));
		_addEntry("information_source", new String(new int[] {0x2139}, 0, 1));
		_addEntry("innocent", new String(new int[] {0x1f607}, 0, 1));
		_addEntry("interrobang", new String(new int[] {0x2049}, 0, 1));
		_addEntry("io", new String(new int[] {0x1f1ee,0x1f1f4}, 0, 2));
		_addEntry("iphone", new String(new int[] {0x1f4f1}, 0, 1));
		_addEntry("iq", new String(new int[] {0x1f1ee,0x1f1f6}, 0, 2));
		_addEntry("ir", new String(new int[] {0x1f1ee,0x1f1f7}, 0, 2));
		_addEntry("is", new String(new int[] {0x1f1ee,0x1f1f8}, 0, 2));
		_addEntry("island", new String(new int[] {0x1f3dd}, 0, 1));
		_addEntry("it", new String(new int[] {0x1f1ee,0x1f1f9}, 0, 2));
		_addEntry("izakaya_lantern", new String(new int[] {0x1f3ee}, 0, 1));
		_addEntry("jack_o_lantern", new String(new int[] {0x1f383}, 0, 1));
		_addEntry("japan", new String(new int[] {0x1f5fe}, 0, 1));
		_addEntry("japanese_castle", new String(new int[] {0x1f3ef}, 0, 1));
		_addEntry("japanese_goblin", new String(new int[] {0x1f47a}, 0, 1));
		_addEntry("japanese_ogre", new String(new int[] {0x1f479}, 0, 1));
		_addEntry("je", new String(new int[] {0x1f1ef,0x1f1ea}, 0, 2));
		_addEntry("jeans", new String(new int[] {0x1f456}, 0, 1));
		_addEntry("jm", new String(new int[] {0x1f1ef,0x1f1f2}, 0, 2));
		_addEntry("jo", new String(new int[] {0x1f1ef,0x1f1f4}, 0, 2));
		_addEntry("joy", new String(new int[] {0x1f602}, 0, 1));
		_addEntry("joy_cat", new String(new int[] {0x1f639}, 0, 1));
		_addEntry("joystick", new String(new int[] {0x1f579}, 0, 1));
		_addEntry("jp", new String(new int[] {0x1f1ef,0x1f1f5}, 0, 2));
		_addEntry("juggler", new String(new int[] {0x1f939}, 0, 1));
		_addEntry("juggler_tone1", new String(new int[] {0x1f939,0x1f3fb}, 0, 2));
		_addEntry("juggler_tone2", new String(new int[] {0x1f939,0x1f3fc}, 0, 2));
		_addEntry("juggler_tone3", new String(new int[] {0x1f939,0x1f3fd}, 0, 2));
		_addEntry("juggler_tone4", new String(new int[] {0x1f939,0x1f3fe}, 0, 2));
		_addEntry("juggler_tone5", new String(new int[] {0x1f939,0x1f3ff}, 0, 2));
		_addEntry("juggling", new String(new int[] {0x1f939}, 0, 1));
		_addEntry("juggling_tone1", new String(new int[] {0x1f939,0x1f3fb}, 0, 2));
		_addEntry("juggling_tone2", new String(new int[] {0x1f939,0x1f3fc}, 0, 2));
		_addEntry("juggling_tone3", new String(new int[] {0x1f939,0x1f3fd}, 0, 2));
		_addEntry("juggling_tone4", new String(new int[] {0x1f939,0x1f3fe}, 0, 2));
		_addEntry("juggling_tone5", new String(new int[] {0x1f939,0x1f3ff}, 0, 2));
		_addEntry("kaaba", new String(new int[] {0x1f54b}, 0, 1));
		_addEntry("karate_uniform", new String(new int[] {0x1f94b}, 0, 1));
		_addEntry("kayak", new String(new int[] {0x1f6f6}, 0, 1));
		_addEntry("ke", new String(new int[] {0x1f1f0,0x1f1ea}, 0, 2));
		_addEntry("key", new String(new int[] {0x1f511}, 0, 1));
		_addEntry("key2", new String(new int[] {0x1f5dd}, 0, 1));
		_addEntry("keyboard", new String(new int[] {0x2328}, 0, 1));
		_addEntry("keycap_asterisk", new String(new int[] {0x002a,0x20e3}, 0, 2));
		_addEntry("keycap_ten", new String(new int[] {0x1f51f}, 0, 1));
		_addEntry("kg", new String(new int[] {0x1f1f0,0x1f1ec}, 0, 2));
		_addEntry("kh", new String(new int[] {0x1f1f0,0x1f1ed}, 0, 2));
		_addEntry("ki", new String(new int[] {0x1f1f0,0x1f1ee}, 0, 2));
		_addEntry("kimono", new String(new int[] {0x1f458}, 0, 1));
		_addEntry("kiss", new String(new int[] {0x1f48b}, 0, 1));
		_addEntry("kiss_mm", new String(new int[] {0x1f468,0x2764,0x1f48b,0x1f468}, 0, 4));
		_addEntry("kiss_woman_man", new String(new int[] {0x1f469,0x2764,0x1f48b,0x1f468}, 0, 4));
		_addEntry("kiss_ww", new String(new int[] {0x1f469,0x2764,0x1f48b,0x1f469}, 0, 4));
		_addEntry("kissing", new String(new int[] {0x1f617}, 0, 1));
		_addEntry("kissing_cat", new String(new int[] {0x1f63d}, 0, 1));
	}
	private static void init13(){
		_addEntry("kissing_closed_eyes", new String(new int[] {0x1f61a}, 0, 1));
		_addEntry("kissing_heart", new String(new int[] {0x1f618}, 0, 1));
		_addEntry("kissing_smiling_eyes", new String(new int[] {0x1f619}, 0, 1));
		_addEntry("kiwi", new String(new int[] {0x1f95d}, 0, 1));
		_addEntry("kiwifruit", new String(new int[] {0x1f95d}, 0, 1));
		_addEntry("km", new String(new int[] {0x1f1f0,0x1f1f2}, 0, 2));
		_addEntry("kn", new String(new int[] {0x1f1f0,0x1f1f3}, 0, 2));
		_addEntry("knife", new String(new int[] {0x1f52a}, 0, 1));
		_addEntry("koala", new String(new int[] {0x1f428}, 0, 1));
		_addEntry("koko", new String(new int[] {0x1f201}, 0, 1));
		_addEntry("kp", new String(new int[] {0x1f1f0,0x1f1f5}, 0, 2));
		_addEntry("kr", new String(new int[] {0x1f1f0,0x1f1f7}, 0, 2));
		_addEntry("kw", new String(new int[] {0x1f1f0,0x1f1fc}, 0, 2));
		_addEntry("ky", new String(new int[] {0x1f1f0,0x1f1fe}, 0, 2));
		_addEntry("kz", new String(new int[] {0x1f1f0,0x1f1ff}, 0, 2));
		_addEntry("la", new String(new int[] {0x1f1f1,0x1f1e6}, 0, 2));
		_addEntry("label", new String(new int[] {0x1f3f7}, 0, 1));
		_addEntry("large_blue_diamond", new String(new int[] {0x1f537}, 0, 1));
		_addEntry("large_orange_diamond", new String(new int[] {0x1f536}, 0, 1));
		_addEntry("last_quarter_moon", new String(new int[] {0x1f317}, 0, 1));
		_addEntry("last_quarter_moon_with_face", new String(new int[] {0x1f31c}, 0, 1));
		_addEntry("latin_cross", new String(new int[] {0x271d}, 0, 1));
		_addEntry("laughing", new String(new int[] {0x1f606}, 0, 1));
		_addEntry("lb", new String(new int[] {0x1f1f1,0x1f1e7}, 0, 2));
		_addEntry("lc", new String(new int[] {0x1f1f1,0x1f1e8}, 0, 2));
		_addEntry("leaves", new String(new int[] {0x1f343}, 0, 1));
		_addEntry("ledger", new String(new int[] {0x1f4d2}, 0, 1));
		_addEntry("left_facing_fist", new String(new int[] {0x1f91b}, 0, 1));
		_addEntry("left_facing_fist_tone1", new String(new int[] {0x1f91b,0x1f3fb}, 0, 2));
		_addEntry("left_facing_fist_tone2", new String(new int[] {0x1f91b,0x1f3fc}, 0, 2));
		_addEntry("left_facing_fist_tone3", new String(new int[] {0x1f91b,0x1f3fd}, 0, 2));
		_addEntry("left_facing_fist_tone4", new String(new int[] {0x1f91b,0x1f3fe}, 0, 2));
		_addEntry("left_facing_fist_tone5", new String(new int[] {0x1f91b,0x1f3ff}, 0, 2));
		_addEntry("left_fist", new String(new int[] {0x1f91b}, 0, 1));
		_addEntry("left_fist_tone1", new String(new int[] {0x1f91b,0x1f3fb}, 0, 2));
		_addEntry("left_fist_tone2", new String(new int[] {0x1f91b,0x1f3fc}, 0, 2));
		_addEntry("left_fist_tone3", new String(new int[] {0x1f91b,0x1f3fd}, 0, 2));
		_addEntry("left_fist_tone4", new String(new int[] {0x1f91b,0x1f3fe}, 0, 2));
		_addEntry("left_fist_tone5", new String(new int[] {0x1f91b,0x1f3ff}, 0, 2));
		_addEntry("left_luggage", new String(new int[] {0x1f6c5}, 0, 1));
		_addEntry("left_right_arrow", new String(new int[] {0x2194}, 0, 1));
		_addEntry("left_speech_bubble", new String(new int[] {0x1f5e8}, 0, 1));
		_addEntry("leftwards_arrow_with_hook", new String(new int[] {0x21a9}, 0, 1));
		_addEntry("lemon", new String(new int[] {0x1f34b}, 0, 1));
		_addEntry("leo", new String(new int[] {0x264c}, 0, 1));
		_addEntry("leopard", new String(new int[] {0x1f406}, 0, 1));
		_addEntry("level_slider", new String(new int[] {0x1f39a}, 0, 1));
		_addEntry("levitate", new String(new int[] {0x1f574}, 0, 1));
		_addEntry("li", new String(new int[] {0x1f1f1,0x1f1ee}, 0, 2));
		_addEntry("liar", new String(new int[] {0x1f925}, 0, 1));
		_addEntry("libra", new String(new int[] {0x264e}, 0, 1));
		_addEntry("lifter", new String(new int[] {0x1f3cb}, 0, 1));
		_addEntry("lifter_tone1", new String(new int[] {0x1f3cb,0x1f3fb}, 0, 2));
		_addEntry("lifter_tone2", new String(new int[] {0x1f3cb,0x1f3fc}, 0, 2));
		_addEntry("lifter_tone3", new String(new int[] {0x1f3cb,0x1f3fd}, 0, 2));
		_addEntry("lifter_tone4", new String(new int[] {0x1f3cb,0x1f3fe}, 0, 2));
		_addEntry("lifter_tone5", new String(new int[] {0x1f3cb,0x1f3ff}, 0, 2));
		_addEntry("light_rail", new String(new int[] {0x1f688}, 0, 1));
		_addEntry("link", new String(new int[] {0x1f517}, 0, 1));
		_addEntry("linked_paperclips", new String(new int[] {0x1f587}, 0, 1));
		_addEntry("lion", new String(new int[] {0x1f981}, 0, 1));
		_addEntry("lion_face", new String(new int[] {0x1f981}, 0, 1));
		_addEntry("lips", new String(new int[] {0x1f444}, 0, 1));
		_addEntry("lipstick", new String(new int[] {0x1f484}, 0, 1));
		_addEntry("lizard", new String(new int[] {0x1f98e}, 0, 1));
		_addEntry("lk", new String(new int[] {0x1f1f1,0x1f1f0}, 0, 2));
		_addEntry("lock", new String(new int[] {0x1f512}, 0, 1));
		_addEntry("lock_with_ink_pen", new String(new int[] {0x1f50f}, 0, 1));
		_addEntry("lollipop", new String(new int[] {0x1f36d}, 0, 1));
		_addEntry("loop", new String(new int[] {0x27bf}, 0, 1));
		_addEntry("loud_sound", new String(new int[] {0x1f50a}, 0, 1));
		_addEntry("loudspeaker", new String(new int[] {0x1f4e2}, 0, 1));
		_addEntry("love_hotel", new String(new int[] {0x1f3e9}, 0, 1));
		_addEntry("love_letter", new String(new int[] {0x1f48c}, 0, 1));
		_addEntry("low_brightness", new String(new int[] {0x1f505}, 0, 1));
		_addEntry("lower_left_ballpoint_pen", new String(new int[] {0x1f58a}, 0, 1));
		_addEntry("lower_left_crayon", new String(new int[] {0x1f58d}, 0, 1));
		_addEntry("lower_left_fountain_pen", new String(new int[] {0x1f58b}, 0, 1));
		_addEntry("lower_left_paintbrush", new String(new int[] {0x1f58c}, 0, 1));
		_addEntry("lr", new String(new int[] {0x1f1f1,0x1f1f7}, 0, 2));
		_addEntry("ls", new String(new int[] {0x1f1f1,0x1f1f8}, 0, 2));
		_addEntry("lt", new String(new int[] {0x1f1f1,0x1f1f9}, 0, 2));
		_addEntry("lu", new String(new int[] {0x1f1f1,0x1f1fa}, 0, 2));
		_addEntry("lv", new String(new int[] {0x1f1f1,0x1f1fb}, 0, 2));
		_addEntry("ly", new String(new int[] {0x1f1f1,0x1f1fe}, 0, 2));
		_addEntry("lying_face", new String(new int[] {0x1f925}, 0, 1));
		_addEntry("m", new String(new int[] {0x24c2}, 0, 1));
		_addEntry("ma", new String(new int[] {0x1f1f2,0x1f1e6}, 0, 2));
		_addEntry("mag", new String(new int[] {0x1f50d}, 0, 1));
		_addEntry("mag_right", new String(new int[] {0x1f50e}, 0, 1));
		_addEntry("mahjong", new String(new int[] {0x1f004}, 0, 1));
		_addEntry("mailbox", new String(new int[] {0x1f4eb}, 0, 1));
		_addEntry("mailbox_closed", new String(new int[] {0x1f4ea}, 0, 1));
		_addEntry("mailbox_with_mail", new String(new int[] {0x1f4ec}, 0, 1));
		_addEntry("mailbox_with_no_mail", new String(new int[] {0x1f4ed}, 0, 1));
		_addEntry("male_dancer", new String(new int[] {0x1f57a}, 0, 1));
		_addEntry("male_dancer_tone1", new String(new int[] {0x1f57a,0x1f3fb}, 0, 2));
		_addEntry("male_dancer_tone2", new String(new int[] {0x1f57a,0x1f3fc}, 0, 2));
		_addEntry("male_dancer_tone3", new String(new int[] {0x1f57a,0x1f3fd}, 0, 2));
		_addEntry("male_dancer_tone4", new String(new int[] {0x1f57a,0x1f3fe}, 0, 2));
		_addEntry("male_dancer_tone5", new String(new int[] {0x1f57a,0x1f3ff}, 0, 2));
	}
	private static void init14(){
		_addEntry("male_sign", new String(new int[] {0x2642}, 0, 1));
		_addEntry("man", new String(new int[] {0x1f468}, 0, 1));
		_addEntry("man_artist", new String(new int[] {0x1f468,0x1f3a8}, 0, 2));
		_addEntry("man_artist_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f3a8}, 0, 3));
		_addEntry("man_artist_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f3a8}, 0, 3));
		_addEntry("man_artist_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f3a8}, 0, 3));
		_addEntry("man_artist_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f3a8}, 0, 3));
		_addEntry("man_artist_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f3a8}, 0, 3));
		_addEntry("man_artist_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f3a8}, 0, 3));
		_addEntry("man_artist_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f3a8}, 0, 3));
		_addEntry("man_artist_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f3a8}, 0, 3));
		_addEntry("man_artist_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f3a8}, 0, 3));
		_addEntry("man_artist_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f3a8}, 0, 3));
		_addEntry("man_astronaut", new String(new int[] {0x1f468,0x1f680}, 0, 2));
		_addEntry("man_astronaut_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f680}, 0, 3));
		_addEntry("man_astronaut_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f680}, 0, 3));
		_addEntry("man_astronaut_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f680}, 0, 3));
		_addEntry("man_astronaut_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f680}, 0, 3));
		_addEntry("man_astronaut_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f680}, 0, 3));
		_addEntry("man_astronaut_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f680}, 0, 3));
		_addEntry("man_astronaut_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f680}, 0, 3));
		_addEntry("man_astronaut_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f680}, 0, 3));
		_addEntry("man_astronaut_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f680}, 0, 3));
		_addEntry("man_astronaut_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f680}, 0, 3));
		_addEntry("man_biking", new String(new int[] {0x1f6b4,0x2642}, 0, 2));
		_addEntry("man_biking_dark_skin_tone", new String(new int[] {0x1f6b4,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_biking_light_skin_tone", new String(new int[] {0x1f6b4,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_biking_medium_dark_skin_tone", new String(new int[] {0x1f6b4,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_biking_medium_light_skin_tone", new String(new int[] {0x1f6b4,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_biking_medium_skin_tone", new String(new int[] {0x1f6b4,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_biking_tone1", new String(new int[] {0x1f6b4,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_biking_tone2", new String(new int[] {0x1f6b4,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_biking_tone3", new String(new int[] {0x1f6b4,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_biking_tone4", new String(new int[] {0x1f6b4,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_biking_tone5", new String(new int[] {0x1f6b4,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_bouncing_ball", new String(new int[] {0x26f9,0x2642}, 0, 2));
		_addEntry("man_bouncing_ball_dark_skin_tone", new String(new int[] {0x26f9,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_bouncing_ball_light_skin_tone", new String(new int[] {0x26f9,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_bouncing_ball_medium_dark_skin_tone", new String(new int[] {0x26f9,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_bouncing_ball_medium_light_skin_tone", new String(new int[] {0x26f9,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_bouncing_ball_medium_skin_tone", new String(new int[] {0x26f9,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_bouncing_ball_tone1", new String(new int[] {0x26f9,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_bouncing_ball_tone2", new String(new int[] {0x26f9,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_bouncing_ball_tone3", new String(new int[] {0x26f9,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_bouncing_ball_tone4", new String(new int[] {0x26f9,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_bouncing_ball_tone5", new String(new int[] {0x26f9,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_bowing", new String(new int[] {0x1f647,0x2642}, 0, 2));
		_addEntry("man_bowing_dark_skin_tone", new String(new int[] {0x1f647,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_bowing_light_skin_tone", new String(new int[] {0x1f647,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_bowing_medium_dark_skin_tone", new String(new int[] {0x1f647,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_bowing_medium_light_skin_tone", new String(new int[] {0x1f647,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_bowing_medium_skin_tone", new String(new int[] {0x1f647,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_bowing_tone1", new String(new int[] {0x1f647,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_bowing_tone2", new String(new int[] {0x1f647,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_bowing_tone3", new String(new int[] {0x1f647,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_bowing_tone4", new String(new int[] {0x1f647,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_bowing_tone5", new String(new int[] {0x1f647,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_cartwheeling", new String(new int[] {0x1f938,0x2642}, 0, 2));
		_addEntry("man_cartwheeling_dark_skin_tone", new String(new int[] {0x1f938,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_cartwheeling_light_skin_tone", new String(new int[] {0x1f938,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_cartwheeling_medium_dark_skin_tone", new String(new int[] {0x1f938,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_cartwheeling_medium_light_skin_tone", new String(new int[] {0x1f938,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_cartwheeling_medium_skin_tone", new String(new int[] {0x1f938,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_cartwheeling_tone1", new String(new int[] {0x1f938,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_cartwheeling_tone2", new String(new int[] {0x1f938,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_cartwheeling_tone3", new String(new int[] {0x1f938,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_cartwheeling_tone4", new String(new int[] {0x1f938,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_cartwheeling_tone5", new String(new int[] {0x1f938,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_construction_worker", new String(new int[] {0x1f477,0x2642}, 0, 2));
		_addEntry("man_construction_worker_dark_skin_tone", new String(new int[] {0x1f477,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_construction_worker_light_skin_tone", new String(new int[] {0x1f477,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_construction_worker_medium_dark_skin_tone", new String(new int[] {0x1f477,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_construction_worker_medium_light_skin_tone", new String(new int[] {0x1f477,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_construction_worker_medium_skin_tone", new String(new int[] {0x1f477,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_construction_worker_tone1", new String(new int[] {0x1f477,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_construction_worker_tone2", new String(new int[] {0x1f477,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_construction_worker_tone3", new String(new int[] {0x1f477,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_construction_worker_tone4", new String(new int[] {0x1f477,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_construction_worker_tone5", new String(new int[] {0x1f477,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_cook", new String(new int[] {0x1f468,0x1f373}, 0, 2));
		_addEntry("man_cook_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f373}, 0, 3));
		_addEntry("man_cook_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f373}, 0, 3));
		_addEntry("man_cook_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f373}, 0, 3));
		_addEntry("man_cook_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f373}, 0, 3));
		_addEntry("man_cook_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f373}, 0, 3));
		_addEntry("man_cook_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f373}, 0, 3));
		_addEntry("man_cook_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f373}, 0, 3));
		_addEntry("man_cook_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f373}, 0, 3));
		_addEntry("man_cook_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f373}, 0, 3));
		_addEntry("man_cook_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f373}, 0, 3));
		_addEntry("man_dancing", new String(new int[] {0x1f57a}, 0, 1));
		_addEntry("man_dancing_tone1", new String(new int[] {0x1f57a,0x1f3fb}, 0, 2));
		_addEntry("man_dancing_tone2", new String(new int[] {0x1f57a,0x1f3fc}, 0, 2));
		_addEntry("man_dancing_tone3", new String(new int[] {0x1f57a,0x1f3fd}, 0, 2));
		_addEntry("man_dancing_tone4", new String(new int[] {0x1f57a,0x1f3fe}, 0, 2));
		_addEntry("man_dancing_tone5", new String(new int[] {0x1f57a,0x1f3ff}, 0, 2));
		_addEntry("man_detective", new String(new int[] {0x1f575,0x2642}, 0, 2));
		_addEntry("man_detective_dark_skin_tone", new String(new int[] {0x1f575,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_detective_light_skin_tone", new String(new int[] {0x1f575,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_detective_medium_dark_skin_tone", new String(new int[] {0x1f575,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_detective_medium_light_skin_tone", new String(new int[] {0x1f575,0x1f3fc,0x2642}, 0, 3));
	}
	private static void init15(){
		_addEntry("man_detective_medium_skin_tone", new String(new int[] {0x1f575,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_detective_tone1", new String(new int[] {0x1f575,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_detective_tone2", new String(new int[] {0x1f575,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_detective_tone3", new String(new int[] {0x1f575,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_detective_tone4", new String(new int[] {0x1f575,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_detective_tone5", new String(new int[] {0x1f575,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_facepalming", new String(new int[] {0x1f926,0x2642}, 0, 2));
		_addEntry("man_facepalming_dark_skin_tone", new String(new int[] {0x1f926,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_facepalming_light_skin_tone", new String(new int[] {0x1f926,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_facepalming_medium_dark_skin_tone", new String(new int[] {0x1f926,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_facepalming_medium_light_skin_tone", new String(new int[] {0x1f926,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_facepalming_medium_skin_tone", new String(new int[] {0x1f926,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_facepalming_tone1", new String(new int[] {0x1f926,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_facepalming_tone2", new String(new int[] {0x1f926,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_facepalming_tone3", new String(new int[] {0x1f926,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_facepalming_tone4", new String(new int[] {0x1f926,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_facepalming_tone5", new String(new int[] {0x1f926,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_factory_worker", new String(new int[] {0x1f468,0x1f3ed}, 0, 2));
		_addEntry("man_factory_worker_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f3ed}, 0, 3));
		_addEntry("man_factory_worker_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f3ed}, 0, 3));
		_addEntry("man_factory_worker_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f3ed}, 0, 3));
		_addEntry("man_factory_worker_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f3ed}, 0, 3));
		_addEntry("man_factory_worker_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f3ed}, 0, 3));
		_addEntry("man_factory_worker_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f3ed}, 0, 3));
		_addEntry("man_factory_worker_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f3ed}, 0, 3));
		_addEntry("man_factory_worker_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f3ed}, 0, 3));
		_addEntry("man_factory_worker_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f3ed}, 0, 3));
		_addEntry("man_factory_worker_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f3ed}, 0, 3));
		_addEntry("man_farmer", new String(new int[] {0x1f468,0x1f33e}, 0, 2));
		_addEntry("man_farmer_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f33e}, 0, 3));
		_addEntry("man_farmer_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f33e}, 0, 3));
		_addEntry("man_farmer_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f33e}, 0, 3));
		_addEntry("man_farmer_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f33e}, 0, 3));
		_addEntry("man_farmer_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f33e}, 0, 3));
		_addEntry("man_farmer_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f33e}, 0, 3));
		_addEntry("man_farmer_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f33e}, 0, 3));
		_addEntry("man_farmer_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f33e}, 0, 3));
		_addEntry("man_farmer_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f33e}, 0, 3));
		_addEntry("man_farmer_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f33e}, 0, 3));
		_addEntry("man_firefighter", new String(new int[] {0x1f468,0x1f692}, 0, 2));
		_addEntry("man_firefighter_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f692}, 0, 3));
		_addEntry("man_firefighter_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f692}, 0, 3));
		_addEntry("man_firefighter_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f692}, 0, 3));
		_addEntry("man_firefighter_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f692}, 0, 3));
		_addEntry("man_firefighter_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f692}, 0, 3));
		_addEntry("man_firefighter_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f692}, 0, 3));
		_addEntry("man_firefighter_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f692}, 0, 3));
		_addEntry("man_firefighter_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f692}, 0, 3));
		_addEntry("man_firefighter_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f692}, 0, 3));
		_addEntry("man_firefighter_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f692}, 0, 3));
		_addEntry("man_frowning", new String(new int[] {0x1f64d,0x2642}, 0, 2));
		_addEntry("man_frowning_dark_skin_tone", new String(new int[] {0x1f64d,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_frowning_light_skin_tone", new String(new int[] {0x1f64d,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_frowning_medium_dark_skin_tone", new String(new int[] {0x1f64d,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_frowning_medium_light_skin_tone", new String(new int[] {0x1f64d,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_frowning_medium_skin_tone", new String(new int[] {0x1f64d,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_frowning_tone1", new String(new int[] {0x1f64d,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_frowning_tone2", new String(new int[] {0x1f64d,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_frowning_tone3", new String(new int[] {0x1f64d,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_frowning_tone4", new String(new int[] {0x1f64d,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_frowning_tone5", new String(new int[] {0x1f64d,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_gesturing_no", new String(new int[] {0x1f645,0x2642}, 0, 2));
		_addEntry("man_gesturing_no_dark_skin_tone", new String(new int[] {0x1f645,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_gesturing_no_light_skin_tone", new String(new int[] {0x1f645,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_gesturing_no_medium_dark_skin_tone", new String(new int[] {0x1f645,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_gesturing_no_medium_light_skin_tone", new String(new int[] {0x1f645,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_gesturing_no_medium_skin_tone", new String(new int[] {0x1f645,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_gesturing_no_tone1", new String(new int[] {0x1f645,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_gesturing_no_tone2", new String(new int[] {0x1f645,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_gesturing_no_tone3", new String(new int[] {0x1f645,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_gesturing_no_tone4", new String(new int[] {0x1f645,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_gesturing_no_tone5", new String(new int[] {0x1f645,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_gesturing_ok", new String(new int[] {0x1f646,0x2642}, 0, 2));
		_addEntry("man_gesturing_ok_dark_skin_tone", new String(new int[] {0x1f646,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_gesturing_ok_light_skin_tone", new String(new int[] {0x1f646,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_gesturing_ok_medium_dark_skin_tone", new String(new int[] {0x1f646,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_gesturing_ok_medium_light_skin_tone", new String(new int[] {0x1f646,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_gesturing_ok_medium_skin_tone", new String(new int[] {0x1f646,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_gesturing_ok_tone1", new String(new int[] {0x1f646,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_gesturing_ok_tone2", new String(new int[] {0x1f646,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_gesturing_ok_tone3", new String(new int[] {0x1f646,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_gesturing_ok_tone4", new String(new int[] {0x1f646,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_gesturing_ok_tone5", new String(new int[] {0x1f646,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_getting_face_massage", new String(new int[] {0x1f486,0x2642}, 0, 2));
		_addEntry("man_getting_face_massage_dark_skin_tone", new String(new int[] {0x1f486,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_getting_face_massage_light_skin_tone", new String(new int[] {0x1f486,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_getting_face_massage_medium_dark_skin_tone", new String(new int[] {0x1f486,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_getting_face_massage_medium_light_skin_tone", new String(new int[] {0x1f486,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_getting_face_massage_medium_skin_tone", new String(new int[] {0x1f486,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_getting_face_massage_tone1", new String(new int[] {0x1f486,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_getting_face_massage_tone2", new String(new int[] {0x1f486,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_getting_face_massage_tone3", new String(new int[] {0x1f486,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_getting_face_massage_tone4", new String(new int[] {0x1f486,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_getting_face_massage_tone5", new String(new int[] {0x1f486,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_getting_haircut", new String(new int[] {0x1f487,0x2642}, 0, 2));
		_addEntry("man_getting_haircut_dark_skin_tone", new String(new int[] {0x1f487,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_getting_haircut_light_skin_tone", new String(new int[] {0x1f487,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_getting_haircut_medium_dark_skin_tone", new String(new int[] {0x1f487,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_getting_haircut_medium_light_skin_tone", new String(new int[] {0x1f487,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_getting_haircut_medium_skin_tone", new String(new int[] {0x1f487,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_getting_haircut_tone1", new String(new int[] {0x1f487,0x1f3fb,0x2642}, 0, 3));
	}
	private static void init16(){
		_addEntry("man_getting_haircut_tone2", new String(new int[] {0x1f487,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_getting_haircut_tone3", new String(new int[] {0x1f487,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_getting_haircut_tone4", new String(new int[] {0x1f487,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_getting_haircut_tone5", new String(new int[] {0x1f487,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_golfing", new String(new int[] {0x1f3cc,0x2642}, 0, 2));
		_addEntry("man_golfing_dark_skin_tone", new String(new int[] {0x1f3cc,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_golfing_light_skin_tone", new String(new int[] {0x1f3cc,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_golfing_medium_dark_skin_tone", new String(new int[] {0x1f3cc,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_golfing_medium_light_skin_tone", new String(new int[] {0x1f3cc,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_golfing_medium_skin_tone", new String(new int[] {0x1f3cc,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_golfing_tone1", new String(new int[] {0x1f3cc,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_golfing_tone2", new String(new int[] {0x1f3cc,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_golfing_tone3", new String(new int[] {0x1f3cc,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_golfing_tone4", new String(new int[] {0x1f3cc,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_golfing_tone5", new String(new int[] {0x1f3cc,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_guard", new String(new int[] {0x1f482,0x2642}, 0, 2));
		_addEntry("man_guard_dark_skin_tone", new String(new int[] {0x1f482,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_guard_light_skin_tone", new String(new int[] {0x1f482,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_guard_medium_dark_skin_tone", new String(new int[] {0x1f482,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_guard_medium_light_skin_tone", new String(new int[] {0x1f482,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_guard_medium_skin_tone", new String(new int[] {0x1f482,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_guard_tone1", new String(new int[] {0x1f482,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_guard_tone2", new String(new int[] {0x1f482,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_guard_tone3", new String(new int[] {0x1f482,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_guard_tone4", new String(new int[] {0x1f482,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_guard_tone5", new String(new int[] {0x1f482,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_health_worker", new String(new int[] {0x1f468,0x2695}, 0, 2));
		_addEntry("man_health_worker_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x2695}, 0, 3));
		_addEntry("man_health_worker_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x2695}, 0, 3));
		_addEntry("man_health_worker_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x2695}, 0, 3));
		_addEntry("man_health_worker_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x2695}, 0, 3));
		_addEntry("man_health_worker_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x2695}, 0, 3));
		_addEntry("man_health_worker_tone1", new String(new int[] {0x1f468,0x1f3fb,0x2695}, 0, 3));
		_addEntry("man_health_worker_tone2", new String(new int[] {0x1f468,0x1f3fc,0x2695}, 0, 3));
		_addEntry("man_health_worker_tone3", new String(new int[] {0x1f468,0x1f3fd,0x2695}, 0, 3));
		_addEntry("man_health_worker_tone4", new String(new int[] {0x1f468,0x1f3fe,0x2695}, 0, 3));
		_addEntry("man_health_worker_tone5", new String(new int[] {0x1f468,0x1f3ff,0x2695}, 0, 3));
		_addEntry("man_in_business_suit_levitating", new String(new int[] {0x1f574}, 0, 1));
		_addEntry("man_in_business_suit_levitating_dark_skin_tone", new String(new int[] {0x1f574,0x1f3ff}, 0, 2));
		_addEntry("man_in_business_suit_levitating_light_skin_tone", new String(new int[] {0x1f574,0x1f3fb}, 0, 2));
		_addEntry("man_in_business_suit_levitating_medium_dark_skin_tone", new String(new int[] {0x1f574,0x1f3fe}, 0, 2));
		_addEntry("man_in_business_suit_levitating_medium_light_skin_tone", new String(new int[] {0x1f574,0x1f3fc}, 0, 2));
		_addEntry("man_in_business_suit_levitating_medium_skin_tone", new String(new int[] {0x1f574,0x1f3fd}, 0, 2));
		_addEntry("man_in_business_suit_levitating_tone1", new String(new int[] {0x1f574,0x1f3fb}, 0, 2));
		_addEntry("man_in_business_suit_levitating_tone2", new String(new int[] {0x1f574,0x1f3fc}, 0, 2));
		_addEntry("man_in_business_suit_levitating_tone3", new String(new int[] {0x1f574,0x1f3fd}, 0, 2));
		_addEntry("man_in_business_suit_levitating_tone4", new String(new int[] {0x1f574,0x1f3fe}, 0, 2));
		_addEntry("man_in_business_suit_levitating_tone5", new String(new int[] {0x1f574,0x1f3ff}, 0, 2));
		_addEntry("man_in_tuxedo", new String(new int[] {0x1f935}, 0, 1));
		_addEntry("man_in_tuxedo_tone1", new String(new int[] {0x1f935,0x1f3fb}, 0, 2));
		_addEntry("man_in_tuxedo_tone2", new String(new int[] {0x1f935,0x1f3fc}, 0, 2));
		_addEntry("man_in_tuxedo_tone3", new String(new int[] {0x1f935,0x1f3fd}, 0, 2));
		_addEntry("man_in_tuxedo_tone4", new String(new int[] {0x1f935,0x1f3fe}, 0, 2));
		_addEntry("man_in_tuxedo_tone5", new String(new int[] {0x1f935,0x1f3ff}, 0, 2));
		_addEntry("man_judge", new String(new int[] {0x1f468,0x2696}, 0, 2));
		_addEntry("man_judge_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x2696}, 0, 3));
		_addEntry("man_judge_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x2696}, 0, 3));
		_addEntry("man_judge_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x2696}, 0, 3));
		_addEntry("man_judge_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x2696}, 0, 3));
		_addEntry("man_judge_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x2696}, 0, 3));
		_addEntry("man_judge_tone1", new String(new int[] {0x1f468,0x1f3fb,0x2696}, 0, 3));
		_addEntry("man_judge_tone2", new String(new int[] {0x1f468,0x1f3fc,0x2696}, 0, 3));
		_addEntry("man_judge_tone3", new String(new int[] {0x1f468,0x1f3fd,0x2696}, 0, 3));
		_addEntry("man_judge_tone4", new String(new int[] {0x1f468,0x1f3fe,0x2696}, 0, 3));
		_addEntry("man_judge_tone5", new String(new int[] {0x1f468,0x1f3ff,0x2696}, 0, 3));
		_addEntry("man_juggling", new String(new int[] {0x1f939,0x2642}, 0, 2));
		_addEntry("man_juggling_dark_skin_tone", new String(new int[] {0x1f939,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_juggling_light_skin_tone", new String(new int[] {0x1f939,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_juggling_medium_dark_skin_tone", new String(new int[] {0x1f939,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_juggling_medium_light_skin_tone", new String(new int[] {0x1f939,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_juggling_medium_skin_tone", new String(new int[] {0x1f939,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_juggling_tone1", new String(new int[] {0x1f939,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_juggling_tone2", new String(new int[] {0x1f939,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_juggling_tone3", new String(new int[] {0x1f939,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_juggling_tone4", new String(new int[] {0x1f939,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_juggling_tone5", new String(new int[] {0x1f939,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_lifting_weights", new String(new int[] {0x1f3cb,0x2642}, 0, 2));
		_addEntry("man_lifting_weights_dark_skin_tone", new String(new int[] {0x1f3cb,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_lifting_weights_light_skin_tone", new String(new int[] {0x1f3cb,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_lifting_weights_medium_dark_skin_tone", new String(new int[] {0x1f3cb,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_lifting_weights_medium_light_skin_tone", new String(new int[] {0x1f3cb,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_lifting_weights_medium_skin_tone", new String(new int[] {0x1f3cb,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_lifting_weights_tone1", new String(new int[] {0x1f3cb,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_lifting_weights_tone2", new String(new int[] {0x1f3cb,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_lifting_weights_tone3", new String(new int[] {0x1f3cb,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_lifting_weights_tone4", new String(new int[] {0x1f3cb,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_lifting_weights_tone5", new String(new int[] {0x1f3cb,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_mechanic", new String(new int[] {0x1f468,0x1f527}, 0, 2));
		_addEntry("man_mechanic_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f527}, 0, 3));
		_addEntry("man_mechanic_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f527}, 0, 3));
		_addEntry("man_mechanic_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f527}, 0, 3));
		_addEntry("man_mechanic_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f527}, 0, 3));
		_addEntry("man_mechanic_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f527}, 0, 3));
		_addEntry("man_mechanic_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f527}, 0, 3));
		_addEntry("man_mechanic_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f527}, 0, 3));
		_addEntry("man_mechanic_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f527}, 0, 3));
		_addEntry("man_mechanic_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f527}, 0, 3));
		_addEntry("man_mechanic_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f527}, 0, 3));
		_addEntry("man_mountain_biking", new String(new int[] {0x1f6b5,0x2642}, 0, 2));
		_addEntry("man_mountain_biking_dark_skin_tone", new String(new int[] {0x1f6b5,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_mountain_biking_light_skin_tone", new String(new int[] {0x1f6b5,0x1f3fb,0x2642}, 0, 3));
	}
	private static void init17(){
		_addEntry("man_mountain_biking_medium_dark_skin_tone", new String(new int[] {0x1f6b5,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_mountain_biking_medium_light_skin_tone", new String(new int[] {0x1f6b5,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_mountain_biking_medium_skin_tone", new String(new int[] {0x1f6b5,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_mountain_biking_tone1", new String(new int[] {0x1f6b5,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_mountain_biking_tone2", new String(new int[] {0x1f6b5,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_mountain_biking_tone3", new String(new int[] {0x1f6b5,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_mountain_biking_tone4", new String(new int[] {0x1f6b5,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_mountain_biking_tone5", new String(new int[] {0x1f6b5,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_office_worker", new String(new int[] {0x1f468,0x1f4bc}, 0, 2));
		_addEntry("man_office_worker_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f4bc}, 0, 3));
		_addEntry("man_office_worker_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f4bc}, 0, 3));
		_addEntry("man_office_worker_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f4bc}, 0, 3));
		_addEntry("man_office_worker_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f4bc}, 0, 3));
		_addEntry("man_office_worker_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f4bc}, 0, 3));
		_addEntry("man_office_worker_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f4bc}, 0, 3));
		_addEntry("man_office_worker_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f4bc}, 0, 3));
		_addEntry("man_office_worker_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f4bc}, 0, 3));
		_addEntry("man_office_worker_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f4bc}, 0, 3));
		_addEntry("man_office_worker_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f4bc}, 0, 3));
		_addEntry("man_pilot", new String(new int[] {0x1f468,0x2708}, 0, 2));
		_addEntry("man_pilot_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x2708}, 0, 3));
		_addEntry("man_pilot_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x2708}, 0, 3));
		_addEntry("man_pilot_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x2708}, 0, 3));
		_addEntry("man_pilot_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x2708}, 0, 3));
		_addEntry("man_pilot_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x2708}, 0, 3));
		_addEntry("man_pilot_tone1", new String(new int[] {0x1f468,0x1f3fb,0x2708}, 0, 3));
		_addEntry("man_pilot_tone2", new String(new int[] {0x1f468,0x1f3fc,0x2708}, 0, 3));
		_addEntry("man_pilot_tone3", new String(new int[] {0x1f468,0x1f3fd,0x2708}, 0, 3));
		_addEntry("man_pilot_tone4", new String(new int[] {0x1f468,0x1f3fe,0x2708}, 0, 3));
		_addEntry("man_pilot_tone5", new String(new int[] {0x1f468,0x1f3ff,0x2708}, 0, 3));
		_addEntry("man_playing_handball", new String(new int[] {0x1f93e,0x2642}, 0, 2));
		_addEntry("man_playing_handball_dark_skin_tone", new String(new int[] {0x1f93e,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_playing_handball_light_skin_tone", new String(new int[] {0x1f93e,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_playing_handball_medium_dark_skin_tone", new String(new int[] {0x1f93e,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_playing_handball_medium_light_skin_tone", new String(new int[] {0x1f93e,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_playing_handball_medium_skin_tone", new String(new int[] {0x1f93e,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_playing_handball_tone1", new String(new int[] {0x1f93e,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_playing_handball_tone2", new String(new int[] {0x1f93e,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_playing_handball_tone3", new String(new int[] {0x1f93e,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_playing_handball_tone4", new String(new int[] {0x1f93e,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_playing_handball_tone5", new String(new int[] {0x1f93e,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_playing_water_polo", new String(new int[] {0x1f93d,0x2642}, 0, 2));
		_addEntry("man_playing_water_polo_dark_skin_tone", new String(new int[] {0x1f93d,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_playing_water_polo_light_skin_tone", new String(new int[] {0x1f93d,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_playing_water_polo_medium_dark_skin_tone", new String(new int[] {0x1f93d,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_playing_water_polo_medium_light_skin_tone", new String(new int[] {0x1f93d,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_playing_water_polo_medium_skin_tone", new String(new int[] {0x1f93d,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_playing_water_polo_tone1", new String(new int[] {0x1f93d,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_playing_water_polo_tone2", new String(new int[] {0x1f93d,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_playing_water_polo_tone3", new String(new int[] {0x1f93d,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_playing_water_polo_tone4", new String(new int[] {0x1f93d,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_playing_water_polo_tone5", new String(new int[] {0x1f93d,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_police_officer", new String(new int[] {0x1f46e,0x2642}, 0, 2));
		_addEntry("man_police_officer_dark_skin_tone", new String(new int[] {0x1f46e,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_police_officer_light_skin_tone", new String(new int[] {0x1f46e,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_police_officer_medium_dark_skin_tone", new String(new int[] {0x1f46e,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_police_officer_medium_light_skin_tone", new String(new int[] {0x1f46e,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_police_officer_medium_skin_tone", new String(new int[] {0x1f46e,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_police_officer_tone1", new String(new int[] {0x1f46e,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_police_officer_tone2", new String(new int[] {0x1f46e,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_police_officer_tone3", new String(new int[] {0x1f46e,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_police_officer_tone4", new String(new int[] {0x1f46e,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_police_officer_tone5", new String(new int[] {0x1f46e,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_pouting", new String(new int[] {0x1f64e,0x2642}, 0, 2));
		_addEntry("man_pouting_dark_skin_tone", new String(new int[] {0x1f64e,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_pouting_light_skin_tone", new String(new int[] {0x1f64e,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_pouting_medium_dark_skin_tone", new String(new int[] {0x1f64e,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_pouting_medium_light_skin_tone", new String(new int[] {0x1f64e,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_pouting_medium_skin_tone", new String(new int[] {0x1f64e,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_pouting_tone1", new String(new int[] {0x1f64e,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_pouting_tone2", new String(new int[] {0x1f64e,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_pouting_tone3", new String(new int[] {0x1f64e,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_pouting_tone4", new String(new int[] {0x1f64e,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_pouting_tone5", new String(new int[] {0x1f64e,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_raising_hand", new String(new int[] {0x1f64b,0x2642}, 0, 2));
		_addEntry("man_raising_hand_dark_skin_tone", new String(new int[] {0x1f64b,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_raising_hand_light_skin_tone", new String(new int[] {0x1f64b,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_raising_hand_medium_dark_skin_tone", new String(new int[] {0x1f64b,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_raising_hand_medium_light_skin_tone", new String(new int[] {0x1f64b,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_raising_hand_medium_skin_tone", new String(new int[] {0x1f64b,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_raising_hand_tone1", new String(new int[] {0x1f64b,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_raising_hand_tone2", new String(new int[] {0x1f64b,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_raising_hand_tone3", new String(new int[] {0x1f64b,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_raising_hand_tone4", new String(new int[] {0x1f64b,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_raising_hand_tone5", new String(new int[] {0x1f64b,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_rowing_boat", new String(new int[] {0x1f6a3,0x2642}, 0, 2));
		_addEntry("man_rowing_boat_dark_skin_tone", new String(new int[] {0x1f6a3,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_rowing_boat_light_skin_tone", new String(new int[] {0x1f6a3,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_rowing_boat_medium_dark_skin_tone", new String(new int[] {0x1f6a3,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_rowing_boat_medium_light_skin_tone", new String(new int[] {0x1f6a3,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_rowing_boat_medium_skin_tone", new String(new int[] {0x1f6a3,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_rowing_boat_tone1", new String(new int[] {0x1f6a3,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_rowing_boat_tone2", new String(new int[] {0x1f6a3,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_rowing_boat_tone3", new String(new int[] {0x1f6a3,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_rowing_boat_tone4", new String(new int[] {0x1f6a3,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_rowing_boat_tone5", new String(new int[] {0x1f6a3,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_running", new String(new int[] {0x1f3c3,0x2642}, 0, 2));
		_addEntry("man_running_dark_skin_tone", new String(new int[] {0x1f3c3,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_running_light_skin_tone", new String(new int[] {0x1f3c3,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_running_medium_dark_skin_tone", new String(new int[] {0x1f3c3,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_running_medium_light_skin_tone", new String(new int[] {0x1f3c3,0x1f3fc,0x2642}, 0, 3));
	}
	private static void init18(){
		_addEntry("man_running_medium_skin_tone", new String(new int[] {0x1f3c3,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_running_tone1", new String(new int[] {0x1f3c3,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_running_tone2", new String(new int[] {0x1f3c3,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_running_tone3", new String(new int[] {0x1f3c3,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_running_tone4", new String(new int[] {0x1f3c3,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_running_tone5", new String(new int[] {0x1f3c3,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_scientist", new String(new int[] {0x1f468,0x1f52c}, 0, 2));
		_addEntry("man_scientist_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f52c}, 0, 3));
		_addEntry("man_scientist_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f52c}, 0, 3));
		_addEntry("man_scientist_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f52c}, 0, 3));
		_addEntry("man_scientist_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f52c}, 0, 3));
		_addEntry("man_scientist_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f52c}, 0, 3));
		_addEntry("man_scientist_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f52c}, 0, 3));
		_addEntry("man_scientist_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f52c}, 0, 3));
		_addEntry("man_scientist_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f52c}, 0, 3));
		_addEntry("man_scientist_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f52c}, 0, 3));
		_addEntry("man_scientist_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f52c}, 0, 3));
		_addEntry("man_shrugging", new String(new int[] {0x1f937,0x2642}, 0, 2));
		_addEntry("man_shrugging_dark_skin_tone", new String(new int[] {0x1f937,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_shrugging_light_skin_tone", new String(new int[] {0x1f937,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_shrugging_medium_dark_skin_tone", new String(new int[] {0x1f937,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_shrugging_medium_light_skin_tone", new String(new int[] {0x1f937,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_shrugging_medium_skin_tone", new String(new int[] {0x1f937,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_shrugging_tone1", new String(new int[] {0x1f937,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_shrugging_tone2", new String(new int[] {0x1f937,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_shrugging_tone3", new String(new int[] {0x1f937,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_shrugging_tone4", new String(new int[] {0x1f937,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_shrugging_tone5", new String(new int[] {0x1f937,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_singer", new String(new int[] {0x1f468,0x1f3a4}, 0, 2));
		_addEntry("man_singer_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f3a4}, 0, 3));
		_addEntry("man_singer_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f3a4}, 0, 3));
		_addEntry("man_singer_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f3a4}, 0, 3));
		_addEntry("man_singer_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f3a4}, 0, 3));
		_addEntry("man_singer_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f3a4}, 0, 3));
		_addEntry("man_singer_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f3a4}, 0, 3));
		_addEntry("man_singer_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f3a4}, 0, 3));
		_addEntry("man_singer_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f3a4}, 0, 3));
		_addEntry("man_singer_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f3a4}, 0, 3));
		_addEntry("man_singer_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f3a4}, 0, 3));
		_addEntry("man_student", new String(new int[] {0x1f468,0x1f393}, 0, 2));
		_addEntry("man_student_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f393}, 0, 3));
		_addEntry("man_student_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f393}, 0, 3));
		_addEntry("man_student_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f393}, 0, 3));
		_addEntry("man_student_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f393}, 0, 3));
		_addEntry("man_student_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f393}, 0, 3));
		_addEntry("man_student_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f393}, 0, 3));
		_addEntry("man_student_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f393}, 0, 3));
		_addEntry("man_student_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f393}, 0, 3));
		_addEntry("man_student_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f393}, 0, 3));
		_addEntry("man_student_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f393}, 0, 3));
		_addEntry("man_surfing", new String(new int[] {0x1f3c4,0x2642}, 0, 2));
		_addEntry("man_surfing_dark_skin_tone", new String(new int[] {0x1f3c4,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_surfing_light_skin_tone", new String(new int[] {0x1f3c4,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_surfing_medium_dark_skin_tone", new String(new int[] {0x1f3c4,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_surfing_medium_light_skin_tone", new String(new int[] {0x1f3c4,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_surfing_medium_skin_tone", new String(new int[] {0x1f3c4,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_surfing_tone1", new String(new int[] {0x1f3c4,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_surfing_tone2", new String(new int[] {0x1f3c4,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_surfing_tone3", new String(new int[] {0x1f3c4,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_surfing_tone4", new String(new int[] {0x1f3c4,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_surfing_tone5", new String(new int[] {0x1f3c4,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_swimming", new String(new int[] {0x1f3ca,0x2642}, 0, 2));
		_addEntry("man_swimming_dark_skin_tone", new String(new int[] {0x1f3ca,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_swimming_light_skin_tone", new String(new int[] {0x1f3ca,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_swimming_medium_dark_skin_tone", new String(new int[] {0x1f3ca,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_swimming_medium_light_skin_tone", new String(new int[] {0x1f3ca,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_swimming_medium_skin_tone", new String(new int[] {0x1f3ca,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_swimming_tone1", new String(new int[] {0x1f3ca,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_swimming_tone2", new String(new int[] {0x1f3ca,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_swimming_tone3", new String(new int[] {0x1f3ca,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_swimming_tone4", new String(new int[] {0x1f3ca,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_swimming_tone5", new String(new int[] {0x1f3ca,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_teacher", new String(new int[] {0x1f468,0x1f3eb}, 0, 2));
		_addEntry("man_teacher_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f3eb}, 0, 3));
		_addEntry("man_teacher_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f3eb}, 0, 3));
		_addEntry("man_teacher_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f3eb}, 0, 3));
		_addEntry("man_teacher_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f3eb}, 0, 3));
		_addEntry("man_teacher_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f3eb}, 0, 3));
		_addEntry("man_teacher_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f3eb}, 0, 3));
		_addEntry("man_teacher_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f3eb}, 0, 3));
		_addEntry("man_teacher_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f3eb}, 0, 3));
		_addEntry("man_teacher_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f3eb}, 0, 3));
		_addEntry("man_teacher_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f3eb}, 0, 3));
		_addEntry("man_technologist", new String(new int[] {0x1f468,0x1f4bb}, 0, 2));
		_addEntry("man_technologist_dark_skin_tone", new String(new int[] {0x1f468,0x1f3ff,0x1f4bb}, 0, 3));
		_addEntry("man_technologist_light_skin_tone", new String(new int[] {0x1f468,0x1f3fb,0x1f4bb}, 0, 3));
		_addEntry("man_technologist_medium_dark_skin_tone", new String(new int[] {0x1f468,0x1f3fe,0x1f4bb}, 0, 3));
		_addEntry("man_technologist_medium_light_skin_tone", new String(new int[] {0x1f468,0x1f3fc,0x1f4bb}, 0, 3));
		_addEntry("man_technologist_medium_skin_tone", new String(new int[] {0x1f468,0x1f3fd,0x1f4bb}, 0, 3));
		_addEntry("man_technologist_tone1", new String(new int[] {0x1f468,0x1f3fb,0x1f4bb}, 0, 3));
		_addEntry("man_technologist_tone2", new String(new int[] {0x1f468,0x1f3fc,0x1f4bb}, 0, 3));
		_addEntry("man_technologist_tone3", new String(new int[] {0x1f468,0x1f3fd,0x1f4bb}, 0, 3));
		_addEntry("man_technologist_tone4", new String(new int[] {0x1f468,0x1f3fe,0x1f4bb}, 0, 3));
		_addEntry("man_technologist_tone5", new String(new int[] {0x1f468,0x1f3ff,0x1f4bb}, 0, 3));
		_addEntry("man_tipping_hand", new String(new int[] {0x1f481,0x2642}, 0, 2));
		_addEntry("man_tipping_hand_dark_skin_tone", new String(new int[] {0x1f481,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_tipping_hand_light_skin_tone", new String(new int[] {0x1f481,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_tipping_hand_medium_dark_skin_tone", new String(new int[] {0x1f481,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_tipping_hand_medium_light_skin_tone", new String(new int[] {0x1f481,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_tipping_hand_medium_skin_tone", new String(new int[] {0x1f481,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_tipping_hand_tone1", new String(new int[] {0x1f481,0x1f3fb,0x2642}, 0, 3));
	}
	private static void init19(){
		_addEntry("man_tipping_hand_tone2", new String(new int[] {0x1f481,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_tipping_hand_tone3", new String(new int[] {0x1f481,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_tipping_hand_tone4", new String(new int[] {0x1f481,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_tipping_hand_tone5", new String(new int[] {0x1f481,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_tone1", new String(new int[] {0x1f468,0x1f3fb}, 0, 2));
		_addEntry("man_tone2", new String(new int[] {0x1f468,0x1f3fc}, 0, 2));
		_addEntry("man_tone3", new String(new int[] {0x1f468,0x1f3fd}, 0, 2));
		_addEntry("man_tone4", new String(new int[] {0x1f468,0x1f3fe}, 0, 2));
		_addEntry("man_tone5", new String(new int[] {0x1f468,0x1f3ff}, 0, 2));
		_addEntry("man_walking", new String(new int[] {0x1f6b6,0x2642}, 0, 2));
		_addEntry("man_walking_dark_skin_tone", new String(new int[] {0x1f6b6,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_walking_light_skin_tone", new String(new int[] {0x1f6b6,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_walking_medium_dark_skin_tone", new String(new int[] {0x1f6b6,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_walking_medium_light_skin_tone", new String(new int[] {0x1f6b6,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_walking_medium_skin_tone", new String(new int[] {0x1f6b6,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_walking_tone1", new String(new int[] {0x1f6b6,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_walking_tone2", new String(new int[] {0x1f6b6,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_walking_tone3", new String(new int[] {0x1f6b6,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_walking_tone4", new String(new int[] {0x1f6b6,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_walking_tone5", new String(new int[] {0x1f6b6,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_wearing_turban", new String(new int[] {0x1f473,0x2642}, 0, 2));
		_addEntry("man_wearing_turban_dark_skin_tone", new String(new int[] {0x1f473,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_wearing_turban_light_skin_tone", new String(new int[] {0x1f473,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_wearing_turban_medium_dark_skin_tone", new String(new int[] {0x1f473,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_wearing_turban_medium_light_skin_tone", new String(new int[] {0x1f473,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_wearing_turban_medium_skin_tone", new String(new int[] {0x1f473,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_wearing_turban_tone1", new String(new int[] {0x1f473,0x1f3fb,0x2642}, 0, 3));
		_addEntry("man_wearing_turban_tone2", new String(new int[] {0x1f473,0x1f3fc,0x2642}, 0, 3));
		_addEntry("man_wearing_turban_tone3", new String(new int[] {0x1f473,0x1f3fd,0x2642}, 0, 3));
		_addEntry("man_wearing_turban_tone4", new String(new int[] {0x1f473,0x1f3fe,0x2642}, 0, 3));
		_addEntry("man_wearing_turban_tone5", new String(new int[] {0x1f473,0x1f3ff,0x2642}, 0, 3));
		_addEntry("man_with_gua_pi_mao", new String(new int[] {0x1f472}, 0, 1));
		_addEntry("man_with_gua_pi_mao_tone1", new String(new int[] {0x1f472,0x1f3fb}, 0, 2));
		_addEntry("man_with_gua_pi_mao_tone2", new String(new int[] {0x1f472,0x1f3fc}, 0, 2));
		_addEntry("man_with_gua_pi_mao_tone3", new String(new int[] {0x1f472,0x1f3fd}, 0, 2));
		_addEntry("man_with_gua_pi_mao_tone4", new String(new int[] {0x1f472,0x1f3fe}, 0, 2));
		_addEntry("man_with_gua_pi_mao_tone5", new String(new int[] {0x1f472,0x1f3ff}, 0, 2));
		_addEntry("man_with_turban", new String(new int[] {0x1f473}, 0, 1));
		_addEntry("man_with_turban_tone1", new String(new int[] {0x1f473,0x1f3fb}, 0, 2));
		_addEntry("man_with_turban_tone2", new String(new int[] {0x1f473,0x1f3fc}, 0, 2));
		_addEntry("man_with_turban_tone3", new String(new int[] {0x1f473,0x1f3fd}, 0, 2));
		_addEntry("man_with_turban_tone4", new String(new int[] {0x1f473,0x1f3fe}, 0, 2));
		_addEntry("man_with_turban_tone5", new String(new int[] {0x1f473,0x1f3ff}, 0, 2));
		_addEntry("mans_shoe", new String(new int[] {0x1f45e}, 0, 1));
		_addEntry("mantlepiece_clock", new String(new int[] {0x1f570}, 0, 1));
		_addEntry("map", new String(new int[] {0x1f5fa}, 0, 1));
		_addEntry("maple_leaf", new String(new int[] {0x1f341}, 0, 1));
		_addEntry("martial_arts_uniform", new String(new int[] {0x1f94b}, 0, 1));
		_addEntry("mask", new String(new int[] {0x1f637}, 0, 1));
		_addEntry("massage", new String(new int[] {0x1f486}, 0, 1));
		_addEntry("massage_tone1", new String(new int[] {0x1f486,0x1f3fb}, 0, 2));
		_addEntry("massage_tone2", new String(new int[] {0x1f486,0x1f3fc}, 0, 2));
		_addEntry("massage_tone3", new String(new int[] {0x1f486,0x1f3fd}, 0, 2));
		_addEntry("massage_tone4", new String(new int[] {0x1f486,0x1f3fe}, 0, 2));
		_addEntry("massage_tone5", new String(new int[] {0x1f486,0x1f3ff}, 0, 2));
		_addEntry("mc", new String(new int[] {0x1f1f2,0x1f1e8}, 0, 2));
		_addEntry("md", new String(new int[] {0x1f1f2,0x1f1e9}, 0, 2));
		_addEntry("me", new String(new int[] {0x1f1f2,0x1f1ea}, 0, 2));
		_addEntry("meat_on_bone", new String(new int[] {0x1f356}, 0, 1));
		_addEntry("medal", new String(new int[] {0x1f3c5}, 0, 1));
		_addEntry("medical_symbol", new String(new int[] {0x2695}, 0, 1));
		_addEntry("mega", new String(new int[] {0x1f4e3}, 0, 1));
		_addEntry("melon", new String(new int[] {0x1f348}, 0, 1));
		_addEntry("men_with_bunny_ears_partying", new String(new int[] {0x1f46f,0x2642}, 0, 2));
		_addEntry("men_wrestling", new String(new int[] {0x1f93c,0x2642}, 0, 2));
		_addEntry("menorah", new String(new int[] {0x1f54e}, 0, 1));
		_addEntry("mens", new String(new int[] {0x1f6b9}, 0, 1));
		_addEntry("metal", new String(new int[] {0x1f918}, 0, 1));
		_addEntry("metal_tone1", new String(new int[] {0x1f918,0x1f3fb}, 0, 2));
		_addEntry("metal_tone2", new String(new int[] {0x1f918,0x1f3fc}, 0, 2));
		_addEntry("metal_tone3", new String(new int[] {0x1f918,0x1f3fd}, 0, 2));
		_addEntry("metal_tone4", new String(new int[] {0x1f918,0x1f3fe}, 0, 2));
		_addEntry("metal_tone5", new String(new int[] {0x1f918,0x1f3ff}, 0, 2));
		_addEntry("metro", new String(new int[] {0x1f687}, 0, 1));
		_addEntry("mf", new String(new int[] {0x1f1f2,0x1f1eb}, 0, 2));
		_addEntry("mg", new String(new int[] {0x1f1f2,0x1f1ec}, 0, 2));
		_addEntry("mh", new String(new int[] {0x1f1f2,0x1f1ed}, 0, 2));
		_addEntry("microphone", new String(new int[] {0x1f3a4}, 0, 1));
		_addEntry("microphone2", new String(new int[] {0x1f399}, 0, 1));
		_addEntry("microscope", new String(new int[] {0x1f52c}, 0, 1));
		_addEntry("middle_finger", new String(new int[] {0x1f595}, 0, 1));
		_addEntry("middle_finger_tone1", new String(new int[] {0x1f595,0x1f3fb}, 0, 2));
		_addEntry("middle_finger_tone2", new String(new int[] {0x1f595,0x1f3fc}, 0, 2));
		_addEntry("middle_finger_tone3", new String(new int[] {0x1f595,0x1f3fd}, 0, 2));
		_addEntry("middle_finger_tone4", new String(new int[] {0x1f595,0x1f3fe}, 0, 2));
		_addEntry("middle_finger_tone5", new String(new int[] {0x1f595,0x1f3ff}, 0, 2));
		_addEntry("military_medal", new String(new int[] {0x1f396}, 0, 1));
		_addEntry("milk", new String(new int[] {0x1f95b}, 0, 1));
		_addEntry("milky_way", new String(new int[] {0x1f30c}, 0, 1));
		_addEntry("minibus", new String(new int[] {0x1f690}, 0, 1));
		_addEntry("minidisc", new String(new int[] {0x1f4bd}, 0, 1));
		_addEntry("mk", new String(new int[] {0x1f1f2,0x1f1f0}, 0, 2));
		_addEntry("ml", new String(new int[] {0x1f1f2,0x1f1f1}, 0, 2));
		_addEntry("mm", new String(new int[] {0x1f1f2,0x1f1f2}, 0, 2));
		_addEntry("mn", new String(new int[] {0x1f1f2,0x1f1f3}, 0, 2));
		_addEntry("mo", new String(new int[] {0x1f1f2,0x1f1f4}, 0, 2));
		_addEntry("mobile_phone_off", new String(new int[] {0x1f4f4}, 0, 1));
		_addEntry("money_mouth", new String(new int[] {0x1f911}, 0, 1));
		_addEntry("money_mouth_face", new String(new int[] {0x1f911}, 0, 1));
		_addEntry("money_with_wings", new String(new int[] {0x1f4b8}, 0, 1));
		_addEntry("moneybag", new String(new int[] {0x1f4b0}, 0, 1));
	}
	private static void init20(){
		_addEntry("monkey", new String(new int[] {0x1f412}, 0, 1));
		_addEntry("monkey_face", new String(new int[] {0x1f435}, 0, 1));
		_addEntry("monorail", new String(new int[] {0x1f69d}, 0, 1));
		_addEntry("mortar_board", new String(new int[] {0x1f393}, 0, 1));
		_addEntry("mosque", new String(new int[] {0x1f54c}, 0, 1));
		_addEntry("mother_christmas", new String(new int[] {0x1f936}, 0, 1));
		_addEntry("mother_christmas_tone1", new String(new int[] {0x1f936,0x1f3fb}, 0, 2));
		_addEntry("mother_christmas_tone2", new String(new int[] {0x1f936,0x1f3fc}, 0, 2));
		_addEntry("mother_christmas_tone3", new String(new int[] {0x1f936,0x1f3fd}, 0, 2));
		_addEntry("mother_christmas_tone4", new String(new int[] {0x1f936,0x1f3fe}, 0, 2));
		_addEntry("mother_christmas_tone5", new String(new int[] {0x1f936,0x1f3ff}, 0, 2));
		_addEntry("motor_scooter", new String(new int[] {0x1f6f5}, 0, 1));
		_addEntry("motorbike", new String(new int[] {0x1f6f5}, 0, 1));
		_addEntry("motorboat", new String(new int[] {0x1f6e5}, 0, 1));
		_addEntry("motorcycle", new String(new int[] {0x1f3cd}, 0, 1));
		_addEntry("motorway", new String(new int[] {0x1f6e3}, 0, 1));
		_addEntry("mount_fuji", new String(new int[] {0x1f5fb}, 0, 1));
		_addEntry("mountain", new String(new int[] {0x26f0}, 0, 1));
		_addEntry("mountain_bicyclist", new String(new int[] {0x1f6b5}, 0, 1));
		_addEntry("mountain_bicyclist_tone1", new String(new int[] {0x1f6b5,0x1f3fb}, 0, 2));
		_addEntry("mountain_bicyclist_tone2", new String(new int[] {0x1f6b5,0x1f3fc}, 0, 2));
		_addEntry("mountain_bicyclist_tone3", new String(new int[] {0x1f6b5,0x1f3fd}, 0, 2));
		_addEntry("mountain_bicyclist_tone4", new String(new int[] {0x1f6b5,0x1f3fe}, 0, 2));
		_addEntry("mountain_bicyclist_tone5", new String(new int[] {0x1f6b5,0x1f3ff}, 0, 2));
		_addEntry("mountain_cableway", new String(new int[] {0x1f6a0}, 0, 1));
		_addEntry("mountain_railway", new String(new int[] {0x1f69e}, 0, 1));
		_addEntry("mountain_snow", new String(new int[] {0x1f3d4}, 0, 1));
		_addEntry("mouse", new String(new int[] {0x1f42d}, 0, 1));
		_addEntry("mouse2", new String(new int[] {0x1f401}, 0, 1));
		_addEntry("mouse_three_button", new String(new int[] {0x1f5b1}, 0, 1));
		_addEntry("movie_camera", new String(new int[] {0x1f3a5}, 0, 1));
		_addEntry("moyai", new String(new int[] {0x1f5ff}, 0, 1));
		_addEntry("mp", new String(new int[] {0x1f1f2,0x1f1f5}, 0, 2));
		_addEntry("mq", new String(new int[] {0x1f1f2,0x1f1f6}, 0, 2));
		_addEntry("mr", new String(new int[] {0x1f1f2,0x1f1f7}, 0, 2));
		_addEntry("mrs_claus", new String(new int[] {0x1f936}, 0, 1));
		_addEntry("mrs_claus_tone1", new String(new int[] {0x1f936,0x1f3fb}, 0, 2));
		_addEntry("mrs_claus_tone2", new String(new int[] {0x1f936,0x1f3fc}, 0, 2));
		_addEntry("mrs_claus_tone3", new String(new int[] {0x1f936,0x1f3fd}, 0, 2));
		_addEntry("mrs_claus_tone4", new String(new int[] {0x1f936,0x1f3fe}, 0, 2));
		_addEntry("mrs_claus_tone5", new String(new int[] {0x1f936,0x1f3ff}, 0, 2));
		_addEntry("ms", new String(new int[] {0x1f1f2,0x1f1f8}, 0, 2));
		_addEntry("mt", new String(new int[] {0x1f1f2,0x1f1f9}, 0, 2));
		_addEntry("mu", new String(new int[] {0x1f1f2,0x1f1fa}, 0, 2));
		_addEntry("muscle", new String(new int[] {0x1f4aa}, 0, 1));
		_addEntry("muscle_tone1", new String(new int[] {0x1f4aa,0x1f3fb}, 0, 2));
		_addEntry("muscle_tone2", new String(new int[] {0x1f4aa,0x1f3fc}, 0, 2));
		_addEntry("muscle_tone3", new String(new int[] {0x1f4aa,0x1f3fd}, 0, 2));
		_addEntry("muscle_tone4", new String(new int[] {0x1f4aa,0x1f3fe}, 0, 2));
		_addEntry("muscle_tone5", new String(new int[] {0x1f4aa,0x1f3ff}, 0, 2));
		_addEntry("mushroom", new String(new int[] {0x1f344}, 0, 1));
		_addEntry("musical_keyboard", new String(new int[] {0x1f3b9}, 0, 1));
		_addEntry("musical_note", new String(new int[] {0x1f3b5}, 0, 1));
		_addEntry("musical_score", new String(new int[] {0x1f3bc}, 0, 1));
		_addEntry("mute", new String(new int[] {0x1f507}, 0, 1));
		_addEntry("mv", new String(new int[] {0x1f1f2,0x1f1fb}, 0, 2));
		_addEntry("mw", new String(new int[] {0x1f1f2,0x1f1fc}, 0, 2));
		_addEntry("mx", new String(new int[] {0x1f1f2,0x1f1fd}, 0, 2));
		_addEntry("my", new String(new int[] {0x1f1f2,0x1f1fe}, 0, 2));
		_addEntry("mz", new String(new int[] {0x1f1f2,0x1f1ff}, 0, 2));
		_addEntry("na", new String(new int[] {0x1f1f3,0x1f1e6}, 0, 2));
		_addEntry("nail_care", new String(new int[] {0x1f485}, 0, 1));
		_addEntry("nail_care_tone1", new String(new int[] {0x1f485,0x1f3fb}, 0, 2));
		_addEntry("nail_care_tone2", new String(new int[] {0x1f485,0x1f3fc}, 0, 2));
		_addEntry("nail_care_tone3", new String(new int[] {0x1f485,0x1f3fd}, 0, 2));
		_addEntry("nail_care_tone4", new String(new int[] {0x1f485,0x1f3fe}, 0, 2));
		_addEntry("nail_care_tone5", new String(new int[] {0x1f485,0x1f3ff}, 0, 2));
		_addEntry("name_badge", new String(new int[] {0x1f4db}, 0, 1));
		_addEntry("national_park", new String(new int[] {0x1f3de}, 0, 1));
		_addEntry("nauseated_face", new String(new int[] {0x1f922}, 0, 1));
		_addEntry("nc", new String(new int[] {0x1f1f3,0x1f1e8}, 0, 2));
		_addEntry("ne", new String(new int[] {0x1f1f3,0x1f1ea}, 0, 2));
		_addEntry("necktie", new String(new int[] {0x1f454}, 0, 1));
		_addEntry("negative_squared_cross_mark", new String(new int[] {0x274e}, 0, 1));
		_addEntry("nerd", new String(new int[] {0x1f913}, 0, 1));
		_addEntry("nerd_face", new String(new int[] {0x1f913}, 0, 1));
		_addEntry("neutral_face", new String(new int[] {0x1f610}, 0, 1));
		_addEntry("new", new String(new int[] {0x1f195}, 0, 1));
		_addEntry("new_moon", new String(new int[] {0x1f311}, 0, 1));
		_addEntry("new_moon_with_face", new String(new int[] {0x1f31a}, 0, 1));
		_addEntry("newspaper", new String(new int[] {0x1f4f0}, 0, 1));
		_addEntry("newspaper2", new String(new int[] {0x1f5de}, 0, 1));
		_addEntry("next_track", new String(new int[] {0x23ed}, 0, 1));
		_addEntry("nf", new String(new int[] {0x1f1f3,0x1f1eb}, 0, 2));
		_addEntry("ng", new String(new int[] {0x1f196}, 0, 1));
		_addEntry("ni", new String(new int[] {0x1f1f3,0x1f1ee}, 0, 2));
		_addEntry("nigeria", new String(new int[] {0x1f1f3,0x1f1ec}, 0, 2));
		_addEntry("night_with_stars", new String(new int[] {0x1f303}, 0, 1));
		_addEntry("nine", new String(new int[] {0x0039,0x20e3}, 0, 2));
		_addEntry("nl", new String(new int[] {0x1f1f3,0x1f1f1}, 0, 2));
		_addEntry("no", new String(new int[] {0x1f1f3,0x1f1f4}, 0, 2));
		_addEntry("no_bell", new String(new int[] {0x1f515}, 0, 1));
		_addEntry("no_bicycles", new String(new int[] {0x1f6b3}, 0, 1));
		_addEntry("no_entry", new String(new int[] {0x26d4}, 0, 1));
		_addEntry("no_entry_sign", new String(new int[] {0x1f6ab}, 0, 1));
		_addEntry("no_good", new String(new int[] {0x1f645}, 0, 1));
		_addEntry("no_good_tone1", new String(new int[] {0x1f645,0x1f3fb}, 0, 2));
		_addEntry("no_good_tone2", new String(new int[] {0x1f645,0x1f3fc}, 0, 2));
		_addEntry("no_good_tone3", new String(new int[] {0x1f645,0x1f3fd}, 0, 2));
		_addEntry("no_good_tone4", new String(new int[] {0x1f645,0x1f3fe}, 0, 2));
		_addEntry("no_good_tone5", new String(new int[] {0x1f645,0x1f3ff}, 0, 2));
	}
	private static void init21(){
		_addEntry("no_mobile_phones", new String(new int[] {0x1f4f5}, 0, 1));
		_addEntry("no_mouth", new String(new int[] {0x1f636}, 0, 1));
		_addEntry("no_pedestrians", new String(new int[] {0x1f6b7}, 0, 1));
		_addEntry("no_smoking", new String(new int[] {0x1f6ad}, 0, 1));
		_addEntry("non-potable_water", new String(new int[] {0x1f6b1}, 0, 1));
		_addEntry("nose", new String(new int[] {0x1f443}, 0, 1));
		_addEntry("nose_tone1", new String(new int[] {0x1f443,0x1f3fb}, 0, 2));
		_addEntry("nose_tone2", new String(new int[] {0x1f443,0x1f3fc}, 0, 2));
		_addEntry("nose_tone3", new String(new int[] {0x1f443,0x1f3fd}, 0, 2));
		_addEntry("nose_tone4", new String(new int[] {0x1f443,0x1f3fe}, 0, 2));
		_addEntry("nose_tone5", new String(new int[] {0x1f443,0x1f3ff}, 0, 2));
		_addEntry("notebook", new String(new int[] {0x1f4d3}, 0, 1));
		_addEntry("notebook_with_decorative_cover", new String(new int[] {0x1f4d4}, 0, 1));
		_addEntry("notepad_spiral", new String(new int[] {0x1f5d2}, 0, 1));
		_addEntry("notes", new String(new int[] {0x1f3b6}, 0, 1));
		_addEntry("np", new String(new int[] {0x1f1f3,0x1f1f5}, 0, 2));
		_addEntry("nr", new String(new int[] {0x1f1f3,0x1f1f7}, 0, 2));
		_addEntry("nu", new String(new int[] {0x1f1f3,0x1f1fa}, 0, 2));
		_addEntry("nut_and_bolt", new String(new int[] {0x1f529}, 0, 1));
		_addEntry("nz", new String(new int[] {0x1f1f3,0x1f1ff}, 0, 2));
		_addEntry("o", new String(new int[] {0x2b55}, 0, 1));
		_addEntry("o2", new String(new int[] {0x1f17e}, 0, 1));
		_addEntry("ocean", new String(new int[] {0x1f30a}, 0, 1));
		_addEntry("octagonal_sign", new String(new int[] {0x1f6d1}, 0, 1));
		_addEntry("octopus", new String(new int[] {0x1f419}, 0, 1));
		_addEntry("oden", new String(new int[] {0x1f362}, 0, 1));
		_addEntry("office", new String(new int[] {0x1f3e2}, 0, 1));
		_addEntry("oil", new String(new int[] {0x1f6e2}, 0, 1));
		_addEntry("oil_drum", new String(new int[] {0x1f6e2}, 0, 1));
		_addEntry("ok", new String(new int[] {0x1f197}, 0, 1));
		_addEntry("ok_hand", new String(new int[] {0x1f44c}, 0, 1));
		_addEntry("ok_hand_tone1", new String(new int[] {0x1f44c,0x1f3fb}, 0, 2));
		_addEntry("ok_hand_tone2", new String(new int[] {0x1f44c,0x1f3fc}, 0, 2));
		_addEntry("ok_hand_tone3", new String(new int[] {0x1f44c,0x1f3fd}, 0, 2));
		_addEntry("ok_hand_tone4", new String(new int[] {0x1f44c,0x1f3fe}, 0, 2));
		_addEntry("ok_hand_tone5", new String(new int[] {0x1f44c,0x1f3ff}, 0, 2));
		_addEntry("ok_woman", new String(new int[] {0x1f646}, 0, 1));
		_addEntry("ok_woman_tone1", new String(new int[] {0x1f646,0x1f3fb}, 0, 2));
		_addEntry("ok_woman_tone2", new String(new int[] {0x1f646,0x1f3fc}, 0, 2));
		_addEntry("ok_woman_tone3", new String(new int[] {0x1f646,0x1f3fd}, 0, 2));
		_addEntry("ok_woman_tone4", new String(new int[] {0x1f646,0x1f3fe}, 0, 2));
		_addEntry("ok_woman_tone5", new String(new int[] {0x1f646,0x1f3ff}, 0, 2));
		_addEntry("old_key", new String(new int[] {0x1f5dd}, 0, 1));
		_addEntry("older_man", new String(new int[] {0x1f474}, 0, 1));
		_addEntry("older_man_tone1", new String(new int[] {0x1f474,0x1f3fb}, 0, 2));
		_addEntry("older_man_tone2", new String(new int[] {0x1f474,0x1f3fc}, 0, 2));
		_addEntry("older_man_tone3", new String(new int[] {0x1f474,0x1f3fd}, 0, 2));
		_addEntry("older_man_tone4", new String(new int[] {0x1f474,0x1f3fe}, 0, 2));
		_addEntry("older_man_tone5", new String(new int[] {0x1f474,0x1f3ff}, 0, 2));
		_addEntry("older_woman", new String(new int[] {0x1f475}, 0, 1));
		_addEntry("older_woman_tone1", new String(new int[] {0x1f475,0x1f3fb}, 0, 2));
		_addEntry("older_woman_tone2", new String(new int[] {0x1f475,0x1f3fc}, 0, 2));
		_addEntry("older_woman_tone3", new String(new int[] {0x1f475,0x1f3fd}, 0, 2));
		_addEntry("older_woman_tone4", new String(new int[] {0x1f475,0x1f3fe}, 0, 2));
		_addEntry("older_woman_tone5", new String(new int[] {0x1f475,0x1f3ff}, 0, 2));
		_addEntry("om", new String(new int[] {0x1f1f4,0x1f1f2}, 0, 2));
		_addEntry("om_symbol", new String(new int[] {0x1f549}, 0, 1));
		_addEntry("on", new String(new int[] {0x1f51b}, 0, 1));
		_addEntry("oncoming_automobile", new String(new int[] {0x1f698}, 0, 1));
		_addEntry("oncoming_bus", new String(new int[] {0x1f68d}, 0, 1));
		_addEntry("oncoming_police_car", new String(new int[] {0x1f694}, 0, 1));
		_addEntry("oncoming_taxi", new String(new int[] {0x1f696}, 0, 1));
		_addEntry("one", new String(new int[] {0x0031,0x20e3}, 0, 2));
		_addEntry("open_file_folder", new String(new int[] {0x1f4c2}, 0, 1));
		_addEntry("open_hands", new String(new int[] {0x1f450}, 0, 1));
		_addEntry("open_hands_tone1", new String(new int[] {0x1f450,0x1f3fb}, 0, 2));
		_addEntry("open_hands_tone2", new String(new int[] {0x1f450,0x1f3fc}, 0, 2));
		_addEntry("open_hands_tone3", new String(new int[] {0x1f450,0x1f3fd}, 0, 2));
		_addEntry("open_hands_tone4", new String(new int[] {0x1f450,0x1f3fe}, 0, 2));
		_addEntry("open_hands_tone5", new String(new int[] {0x1f450,0x1f3ff}, 0, 2));
		_addEntry("open_mouth", new String(new int[] {0x1f62e}, 0, 1));
		_addEntry("ophiuchus", new String(new int[] {0x26ce}, 0, 1));
		_addEntry("orange_book", new String(new int[] {0x1f4d9}, 0, 1));
		_addEntry("orthodox_cross", new String(new int[] {0x2626}, 0, 1));
		_addEntry("outbox_tray", new String(new int[] {0x1f4e4}, 0, 1));
		_addEntry("owl", new String(new int[] {0x1f989}, 0, 1));
		_addEntry("ox", new String(new int[] {0x1f402}, 0, 1));
		_addEntry("pa", new String(new int[] {0x1f1f5,0x1f1e6}, 0, 2));
		_addEntry("package", new String(new int[] {0x1f4e6}, 0, 1));
		_addEntry("paella", new String(new int[] {0x1f958}, 0, 1));
		_addEntry("page_facing_up", new String(new int[] {0x1f4c4}, 0, 1));
		_addEntry("page_with_curl", new String(new int[] {0x1f4c3}, 0, 1));
		_addEntry("pager", new String(new int[] {0x1f4df}, 0, 1));
		_addEntry("paintbrush", new String(new int[] {0x1f58c}, 0, 1));
		_addEntry("palm_tree", new String(new int[] {0x1f334}, 0, 1));
		_addEntry("pancakes", new String(new int[] {0x1f95e}, 0, 1));
		_addEntry("panda_face", new String(new int[] {0x1f43c}, 0, 1));
		_addEntry("paperclip", new String(new int[] {0x1f4ce}, 0, 1));
		_addEntry("paperclips", new String(new int[] {0x1f587}, 0, 1));
		_addEntry("park", new String(new int[] {0x1f3de}, 0, 1));
		_addEntry("parking", new String(new int[] {0x1f17f}, 0, 1));
		_addEntry("part_alternation_mark", new String(new int[] {0x303d}, 0, 1));
		_addEntry("partly_sunny", new String(new int[] {0x26c5}, 0, 1));
		_addEntry("passenger_ship", new String(new int[] {0x1f6f3}, 0, 1));
		_addEntry("passport_control", new String(new int[] {0x1f6c2}, 0, 1));
		_addEntry("pause_button", new String(new int[] {0x23f8}, 0, 1));
		_addEntry("paw_prints", new String(new int[] {0x1f43e}, 0, 1));
		_addEntry("pe", new String(new int[] {0x1f1f5,0x1f1ea}, 0, 2));
		_addEntry("peace", new String(new int[] {0x262e}, 0, 1));
		_addEntry("peace_symbol", new String(new int[] {0x262e}, 0, 1));
		_addEntry("peach", new String(new int[] {0x1f351}, 0, 1));
	}
	private static void init22(){
		_addEntry("peanuts", new String(new int[] {0x1f95c}, 0, 1));
		_addEntry("pear", new String(new int[] {0x1f350}, 0, 1));
		_addEntry("pen_ballpoint", new String(new int[] {0x1f58a}, 0, 1));
		_addEntry("pen_fountain", new String(new int[] {0x1f58b}, 0, 1));
		_addEntry("pencil", new String(new int[] {0x1f4dd}, 0, 1));
		_addEntry("pencil2", new String(new int[] {0x270f}, 0, 1));
		_addEntry("penguin", new String(new int[] {0x1f427}, 0, 1));
		_addEntry("pensive", new String(new int[] {0x1f614}, 0, 1));
		_addEntry("performing_arts", new String(new int[] {0x1f3ad}, 0, 1));
		_addEntry("persevere", new String(new int[] {0x1f623}, 0, 1));
		_addEntry("person_doing_cartwheel", new String(new int[] {0x1f938}, 0, 1));
		_addEntry("person_doing_cartwheel_tone1", new String(new int[] {0x1f938,0x1f3fb}, 0, 2));
		_addEntry("person_doing_cartwheel_tone2", new String(new int[] {0x1f938,0x1f3fc}, 0, 2));
		_addEntry("person_doing_cartwheel_tone3", new String(new int[] {0x1f938,0x1f3fd}, 0, 2));
		_addEntry("person_doing_cartwheel_tone4", new String(new int[] {0x1f938,0x1f3fe}, 0, 2));
		_addEntry("person_doing_cartwheel_tone5", new String(new int[] {0x1f938,0x1f3ff}, 0, 2));
		_addEntry("person_frowning", new String(new int[] {0x1f64d}, 0, 1));
		_addEntry("person_frowning_tone1", new String(new int[] {0x1f64d,0x1f3fb}, 0, 2));
		_addEntry("person_frowning_tone2", new String(new int[] {0x1f64d,0x1f3fc}, 0, 2));
		_addEntry("person_frowning_tone3", new String(new int[] {0x1f64d,0x1f3fd}, 0, 2));
		_addEntry("person_frowning_tone4", new String(new int[] {0x1f64d,0x1f3fe}, 0, 2));
		_addEntry("person_frowning_tone5", new String(new int[] {0x1f64d,0x1f3ff}, 0, 2));
		_addEntry("person_golfing_dark_skin_tone", new String(new int[] {0x1f3cc,0x1f3ff}, 0, 2));
		_addEntry("person_golfing_light_skin_tone", new String(new int[] {0x1f3cc,0x1f3fb}, 0, 2));
		_addEntry("person_golfing_medium_dark_skin_tone", new String(new int[] {0x1f3cc,0x1f3fe}, 0, 2));
		_addEntry("person_golfing_medium_light_skin_tone", new String(new int[] {0x1f3cc,0x1f3fc}, 0, 2));
		_addEntry("person_golfing_medium_skin_tone", new String(new int[] {0x1f3cc,0x1f3fd}, 0, 2));
		_addEntry("person_golfing_tone1", new String(new int[] {0x1f3cc,0x1f3fb}, 0, 2));
		_addEntry("person_golfing_tone2", new String(new int[] {0x1f3cc,0x1f3fc}, 0, 2));
		_addEntry("person_golfing_tone3", new String(new int[] {0x1f3cc,0x1f3fd}, 0, 2));
		_addEntry("person_golfing_tone4", new String(new int[] {0x1f3cc,0x1f3fe}, 0, 2));
		_addEntry("person_golfing_tone5", new String(new int[] {0x1f3cc,0x1f3ff}, 0, 2));
		_addEntry("person_in_bed_dark_skin_tone", new String(new int[] {0x1f6cc,0x1f3ff}, 0, 2));
		_addEntry("person_in_bed_light_skin_tone", new String(new int[] {0x1f6cc,0x1f3fb}, 0, 2));
		_addEntry("person_in_bed_medium_dark_skin_tone", new String(new int[] {0x1f6cc,0x1f3fe}, 0, 2));
		_addEntry("person_in_bed_medium_light_skin_tone", new String(new int[] {0x1f6cc,0x1f3fc}, 0, 2));
		_addEntry("person_in_bed_medium_skin_tone", new String(new int[] {0x1f6cc,0x1f3fd}, 0, 2));
		_addEntry("person_in_bed_tone1", new String(new int[] {0x1f6cc,0x1f3fb}, 0, 2));
		_addEntry("person_in_bed_tone2", new String(new int[] {0x1f6cc,0x1f3fc}, 0, 2));
		_addEntry("person_in_bed_tone3", new String(new int[] {0x1f6cc,0x1f3fd}, 0, 2));
		_addEntry("person_in_bed_tone4", new String(new int[] {0x1f6cc,0x1f3fe}, 0, 2));
		_addEntry("person_in_bed_tone5", new String(new int[] {0x1f6cc,0x1f3ff}, 0, 2));
		_addEntry("person_with_ball", new String(new int[] {0x26f9}, 0, 1));
		_addEntry("person_with_ball_tone1", new String(new int[] {0x26f9,0x1f3fb}, 0, 2));
		_addEntry("person_with_ball_tone2", new String(new int[] {0x26f9,0x1f3fc}, 0, 2));
		_addEntry("person_with_ball_tone3", new String(new int[] {0x26f9,0x1f3fd}, 0, 2));
		_addEntry("person_with_ball_tone4", new String(new int[] {0x26f9,0x1f3fe}, 0, 2));
		_addEntry("person_with_ball_tone5", new String(new int[] {0x26f9,0x1f3ff}, 0, 2));
		_addEntry("person_with_blond_hair", new String(new int[] {0x1f471}, 0, 1));
		_addEntry("person_with_blond_hair_tone1", new String(new int[] {0x1f471,0x1f3fb}, 0, 2));
		_addEntry("person_with_blond_hair_tone2", new String(new int[] {0x1f471,0x1f3fc}, 0, 2));
		_addEntry("person_with_blond_hair_tone3", new String(new int[] {0x1f471,0x1f3fd}, 0, 2));
		_addEntry("person_with_blond_hair_tone4", new String(new int[] {0x1f471,0x1f3fe}, 0, 2));
		_addEntry("person_with_blond_hair_tone5", new String(new int[] {0x1f471,0x1f3ff}, 0, 2));
		_addEntry("person_with_pouting_face", new String(new int[] {0x1f64e}, 0, 1));
		_addEntry("person_with_pouting_face_tone1", new String(new int[] {0x1f64e,0x1f3fb}, 0, 2));
		_addEntry("person_with_pouting_face_tone2", new String(new int[] {0x1f64e,0x1f3fc}, 0, 2));
		_addEntry("person_with_pouting_face_tone3", new String(new int[] {0x1f64e,0x1f3fd}, 0, 2));
		_addEntry("person_with_pouting_face_tone4", new String(new int[] {0x1f64e,0x1f3fe}, 0, 2));
		_addEntry("person_with_pouting_face_tone5", new String(new int[] {0x1f64e,0x1f3ff}, 0, 2));
		_addEntry("pf", new String(new int[] {0x1f1f5,0x1f1eb}, 0, 2));
		_addEntry("pg", new String(new int[] {0x1f1f5,0x1f1ec}, 0, 2));
		_addEntry("ph", new String(new int[] {0x1f1f5,0x1f1ed}, 0, 2));
		_addEntry("pick", new String(new int[] {0x26cf}, 0, 1));
		_addEntry("pig", new String(new int[] {0x1f437}, 0, 1));
		_addEntry("pig2", new String(new int[] {0x1f416}, 0, 1));
		_addEntry("pig_nose", new String(new int[] {0x1f43d}, 0, 1));
		_addEntry("pill", new String(new int[] {0x1f48a}, 0, 1));
		_addEntry("pineapple", new String(new int[] {0x1f34d}, 0, 1));
		_addEntry("ping_pong", new String(new int[] {0x1f3d3}, 0, 1));
		_addEntry("pisces", new String(new int[] {0x2653}, 0, 1));
		_addEntry("pizza", new String(new int[] {0x1f355}, 0, 1));
		_addEntry("pk", new String(new int[] {0x1f1f5,0x1f1f0}, 0, 2));
		_addEntry("pl", new String(new int[] {0x1f1f5,0x1f1f1}, 0, 2));
		_addEntry("place_of_worship", new String(new int[] {0x1f6d0}, 0, 1));
		_addEntry("play_pause", new String(new int[] {0x23ef}, 0, 1));
		_addEntry("pm", new String(new int[] {0x1f1f5,0x1f1f2}, 0, 2));
		_addEntry("pn", new String(new int[] {0x1f1f5,0x1f1f3}, 0, 2));
		_addEntry("point_down", new String(new int[] {0x1f447}, 0, 1));
		_addEntry("point_down_tone1", new String(new int[] {0x1f447,0x1f3fb}, 0, 2));
		_addEntry("point_down_tone2", new String(new int[] {0x1f447,0x1f3fc}, 0, 2));
		_addEntry("point_down_tone3", new String(new int[] {0x1f447,0x1f3fd}, 0, 2));
		_addEntry("point_down_tone4", new String(new int[] {0x1f447,0x1f3fe}, 0, 2));
		_addEntry("point_down_tone5", new String(new int[] {0x1f447,0x1f3ff}, 0, 2));
		_addEntry("point_left", new String(new int[] {0x1f448}, 0, 1));
		_addEntry("point_left_tone1", new String(new int[] {0x1f448,0x1f3fb}, 0, 2));
		_addEntry("point_left_tone2", new String(new int[] {0x1f448,0x1f3fc}, 0, 2));
		_addEntry("point_left_tone3", new String(new int[] {0x1f448,0x1f3fd}, 0, 2));
		_addEntry("point_left_tone4", new String(new int[] {0x1f448,0x1f3fe}, 0, 2));
		_addEntry("point_left_tone5", new String(new int[] {0x1f448,0x1f3ff}, 0, 2));
		_addEntry("point_right", new String(new int[] {0x1f449}, 0, 1));
		_addEntry("point_right_tone1", new String(new int[] {0x1f449,0x1f3fb}, 0, 2));
		_addEntry("point_right_tone2", new String(new int[] {0x1f449,0x1f3fc}, 0, 2));
		_addEntry("point_right_tone3", new String(new int[] {0x1f449,0x1f3fd}, 0, 2));
		_addEntry("point_right_tone4", new String(new int[] {0x1f449,0x1f3fe}, 0, 2));
		_addEntry("point_right_tone5", new String(new int[] {0x1f449,0x1f3ff}, 0, 2));
		_addEntry("point_up", new String(new int[] {0x261d}, 0, 1));
		_addEntry("point_up_2", new String(new int[] {0x1f446}, 0, 1));
		_addEntry("point_up_2_tone1", new String(new int[] {0x1f446,0x1f3fb}, 0, 2));
		_addEntry("point_up_2_tone2", new String(new int[] {0x1f446,0x1f3fc}, 0, 2));
		_addEntry("point_up_2_tone3", new String(new int[] {0x1f446,0x1f3fd}, 0, 2));
	}
	private static void init23(){
		_addEntry("point_up_2_tone4", new String(new int[] {0x1f446,0x1f3fe}, 0, 2));
		_addEntry("point_up_2_tone5", new String(new int[] {0x1f446,0x1f3ff}, 0, 2));
		_addEntry("point_up_tone1", new String(new int[] {0x261d,0x1f3fb}, 0, 2));
		_addEntry("point_up_tone2", new String(new int[] {0x261d,0x1f3fc}, 0, 2));
		_addEntry("point_up_tone3", new String(new int[] {0x261d,0x1f3fd}, 0, 2));
		_addEntry("point_up_tone4", new String(new int[] {0x261d,0x1f3fe}, 0, 2));
		_addEntry("point_up_tone5", new String(new int[] {0x261d,0x1f3ff}, 0, 2));
		_addEntry("police_car", new String(new int[] {0x1f693}, 0, 1));
		_addEntry("poo", new String(new int[] {0x1f4a9}, 0, 1));
		_addEntry("poodle", new String(new int[] {0x1f429}, 0, 1));
		_addEntry("poop", new String(new int[] {0x1f4a9}, 0, 1));
		_addEntry("popcorn", new String(new int[] {0x1f37f}, 0, 1));
		_addEntry("post_office", new String(new int[] {0x1f3e3}, 0, 1));
		_addEntry("postal_horn", new String(new int[] {0x1f4ef}, 0, 1));
		_addEntry("postbox", new String(new int[] {0x1f4ee}, 0, 1));
		_addEntry("potable_water", new String(new int[] {0x1f6b0}, 0, 1));
		_addEntry("potato", new String(new int[] {0x1f954}, 0, 1));
		_addEntry("pouch", new String(new int[] {0x1f45d}, 0, 1));
		_addEntry("poultry_leg", new String(new int[] {0x1f357}, 0, 1));
		_addEntry("pound", new String(new int[] {0x1f4b7}, 0, 1));
		_addEntry("pound_symbol", new String(new int[] {0x0023}, 0, 1));
		_addEntry("pouting_cat", new String(new int[] {0x1f63e}, 0, 1));
		_addEntry("pr", new String(new int[] {0x1f1f5,0x1f1f7}, 0, 2));
		_addEntry("pray", new String(new int[] {0x1f64f}, 0, 1));
		_addEntry("pray_tone1", new String(new int[] {0x1f64f,0x1f3fb}, 0, 2));
		_addEntry("pray_tone2", new String(new int[] {0x1f64f,0x1f3fc}, 0, 2));
		_addEntry("pray_tone3", new String(new int[] {0x1f64f,0x1f3fd}, 0, 2));
		_addEntry("pray_tone4", new String(new int[] {0x1f64f,0x1f3fe}, 0, 2));
		_addEntry("pray_tone5", new String(new int[] {0x1f64f,0x1f3ff}, 0, 2));
		_addEntry("prayer_beads", new String(new int[] {0x1f4ff}, 0, 1));
		_addEntry("pregnant_woman", new String(new int[] {0x1f930}, 0, 1));
		_addEntry("pregnant_woman_tone1", new String(new int[] {0x1f930,0x1f3fb}, 0, 2));
		_addEntry("pregnant_woman_tone2", new String(new int[] {0x1f930,0x1f3fc}, 0, 2));
		_addEntry("pregnant_woman_tone3", new String(new int[] {0x1f930,0x1f3fd}, 0, 2));
		_addEntry("pregnant_woman_tone4", new String(new int[] {0x1f930,0x1f3fe}, 0, 2));
		_addEntry("pregnant_woman_tone5", new String(new int[] {0x1f930,0x1f3ff}, 0, 2));
		_addEntry("previous_track", new String(new int[] {0x23ee}, 0, 1));
		_addEntry("prince", new String(new int[] {0x1f934}, 0, 1));
		_addEntry("prince_tone1", new String(new int[] {0x1f934,0x1f3fb}, 0, 2));
		_addEntry("prince_tone2", new String(new int[] {0x1f934,0x1f3fc}, 0, 2));
		_addEntry("prince_tone3", new String(new int[] {0x1f934,0x1f3fd}, 0, 2));
		_addEntry("prince_tone4", new String(new int[] {0x1f934,0x1f3fe}, 0, 2));
		_addEntry("prince_tone5", new String(new int[] {0x1f934,0x1f3ff}, 0, 2));
		_addEntry("princess", new String(new int[] {0x1f478}, 0, 1));
		_addEntry("princess_tone1", new String(new int[] {0x1f478,0x1f3fb}, 0, 2));
		_addEntry("princess_tone2", new String(new int[] {0x1f478,0x1f3fc}, 0, 2));
		_addEntry("princess_tone3", new String(new int[] {0x1f478,0x1f3fd}, 0, 2));
		_addEntry("princess_tone4", new String(new int[] {0x1f478,0x1f3fe}, 0, 2));
		_addEntry("princess_tone5", new String(new int[] {0x1f478,0x1f3ff}, 0, 2));
		_addEntry("printer", new String(new int[] {0x1f5a8}, 0, 1));
		_addEntry("projector", new String(new int[] {0x1f4fd}, 0, 1));
		_addEntry("ps", new String(new int[] {0x1f1f5,0x1f1f8}, 0, 2));
		_addEntry("pt", new String(new int[] {0x1f1f5,0x1f1f9}, 0, 2));
		_addEntry("pudding", new String(new int[] {0x1f36e}, 0, 1));
		_addEntry("punch", new String(new int[] {0x1f44a}, 0, 1));
		_addEntry("punch_tone1", new String(new int[] {0x1f44a,0x1f3fb}, 0, 2));
		_addEntry("punch_tone2", new String(new int[] {0x1f44a,0x1f3fc}, 0, 2));
		_addEntry("punch_tone3", new String(new int[] {0x1f44a,0x1f3fd}, 0, 2));
		_addEntry("punch_tone4", new String(new int[] {0x1f44a,0x1f3fe}, 0, 2));
		_addEntry("punch_tone5", new String(new int[] {0x1f44a,0x1f3ff}, 0, 2));
		_addEntry("purple_heart", new String(new int[] {0x1f49c}, 0, 1));
		_addEntry("purse", new String(new int[] {0x1f45b}, 0, 1));
		_addEntry("pushpin", new String(new int[] {0x1f4cc}, 0, 1));
		_addEntry("put_litter_in_its_place", new String(new int[] {0x1f6ae}, 0, 1));
		_addEntry("pw", new String(new int[] {0x1f1f5,0x1f1fc}, 0, 2));
		_addEntry("py", new String(new int[] {0x1f1f5,0x1f1fe}, 0, 2));
		_addEntry("qa", new String(new int[] {0x1f1f6,0x1f1e6}, 0, 2));
		_addEntry("question", new String(new int[] {0x2753}, 0, 1));
		_addEntry("rabbit", new String(new int[] {0x1f430}, 0, 1));
		_addEntry("rabbit2", new String(new int[] {0x1f407}, 0, 1));
		_addEntry("race_car", new String(new int[] {0x1f3ce}, 0, 1));
		_addEntry("racehorse", new String(new int[] {0x1f40e}, 0, 1));
		_addEntry("racing_car", new String(new int[] {0x1f3ce}, 0, 1));
		_addEntry("racing_motorcycle", new String(new int[] {0x1f3cd}, 0, 1));
		_addEntry("radio", new String(new int[] {0x1f4fb}, 0, 1));
		_addEntry("radio_button", new String(new int[] {0x1f518}, 0, 1));
		_addEntry("radioactive", new String(new int[] {0x2622}, 0, 1));
		_addEntry("radioactive_sign", new String(new int[] {0x2622}, 0, 1));
		_addEntry("rage", new String(new int[] {0x1f621}, 0, 1));
		_addEntry("railroad_track", new String(new int[] {0x1f6e4}, 0, 1));
		_addEntry("railway_car", new String(new int[] {0x1f683}, 0, 1));
		_addEntry("railway_track", new String(new int[] {0x1f6e4}, 0, 1));
		_addEntry("rainbow", new String(new int[] {0x1f308}, 0, 1));
		_addEntry("rainbow_flag", new String(new int[] {0x1f3f3,0x1f308}, 0, 2));
		_addEntry("raised_back_of_hand", new String(new int[] {0x1f91a}, 0, 1));
		_addEntry("raised_back_of_hand_tone1", new String(new int[] {0x1f91a,0x1f3fb}, 0, 2));
		_addEntry("raised_back_of_hand_tone2", new String(new int[] {0x1f91a,0x1f3fc}, 0, 2));
		_addEntry("raised_back_of_hand_tone3", new String(new int[] {0x1f91a,0x1f3fd}, 0, 2));
		_addEntry("raised_back_of_hand_tone4", new String(new int[] {0x1f91a,0x1f3fe}, 0, 2));
		_addEntry("raised_back_of_hand_tone5", new String(new int[] {0x1f91a,0x1f3ff}, 0, 2));
		_addEntry("raised_hand", new String(new int[] {0x270b}, 0, 1));
		_addEntry("raised_hand_tone1", new String(new int[] {0x270b,0x1f3fb}, 0, 2));
		_addEntry("raised_hand_tone2", new String(new int[] {0x270b,0x1f3fc}, 0, 2));
		_addEntry("raised_hand_tone3", new String(new int[] {0x270b,0x1f3fd}, 0, 2));
		_addEntry("raised_hand_tone4", new String(new int[] {0x270b,0x1f3fe}, 0, 2));
		_addEntry("raised_hand_tone5", new String(new int[] {0x270b,0x1f3ff}, 0, 2));
		_addEntry("raised_hand_with_fingers_splayed", new String(new int[] {0x1f590}, 0, 1));
		_addEntry("raised_hand_with_fingers_splayed_tone1", new String(new int[] {0x1f590,0x1f3fb}, 0, 2));
		_addEntry("raised_hand_with_fingers_splayed_tone2", new String(new int[] {0x1f590,0x1f3fc}, 0, 2));
		_addEntry("raised_hand_with_fingers_splayed_tone3", new String(new int[] {0x1f590,0x1f3fd}, 0, 2));
		_addEntry("raised_hand_with_fingers_splayed_tone4", new String(new int[] {0x1f590,0x1f3fe}, 0, 2));
	}
	private static void init24(){
		_addEntry("raised_hand_with_fingers_splayed_tone5", new String(new int[] {0x1f590,0x1f3ff}, 0, 2));
		_addEntry("raised_hand_with_part_between_middle_and_ring_fingers", new String(new int[] {0x1f596}, 0, 1));
		_addEntry("raised_hand_with_part_between_middle_and_ring_fingers_tone1", new String(new int[] {0x1f596,0x1f3fb}, 0, 2));
		_addEntry("raised_hand_with_part_between_middle_and_ring_fingers_tone2", new String(new int[] {0x1f596,0x1f3fc}, 0, 2));
		_addEntry("raised_hand_with_part_between_middle_and_ring_fingers_tone3", new String(new int[] {0x1f596,0x1f3fd}, 0, 2));
		_addEntry("raised_hand_with_part_between_middle_and_ring_fingers_tone4", new String(new int[] {0x1f596,0x1f3fe}, 0, 2));
		_addEntry("raised_hand_with_part_between_middle_and_ring_fingers_tone5", new String(new int[] {0x1f596,0x1f3ff}, 0, 2));
		_addEntry("raised_hands", new String(new int[] {0x1f64c}, 0, 1));
		_addEntry("raised_hands_tone1", new String(new int[] {0x1f64c,0x1f3fb}, 0, 2));
		_addEntry("raised_hands_tone2", new String(new int[] {0x1f64c,0x1f3fc}, 0, 2));
		_addEntry("raised_hands_tone3", new String(new int[] {0x1f64c,0x1f3fd}, 0, 2));
		_addEntry("raised_hands_tone4", new String(new int[] {0x1f64c,0x1f3fe}, 0, 2));
		_addEntry("raised_hands_tone5", new String(new int[] {0x1f64c,0x1f3ff}, 0, 2));
		_addEntry("raising_hand", new String(new int[] {0x1f64b}, 0, 1));
		_addEntry("raising_hand_tone1", new String(new int[] {0x1f64b,0x1f3fb}, 0, 2));
		_addEntry("raising_hand_tone2", new String(new int[] {0x1f64b,0x1f3fc}, 0, 2));
		_addEntry("raising_hand_tone3", new String(new int[] {0x1f64b,0x1f3fd}, 0, 2));
		_addEntry("raising_hand_tone4", new String(new int[] {0x1f64b,0x1f3fe}, 0, 2));
		_addEntry("raising_hand_tone5", new String(new int[] {0x1f64b,0x1f3ff}, 0, 2));
		_addEntry("ram", new String(new int[] {0x1f40f}, 0, 1));
		_addEntry("ramen", new String(new int[] {0x1f35c}, 0, 1));
		_addEntry("rat", new String(new int[] {0x1f400}, 0, 1));
		_addEntry("re", new String(new int[] {0x1f1f7,0x1f1ea}, 0, 2));
		_addEntry("record_button", new String(new int[] {0x23fa}, 0, 1));
		_addEntry("recycle", new String(new int[] {0x267b}, 0, 1));
		_addEntry("red_car", new String(new int[] {0x1f697}, 0, 1));
		_addEntry("red_circle", new String(new int[] {0x1f534}, 0, 1));
		_addEntry("regional_indicator_a", new String(new int[] {0x1f1e6}, 0, 1));
		_addEntry("regional_indicator_b", new String(new int[] {0x1f1e7}, 0, 1));
		_addEntry("regional_indicator_c", new String(new int[] {0x1f1e8}, 0, 1));
		_addEntry("regional_indicator_d", new String(new int[] {0x1f1e9}, 0, 1));
		_addEntry("regional_indicator_e", new String(new int[] {0x1f1ea}, 0, 1));
		_addEntry("regional_indicator_f", new String(new int[] {0x1f1eb}, 0, 1));
		_addEntry("regional_indicator_g", new String(new int[] {0x1f1ec}, 0, 1));
		_addEntry("regional_indicator_h", new String(new int[] {0x1f1ed}, 0, 1));
		_addEntry("regional_indicator_i", new String(new int[] {0x1f1ee}, 0, 1));
		_addEntry("regional_indicator_j", new String(new int[] {0x1f1ef}, 0, 1));
		_addEntry("regional_indicator_k", new String(new int[] {0x1f1f0}, 0, 1));
		_addEntry("regional_indicator_l", new String(new int[] {0x1f1f1}, 0, 1));
		_addEntry("regional_indicator_m", new String(new int[] {0x1f1f2}, 0, 1));
		_addEntry("regional_indicator_n", new String(new int[] {0x1f1f3}, 0, 1));
		_addEntry("regional_indicator_o", new String(new int[] {0x1f1f4}, 0, 1));
		_addEntry("regional_indicator_p", new String(new int[] {0x1f1f5}, 0, 1));
		_addEntry("regional_indicator_q", new String(new int[] {0x1f1f6}, 0, 1));
		_addEntry("regional_indicator_r", new String(new int[] {0x1f1f7}, 0, 1));
		_addEntry("regional_indicator_s", new String(new int[] {0x1f1f8}, 0, 1));
		_addEntry("regional_indicator_t", new String(new int[] {0x1f1f9}, 0, 1));
		_addEntry("regional_indicator_u", new String(new int[] {0x1f1fa}, 0, 1));
		_addEntry("regional_indicator_v", new String(new int[] {0x1f1fb}, 0, 1));
		_addEntry("regional_indicator_w", new String(new int[] {0x1f1fc}, 0, 1));
		_addEntry("regional_indicator_x", new String(new int[] {0x1f1fd}, 0, 1));
		_addEntry("regional_indicator_y", new String(new int[] {0x1f1fe}, 0, 1));
		_addEntry("regional_indicator_z", new String(new int[] {0x1f1ff}, 0, 1));
		_addEntry("registered", new String(new int[] {0x00ae}, 0, 1));
		_addEntry("relaxed", new String(new int[] {0x263a}, 0, 1));
		_addEntry("relieved", new String(new int[] {0x1f60c}, 0, 1));
		_addEntry("reminder_ribbon", new String(new int[] {0x1f397}, 0, 1));
		_addEntry("repeat", new String(new int[] {0x1f501}, 0, 1));
		_addEntry("repeat_one", new String(new int[] {0x1f502}, 0, 1));
		_addEntry("restroom", new String(new int[] {0x1f6bb}, 0, 1));
		_addEntry("reversed_hand_with_middle_finger_extended", new String(new int[] {0x1f595}, 0, 1));
		_addEntry("reversed_hand_with_middle_finger_extended_tone1", new String(new int[] {0x1f595,0x1f3fb}, 0, 2));
		_addEntry("reversed_hand_with_middle_finger_extended_tone2", new String(new int[] {0x1f595,0x1f3fc}, 0, 2));
		_addEntry("reversed_hand_with_middle_finger_extended_tone3", new String(new int[] {0x1f595,0x1f3fd}, 0, 2));
		_addEntry("reversed_hand_with_middle_finger_extended_tone4", new String(new int[] {0x1f595,0x1f3fe}, 0, 2));
		_addEntry("reversed_hand_with_middle_finger_extended_tone5", new String(new int[] {0x1f595,0x1f3ff}, 0, 2));
		_addEntry("revolving_hearts", new String(new int[] {0x1f49e}, 0, 1));
		_addEntry("rewind", new String(new int[] {0x23ea}, 0, 1));
		_addEntry("rhino", new String(new int[] {0x1f98f}, 0, 1));
		_addEntry("rhinoceros", new String(new int[] {0x1f98f}, 0, 1));
		_addEntry("ribbon", new String(new int[] {0x1f380}, 0, 1));
		_addEntry("rice", new String(new int[] {0x1f35a}, 0, 1));
		_addEntry("rice_ball", new String(new int[] {0x1f359}, 0, 1));
		_addEntry("rice_cracker", new String(new int[] {0x1f358}, 0, 1));
		_addEntry("rice_scene", new String(new int[] {0x1f391}, 0, 1));
		_addEntry("right_anger_bubble", new String(new int[] {0x1f5ef}, 0, 1));
		_addEntry("right_facing_fist", new String(new int[] {0x1f91c}, 0, 1));
		_addEntry("right_facing_fist_tone1", new String(new int[] {0x1f91c,0x1f3fb}, 0, 2));
		_addEntry("right_facing_fist_tone2", new String(new int[] {0x1f91c,0x1f3fc}, 0, 2));
		_addEntry("right_facing_fist_tone3", new String(new int[] {0x1f91c,0x1f3fd}, 0, 2));
		_addEntry("right_facing_fist_tone4", new String(new int[] {0x1f91c,0x1f3fe}, 0, 2));
		_addEntry("right_facing_fist_tone5", new String(new int[] {0x1f91c,0x1f3ff}, 0, 2));
		_addEntry("right_fist", new String(new int[] {0x1f91c}, 0, 1));
		_addEntry("right_fist_tone1", new String(new int[] {0x1f91c,0x1f3fb}, 0, 2));
		_addEntry("right_fist_tone2", new String(new int[] {0x1f91c,0x1f3fc}, 0, 2));
		_addEntry("right_fist_tone3", new String(new int[] {0x1f91c,0x1f3fd}, 0, 2));
		_addEntry("right_fist_tone4", new String(new int[] {0x1f91c,0x1f3fe}, 0, 2));
		_addEntry("right_fist_tone5", new String(new int[] {0x1f91c,0x1f3ff}, 0, 2));
		_addEntry("ring", new String(new int[] {0x1f48d}, 0, 1));
		_addEntry("ro", new String(new int[] {0x1f1f7,0x1f1f4}, 0, 2));
		_addEntry("robot", new String(new int[] {0x1f916}, 0, 1));
		_addEntry("robot_face", new String(new int[] {0x1f916}, 0, 1));
		_addEntry("rocket", new String(new int[] {0x1f680}, 0, 1));
		_addEntry("rofl", new String(new int[] {0x1f923}, 0, 1));
		_addEntry("rolled_up_newspaper", new String(new int[] {0x1f5de}, 0, 1));
		_addEntry("roller_coaster", new String(new int[] {0x1f3a2}, 0, 1));
		_addEntry("rolling_eyes", new String(new int[] {0x1f644}, 0, 1));
		_addEntry("rolling_on_the_floor_laughing", new String(new int[] {0x1f923}, 0, 1));
		_addEntry("rooster", new String(new int[] {0x1f413}, 0, 1));
		_addEntry("rose", new String(new int[] {0x1f339}, 0, 1));
		_addEntry("rosette", new String(new int[] {0x1f3f5}, 0, 1));
	}
	private static void init25(){
		_addEntry("rotating_light", new String(new int[] {0x1f6a8}, 0, 1));
		_addEntry("round_pushpin", new String(new int[] {0x1f4cd}, 0, 1));
		_addEntry("rowboat", new String(new int[] {0x1f6a3}, 0, 1));
		_addEntry("rowboat_tone1", new String(new int[] {0x1f6a3,0x1f3fb}, 0, 2));
		_addEntry("rowboat_tone2", new String(new int[] {0x1f6a3,0x1f3fc}, 0, 2));
		_addEntry("rowboat_tone3", new String(new int[] {0x1f6a3,0x1f3fd}, 0, 2));
		_addEntry("rowboat_tone4", new String(new int[] {0x1f6a3,0x1f3fe}, 0, 2));
		_addEntry("rowboat_tone5", new String(new int[] {0x1f6a3,0x1f3ff}, 0, 2));
		_addEntry("rs", new String(new int[] {0x1f1f7,0x1f1f8}, 0, 2));
		_addEntry("ru", new String(new int[] {0x1f1f7,0x1f1fa}, 0, 2));
		_addEntry("rugby_football", new String(new int[] {0x1f3c9}, 0, 1));
		_addEntry("runner", new String(new int[] {0x1f3c3}, 0, 1));
		_addEntry("runner_tone1", new String(new int[] {0x1f3c3,0x1f3fb}, 0, 2));
		_addEntry("runner_tone2", new String(new int[] {0x1f3c3,0x1f3fc}, 0, 2));
		_addEntry("runner_tone3", new String(new int[] {0x1f3c3,0x1f3fd}, 0, 2));
		_addEntry("runner_tone4", new String(new int[] {0x1f3c3,0x1f3fe}, 0, 2));
		_addEntry("runner_tone5", new String(new int[] {0x1f3c3,0x1f3ff}, 0, 2));
		_addEntry("running_shirt_with_sash", new String(new int[] {0x1f3bd}, 0, 1));
		_addEntry("rw", new String(new int[] {0x1f1f7,0x1f1fc}, 0, 2));
		_addEntry("sa", new String(new int[] {0x1f202}, 0, 1));
		_addEntry("sagittarius", new String(new int[] {0x2650}, 0, 1));
		_addEntry("sailboat", new String(new int[] {0x26f5}, 0, 1));
		_addEntry("sake", new String(new int[] {0x1f376}, 0, 1));
		_addEntry("salad", new String(new int[] {0x1f957}, 0, 1));
		_addEntry("sandal", new String(new int[] {0x1f461}, 0, 1));
		_addEntry("santa", new String(new int[] {0x1f385}, 0, 1));
		_addEntry("santa_tone1", new String(new int[] {0x1f385,0x1f3fb}, 0, 2));
		_addEntry("santa_tone2", new String(new int[] {0x1f385,0x1f3fc}, 0, 2));
		_addEntry("santa_tone3", new String(new int[] {0x1f385,0x1f3fd}, 0, 2));
		_addEntry("santa_tone4", new String(new int[] {0x1f385,0x1f3fe}, 0, 2));
		_addEntry("santa_tone5", new String(new int[] {0x1f385,0x1f3ff}, 0, 2));
		_addEntry("satellite", new String(new int[] {0x1f4e1}, 0, 1));
		_addEntry("satellite_orbital", new String(new int[] {0x1f6f0}, 0, 1));
		_addEntry("satisfied", new String(new int[] {0x1f606}, 0, 1));
		_addEntry("saudi", new String(new int[] {0x1f1f8,0x1f1e6}, 0, 2));
		_addEntry("saudiarabia", new String(new int[] {0x1f1f8,0x1f1e6}, 0, 2));
		_addEntry("saxophone", new String(new int[] {0x1f3b7}, 0, 1));
		_addEntry("sb", new String(new int[] {0x1f1f8,0x1f1e7}, 0, 2));
		_addEntry("sc", new String(new int[] {0x1f1f8,0x1f1e8}, 0, 2));
		_addEntry("scales", new String(new int[] {0x2696}, 0, 1));
		_addEntry("school", new String(new int[] {0x1f3eb}, 0, 1));
		_addEntry("school_satchel", new String(new int[] {0x1f392}, 0, 1));
		_addEntry("scissors", new String(new int[] {0x2702}, 0, 1));
		_addEntry("scooter", new String(new int[] {0x1f6f4}, 0, 1));
		_addEntry("scorpion", new String(new int[] {0x1f982}, 0, 1));
		_addEntry("scorpius", new String(new int[] {0x264f}, 0, 1));
		_addEntry("scream", new String(new int[] {0x1f631}, 0, 1));
		_addEntry("scream_cat", new String(new int[] {0x1f640}, 0, 1));
		_addEntry("scroll", new String(new int[] {0x1f4dc}, 0, 1));
		_addEntry("sd", new String(new int[] {0x1f1f8,0x1f1e9}, 0, 2));
		_addEntry("se", new String(new int[] {0x1f1f8,0x1f1ea}, 0, 2));
		_addEntry("seat", new String(new int[] {0x1f4ba}, 0, 1));
		_addEntry("second_place", new String(new int[] {0x1f948}, 0, 1));
		_addEntry("second_place_medal", new String(new int[] {0x1f948}, 0, 1));
		_addEntry("secret", new String(new int[] {0x3299}, 0, 1));
		_addEntry("see_no_evil", new String(new int[] {0x1f648}, 0, 1));
		_addEntry("seedling", new String(new int[] {0x1f331}, 0, 1));
		_addEntry("selfie", new String(new int[] {0x1f933}, 0, 1));
		_addEntry("selfie_tone1", new String(new int[] {0x1f933,0x1f3fb}, 0, 2));
		_addEntry("selfie_tone2", new String(new int[] {0x1f933,0x1f3fc}, 0, 2));
		_addEntry("selfie_tone3", new String(new int[] {0x1f933,0x1f3fd}, 0, 2));
		_addEntry("selfie_tone4", new String(new int[] {0x1f933,0x1f3fe}, 0, 2));
		_addEntry("selfie_tone5", new String(new int[] {0x1f933,0x1f3ff}, 0, 2));
		_addEntry("seven", new String(new int[] {0x0037,0x20e3}, 0, 2));
		_addEntry("sg", new String(new int[] {0x1f1f8,0x1f1ec}, 0, 2));
		_addEntry("sh", new String(new int[] {0x1f1f8,0x1f1ed}, 0, 2));
		_addEntry("shaking_hands", new String(new int[] {0x1f91d}, 0, 1));
		_addEntry("shallow_pan_of_food", new String(new int[] {0x1f958}, 0, 1));
		_addEntry("shamrock", new String(new int[] {0x2618}, 0, 1));
		_addEntry("shark", new String(new int[] {0x1f988}, 0, 1));
		_addEntry("shaved_ice", new String(new int[] {0x1f367}, 0, 1));
		_addEntry("sheep", new String(new int[] {0x1f411}, 0, 1));
		_addEntry("shell", new String(new int[] {0x1f41a}, 0, 1));
		_addEntry("shelled_peanut", new String(new int[] {0x1f95c}, 0, 1));
		_addEntry("shield", new String(new int[] {0x1f6e1}, 0, 1));
		_addEntry("shinto_shrine", new String(new int[] {0x26e9}, 0, 1));
		_addEntry("ship", new String(new int[] {0x1f6a2}, 0, 1));
		_addEntry("shirt", new String(new int[] {0x1f455}, 0, 1));
		_addEntry("shit", new String(new int[] {0x1f4a9}, 0, 1));
		_addEntry("shopping_bags", new String(new int[] {0x1f6cd}, 0, 1));
		_addEntry("shopping_cart", new String(new int[] {0x1f6d2}, 0, 1));
		_addEntry("shopping_trolley", new String(new int[] {0x1f6d2}, 0, 1));
		_addEntry("shower", new String(new int[] {0x1f6bf}, 0, 1));
		_addEntry("shrimp", new String(new int[] {0x1f990}, 0, 1));
		_addEntry("shrug", new String(new int[] {0x1f937}, 0, 1));
		_addEntry("shrug_tone1", new String(new int[] {0x1f937,0x1f3fb}, 0, 2));
		_addEntry("shrug_tone2", new String(new int[] {0x1f937,0x1f3fc}, 0, 2));
		_addEntry("shrug_tone3", new String(new int[] {0x1f937,0x1f3fd}, 0, 2));
		_addEntry("shrug_tone4", new String(new int[] {0x1f937,0x1f3fe}, 0, 2));
		_addEntry("shrug_tone5", new String(new int[] {0x1f937,0x1f3ff}, 0, 2));
		_addEntry("si", new String(new int[] {0x1f1f8,0x1f1ee}, 0, 2));
		_addEntry("sick", new String(new int[] {0x1f922}, 0, 1));
		_addEntry("sign_of_the_horns", new String(new int[] {0x1f918}, 0, 1));
		_addEntry("sign_of_the_horns_tone1", new String(new int[] {0x1f918,0x1f3fb}, 0, 2));
		_addEntry("sign_of_the_horns_tone2", new String(new int[] {0x1f918,0x1f3fc}, 0, 2));
		_addEntry("sign_of_the_horns_tone3", new String(new int[] {0x1f918,0x1f3fd}, 0, 2));
		_addEntry("sign_of_the_horns_tone4", new String(new int[] {0x1f918,0x1f3fe}, 0, 2));
		_addEntry("sign_of_the_horns_tone5", new String(new int[] {0x1f918,0x1f3ff}, 0, 2));
		_addEntry("signal_strength", new String(new int[] {0x1f4f6}, 0, 1));
		_addEntry("six", new String(new int[] {0x0036,0x20e3}, 0, 2));
		_addEntry("six_pointed_star", new String(new int[] {0x1f52f}, 0, 1));
	}
	private static void init26(){
		_addEntry("sj", new String(new int[] {0x1f1f8,0x1f1ef}, 0, 2));
		_addEntry("sk", new String(new int[] {0x1f1f8,0x1f1f0}, 0, 2));
		_addEntry("skeleton", new String(new int[] {0x1f480}, 0, 1));
		_addEntry("ski", new String(new int[] {0x1f3bf}, 0, 1));
		_addEntry("skier", new String(new int[] {0x26f7}, 0, 1));
		_addEntry("skull", new String(new int[] {0x1f480}, 0, 1));
		_addEntry("skull_and_crossbones", new String(new int[] {0x2620}, 0, 1));
		_addEntry("skull_crossbones", new String(new int[] {0x2620}, 0, 1));
		_addEntry("sl", new String(new int[] {0x1f1f8,0x1f1f1}, 0, 2));
		_addEntry("sleeping", new String(new int[] {0x1f634}, 0, 1));
		_addEntry("sleeping_accommodation", new String(new int[] {0x1f6cc}, 0, 1));
		_addEntry("sleepy", new String(new int[] {0x1f62a}, 0, 1));
		_addEntry("sleuth_or_spy", new String(new int[] {0x1f575}, 0, 1));
		_addEntry("sleuth_or_spy_tone1", new String(new int[] {0x1f575,0x1f3fb}, 0, 2));
		_addEntry("sleuth_or_spy_tone2", new String(new int[] {0x1f575,0x1f3fc}, 0, 2));
		_addEntry("sleuth_or_spy_tone3", new String(new int[] {0x1f575,0x1f3fd}, 0, 2));
		_addEntry("sleuth_or_spy_tone4", new String(new int[] {0x1f575,0x1f3fe}, 0, 2));
		_addEntry("sleuth_or_spy_tone5", new String(new int[] {0x1f575,0x1f3ff}, 0, 2));
		_addEntry("slight_frown", new String(new int[] {0x1f641}, 0, 1));
		_addEntry("slight_smile", new String(new int[] {0x1f642}, 0, 1));
		_addEntry("slightly_frowning_face", new String(new int[] {0x1f641}, 0, 1));
		_addEntry("slightly_smiling_face", new String(new int[] {0x1f642}, 0, 1));
		_addEntry("slot_machine", new String(new int[] {0x1f3b0}, 0, 1));
		_addEntry("sm", new String(new int[] {0x1f1f8,0x1f1f2}, 0, 2));
		_addEntry("small_airplane", new String(new int[] {0x1f6e9}, 0, 1));
		_addEntry("small_blue_diamond", new String(new int[] {0x1f539}, 0, 1));
		_addEntry("small_orange_diamond", new String(new int[] {0x1f538}, 0, 1));
		_addEntry("small_red_triangle", new String(new int[] {0x1f53a}, 0, 1));
		_addEntry("small_red_triangle_down", new String(new int[] {0x1f53b}, 0, 1));
		_addEntry("smile", new String(new int[] {0x1f604}, 0, 1));
		_addEntry("smile_cat", new String(new int[] {0x1f638}, 0, 1));
		_addEntry("smiley", new String(new int[] {0x1f603}, 0, 1));
		_addEntry("smiley_cat", new String(new int[] {0x1f63a}, 0, 1));
		_addEntry("smiling_imp", new String(new int[] {0x1f608}, 0, 1));
		_addEntry("smirk", new String(new int[] {0x1f60f}, 0, 1));
		_addEntry("smirk_cat", new String(new int[] {0x1f63c}, 0, 1));
		_addEntry("smoking", new String(new int[] {0x1f6ac}, 0, 1));
		_addEntry("sn", new String(new int[] {0x1f1f8,0x1f1f3}, 0, 2));
		_addEntry("snail", new String(new int[] {0x1f40c}, 0, 1));
		_addEntry("snake", new String(new int[] {0x1f40d}, 0, 1));
		_addEntry("sneeze", new String(new int[] {0x1f927}, 0, 1));
		_addEntry("sneezing_face", new String(new int[] {0x1f927}, 0, 1));
		_addEntry("snow_capped_mountain", new String(new int[] {0x1f3d4}, 0, 1));
		_addEntry("snowboarder", new String(new int[] {0x1f3c2}, 0, 1));
		_addEntry("snowboarder_dark_skin_tone", new String(new int[] {0x1f3c2,0x1f3ff}, 0, 2));
		_addEntry("snowboarder_light_skin_tone", new String(new int[] {0x1f3c2,0x1f3fb}, 0, 2));
		_addEntry("snowboarder_medium_dark_skin_tone", new String(new int[] {0x1f3c2,0x1f3fe}, 0, 2));
		_addEntry("snowboarder_medium_light_skin_tone", new String(new int[] {0x1f3c2,0x1f3fc}, 0, 2));
		_addEntry("snowboarder_medium_skin_tone", new String(new int[] {0x1f3c2,0x1f3fd}, 0, 2));
		_addEntry("snowboarder_tone1", new String(new int[] {0x1f3c2,0x1f3fb}, 0, 2));
		_addEntry("snowboarder_tone2", new String(new int[] {0x1f3c2,0x1f3fc}, 0, 2));
		_addEntry("snowboarder_tone3", new String(new int[] {0x1f3c2,0x1f3fd}, 0, 2));
		_addEntry("snowboarder_tone4", new String(new int[] {0x1f3c2,0x1f3fe}, 0, 2));
		_addEntry("snowboarder_tone5", new String(new int[] {0x1f3c2,0x1f3ff}, 0, 2));
		_addEntry("snowflake", new String(new int[] {0x2744}, 0, 1));
		_addEntry("snowman", new String(new int[] {0x26c4}, 0, 1));
		_addEntry("snowman2", new String(new int[] {0x2603}, 0, 1));
		_addEntry("so", new String(new int[] {0x1f1f8,0x1f1f4}, 0, 2));
		_addEntry("sob", new String(new int[] {0x1f62d}, 0, 1));
		_addEntry("soccer", new String(new int[] {0x26bd}, 0, 1));
		_addEntry("soon", new String(new int[] {0x1f51c}, 0, 1));
		_addEntry("sos", new String(new int[] {0x1f198}, 0, 1));
		_addEntry("sound", new String(new int[] {0x1f509}, 0, 1));
		_addEntry("space_invader", new String(new int[] {0x1f47e}, 0, 1));
		_addEntry("spades", new String(new int[] {0x2660}, 0, 1));
		_addEntry("spaghetti", new String(new int[] {0x1f35d}, 0, 1));
		_addEntry("sparkle", new String(new int[] {0x2747}, 0, 1));
		_addEntry("sparkler", new String(new int[] {0x1f387}, 0, 1));
		_addEntry("sparkles", new String(new int[] {0x2728}, 0, 1));
		_addEntry("sparkling_heart", new String(new int[] {0x1f496}, 0, 1));
		_addEntry("speak_no_evil", new String(new int[] {0x1f64a}, 0, 1));
		_addEntry("speaker", new String(new int[] {0x1f508}, 0, 1));
		_addEntry("speaking_head", new String(new int[] {0x1f5e3}, 0, 1));
		_addEntry("speaking_head_in_silhouette", new String(new int[] {0x1f5e3}, 0, 1));
		_addEntry("speech_balloon", new String(new int[] {0x1f4ac}, 0, 1));
		_addEntry("speech_left", new String(new int[] {0x1f5e8}, 0, 1));
		_addEntry("speedboat", new String(new int[] {0x1f6a4}, 0, 1));
		_addEntry("spider", new String(new int[] {0x1f577}, 0, 1));
		_addEntry("spider_web", new String(new int[] {0x1f578}, 0, 1));
		_addEntry("spiral_calendar_pad", new String(new int[] {0x1f5d3}, 0, 1));
		_addEntry("spiral_note_pad", new String(new int[] {0x1f5d2}, 0, 1));
		_addEntry("spoon", new String(new int[] {0x1f944}, 0, 1));
		_addEntry("sports_medal", new String(new int[] {0x1f3c5}, 0, 1));
		_addEntry("spy", new String(new int[] {0x1f575}, 0, 1));
		_addEntry("spy_tone1", new String(new int[] {0x1f575,0x1f3fb}, 0, 2));
		_addEntry("spy_tone2", new String(new int[] {0x1f575,0x1f3fc}, 0, 2));
		_addEntry("spy_tone3", new String(new int[] {0x1f575,0x1f3fd}, 0, 2));
		_addEntry("spy_tone4", new String(new int[] {0x1f575,0x1f3fe}, 0, 2));
		_addEntry("spy_tone5", new String(new int[] {0x1f575,0x1f3ff}, 0, 2));
		_addEntry("squid", new String(new int[] {0x1f991}, 0, 1));
		_addEntry("sr", new String(new int[] {0x1f1f8,0x1f1f7}, 0, 2));
		_addEntry("ss", new String(new int[] {0x1f1f8,0x1f1f8}, 0, 2));
		_addEntry("st", new String(new int[] {0x1f1f8,0x1f1f9}, 0, 2));
		_addEntry("stadium", new String(new int[] {0x1f3df}, 0, 1));
		_addEntry("star", new String(new int[] {0x2b50}, 0, 1));
		_addEntry("star2", new String(new int[] {0x1f31f}, 0, 1));
		_addEntry("star_and_crescent", new String(new int[] {0x262a}, 0, 1));
		_addEntry("star_of_david", new String(new int[] {0x2721}, 0, 1));
		_addEntry("stars", new String(new int[] {0x1f320}, 0, 1));
		_addEntry("station", new String(new int[] {0x1f689}, 0, 1));
		_addEntry("statue_of_liberty", new String(new int[] {0x1f5fd}, 0, 1));
	}
	private static void init27(){
		_addEntry("steam_locomotive", new String(new int[] {0x1f682}, 0, 1));
		_addEntry("stew", new String(new int[] {0x1f372}, 0, 1));
		_addEntry("stop_button", new String(new int[] {0x23f9}, 0, 1));
		_addEntry("stop_sign", new String(new int[] {0x1f6d1}, 0, 1));
		_addEntry("stopwatch", new String(new int[] {0x23f1}, 0, 1));
		_addEntry("straight_ruler", new String(new int[] {0x1f4cf}, 0, 1));
		_addEntry("strawberry", new String(new int[] {0x1f353}, 0, 1));
		_addEntry("stuck_out_tongue", new String(new int[] {0x1f61b}, 0, 1));
		_addEntry("stuck_out_tongue_closed_eyes", new String(new int[] {0x1f61d}, 0, 1));
		_addEntry("stuck_out_tongue_winking_eye", new String(new int[] {0x1f61c}, 0, 1));
		_addEntry("studio_microphone", new String(new int[] {0x1f399}, 0, 1));
		_addEntry("stuffed_flatbread", new String(new int[] {0x1f959}, 0, 1));
		_addEntry("stuffed_pita", new String(new int[] {0x1f959}, 0, 1));
		_addEntry("sun_with_face", new String(new int[] {0x1f31e}, 0, 1));
		_addEntry("sunflower", new String(new int[] {0x1f33b}, 0, 1));
		_addEntry("sunglasses", new String(new int[] {0x1f60e}, 0, 1));
		_addEntry("sunny", new String(new int[] {0x2600}, 0, 1));
		_addEntry("sunrise", new String(new int[] {0x1f305}, 0, 1));
		_addEntry("sunrise_over_mountains", new String(new int[] {0x1f304}, 0, 1));
		_addEntry("surfer", new String(new int[] {0x1f3c4}, 0, 1));
		_addEntry("surfer_tone1", new String(new int[] {0x1f3c4,0x1f3fb}, 0, 2));
		_addEntry("surfer_tone2", new String(new int[] {0x1f3c4,0x1f3fc}, 0, 2));
		_addEntry("surfer_tone3", new String(new int[] {0x1f3c4,0x1f3fd}, 0, 2));
		_addEntry("surfer_tone4", new String(new int[] {0x1f3c4,0x1f3fe}, 0, 2));
		_addEntry("surfer_tone5", new String(new int[] {0x1f3c4,0x1f3ff}, 0, 2));
		_addEntry("sushi", new String(new int[] {0x1f363}, 0, 1));
		_addEntry("suspension_railway", new String(new int[] {0x1f69f}, 0, 1));
		_addEntry("sv", new String(new int[] {0x1f1f8,0x1f1fb}, 0, 2));
		_addEntry("sweat", new String(new int[] {0x1f613}, 0, 1));
		_addEntry("sweat_drops", new String(new int[] {0x1f4a6}, 0, 1));
		_addEntry("sweat_smile", new String(new int[] {0x1f605}, 0, 1));
		_addEntry("sweet_potato", new String(new int[] {0x1f360}, 0, 1));
		_addEntry("swimmer", new String(new int[] {0x1f3ca}, 0, 1));
		_addEntry("swimmer_tone1", new String(new int[] {0x1f3ca,0x1f3fb}, 0, 2));
		_addEntry("swimmer_tone2", new String(new int[] {0x1f3ca,0x1f3fc}, 0, 2));
		_addEntry("swimmer_tone3", new String(new int[] {0x1f3ca,0x1f3fd}, 0, 2));
		_addEntry("swimmer_tone4", new String(new int[] {0x1f3ca,0x1f3fe}, 0, 2));
		_addEntry("swimmer_tone5", new String(new int[] {0x1f3ca,0x1f3ff}, 0, 2));
		_addEntry("sx", new String(new int[] {0x1f1f8,0x1f1fd}, 0, 2));
		_addEntry("sy", new String(new int[] {0x1f1f8,0x1f1fe}, 0, 2));
		_addEntry("symbols", new String(new int[] {0x1f523}, 0, 1));
		_addEntry("synagogue", new String(new int[] {0x1f54d}, 0, 1));
		_addEntry("syringe", new String(new int[] {0x1f489}, 0, 1));
		_addEntry("sz", new String(new int[] {0x1f1f8,0x1f1ff}, 0, 2));
		_addEntry("ta", new String(new int[] {0x1f1f9,0x1f1e6}, 0, 2));
		_addEntry("table_tennis", new String(new int[] {0x1f3d3}, 0, 1));
		_addEntry("taco", new String(new int[] {0x1f32e}, 0, 1));
		_addEntry("tada", new String(new int[] {0x1f389}, 0, 1));
		_addEntry("tanabata_tree", new String(new int[] {0x1f38b}, 0, 1));
		_addEntry("tangerine", new String(new int[] {0x1f34a}, 0, 1));
		_addEntry("taurus", new String(new int[] {0x2649}, 0, 1));
		_addEntry("taxi", new String(new int[] {0x1f695}, 0, 1));
		_addEntry("tc", new String(new int[] {0x1f1f9,0x1f1e8}, 0, 2));
		_addEntry("td", new String(new int[] {0x1f1f9,0x1f1e9}, 0, 2));
		_addEntry("tea", new String(new int[] {0x1f375}, 0, 1));
		_addEntry("telephone", new String(new int[] {0x260e}, 0, 1));
		_addEntry("telephone_receiver", new String(new int[] {0x1f4de}, 0, 1));
		_addEntry("telescope", new String(new int[] {0x1f52d}, 0, 1));
		_addEntry("tennis", new String(new int[] {0x1f3be}, 0, 1));
		_addEntry("tent", new String(new int[] {0x26fa}, 0, 1));
		_addEntry("tf", new String(new int[] {0x1f1f9,0x1f1eb}, 0, 2));
		_addEntry("tg", new String(new int[] {0x1f1f9,0x1f1ec}, 0, 2));
		_addEntry("th", new String(new int[] {0x1f1f9,0x1f1ed}, 0, 2));
		_addEntry("thermometer", new String(new int[] {0x1f321}, 0, 1));
		_addEntry("thermometer_face", new String(new int[] {0x1f912}, 0, 1));
		_addEntry("thinking", new String(new int[] {0x1f914}, 0, 1));
		_addEntry("thinking_face", new String(new int[] {0x1f914}, 0, 1));
		_addEntry("third_place", new String(new int[] {0x1f949}, 0, 1));
		_addEntry("third_place_medal", new String(new int[] {0x1f949}, 0, 1));
		_addEntry("thought_balloon", new String(new int[] {0x1f4ad}, 0, 1));
		_addEntry("three", new String(new int[] {0x0033,0x20e3}, 0, 2));
		_addEntry("three_button_mouse", new String(new int[] {0x1f5b1}, 0, 1));
		_addEntry("thumbdown", new String(new int[] {0x1f44e}, 0, 1));
		_addEntry("thumbdown_tone1", new String(new int[] {0x1f44e,0x1f3fb}, 0, 2));
		_addEntry("thumbdown_tone2", new String(new int[] {0x1f44e,0x1f3fc}, 0, 2));
		_addEntry("thumbdown_tone3", new String(new int[] {0x1f44e,0x1f3fd}, 0, 2));
		_addEntry("thumbdown_tone4", new String(new int[] {0x1f44e,0x1f3fe}, 0, 2));
		_addEntry("thumbdown_tone5", new String(new int[] {0x1f44e,0x1f3ff}, 0, 2));
		_addEntry("thumbsdown", new String(new int[] {0x1f44e}, 0, 1));
		_addEntry("thumbsdown_tone1", new String(new int[] {0x1f44e,0x1f3fb}, 0, 2));
		_addEntry("thumbsdown_tone2", new String(new int[] {0x1f44e,0x1f3fc}, 0, 2));
		_addEntry("thumbsdown_tone3", new String(new int[] {0x1f44e,0x1f3fd}, 0, 2));
		_addEntry("thumbsdown_tone4", new String(new int[] {0x1f44e,0x1f3fe}, 0, 2));
		_addEntry("thumbsdown_tone5", new String(new int[] {0x1f44e,0x1f3ff}, 0, 2));
		_addEntry("thumbsup", new String(new int[] {0x1f44d}, 0, 1));
		_addEntry("thumbsup_tone1", new String(new int[] {0x1f44d,0x1f3fb}, 0, 2));
		_addEntry("thumbsup_tone2", new String(new int[] {0x1f44d,0x1f3fc}, 0, 2));
		_addEntry("thumbsup_tone3", new String(new int[] {0x1f44d,0x1f3fd}, 0, 2));
		_addEntry("thumbsup_tone4", new String(new int[] {0x1f44d,0x1f3fe}, 0, 2));
		_addEntry("thumbsup_tone5", new String(new int[] {0x1f44d,0x1f3ff}, 0, 2));
		_addEntry("thumbup", new String(new int[] {0x1f44d}, 0, 1));
		_addEntry("thumbup_tone1", new String(new int[] {0x1f44d,0x1f3fb}, 0, 2));
		_addEntry("thumbup_tone2", new String(new int[] {0x1f44d,0x1f3fc}, 0, 2));
		_addEntry("thumbup_tone3", new String(new int[] {0x1f44d,0x1f3fd}, 0, 2));
		_addEntry("thumbup_tone4", new String(new int[] {0x1f44d,0x1f3fe}, 0, 2));
		_addEntry("thumbup_tone5", new String(new int[] {0x1f44d,0x1f3ff}, 0, 2));
		_addEntry("thunder_cloud_and_rain", new String(new int[] {0x26c8}, 0, 1));
		_addEntry("thunder_cloud_rain", new String(new int[] {0x26c8}, 0, 1));
		_addEntry("ticket", new String(new int[] {0x1f3ab}, 0, 1));
		_addEntry("tickets", new String(new int[] {0x1f39f}, 0, 1));
		_addEntry("tiger", new String(new int[] {0x1f42f}, 0, 1));
	}
	private static void init28(){
		_addEntry("tiger2", new String(new int[] {0x1f405}, 0, 1));
		_addEntry("timer", new String(new int[] {0x23f2}, 0, 1));
		_addEntry("timer_clock", new String(new int[] {0x23f2}, 0, 1));
		_addEntry("tired_face", new String(new int[] {0x1f62b}, 0, 1));
		_addEntry("tj", new String(new int[] {0x1f1f9,0x1f1ef}, 0, 2));
		_addEntry("tk", new String(new int[] {0x1f1f9,0x1f1f0}, 0, 2));
		_addEntry("tl", new String(new int[] {0x1f1f9,0x1f1f1}, 0, 2));
		_addEntry("tm", new String(new int[] {0x2122}, 0, 1));
		_addEntry("tn", new String(new int[] {0x1f1f9,0x1f1f3}, 0, 2));
		_addEntry("to", new String(new int[] {0x1f1f9,0x1f1f4}, 0, 2));
		_addEntry("toilet", new String(new int[] {0x1f6bd}, 0, 1));
		_addEntry("tokyo_tower", new String(new int[] {0x1f5fc}, 0, 1));
		_addEntry("tomato", new String(new int[] {0x1f345}, 0, 1));
		_addEntry("tone1", new String(new int[] {0x1f3fb}, 0, 1));
		_addEntry("tone2", new String(new int[] {0x1f3fc}, 0, 1));
		_addEntry("tone3", new String(new int[] {0x1f3fd}, 0, 1));
		_addEntry("tone4", new String(new int[] {0x1f3fe}, 0, 1));
		_addEntry("tone5", new String(new int[] {0x1f3ff}, 0, 1));
		_addEntry("tongue", new String(new int[] {0x1f445}, 0, 1));
		_addEntry("tools", new String(new int[] {0x1f6e0}, 0, 1));
		_addEntry("top", new String(new int[] {0x1f51d}, 0, 1));
		_addEntry("tophat", new String(new int[] {0x1f3a9}, 0, 1));
		_addEntry("tr", new String(new int[] {0x1f1f9,0x1f1f7}, 0, 2));
		_addEntry("track_next", new String(new int[] {0x23ed}, 0, 1));
		_addEntry("track_previous", new String(new int[] {0x23ee}, 0, 1));
		_addEntry("trackball", new String(new int[] {0x1f5b2}, 0, 1));
		_addEntry("tractor", new String(new int[] {0x1f69c}, 0, 1));
		_addEntry("traffic_light", new String(new int[] {0x1f6a5}, 0, 1));
		_addEntry("train", new String(new int[] {0x1f68b}, 0, 1));
		_addEntry("train2", new String(new int[] {0x1f686}, 0, 1));
		_addEntry("tram", new String(new int[] {0x1f68a}, 0, 1));
		_addEntry("triangular_flag_on_post", new String(new int[] {0x1f6a9}, 0, 1));
		_addEntry("triangular_ruler", new String(new int[] {0x1f4d0}, 0, 1));
		_addEntry("trident", new String(new int[] {0x1f531}, 0, 1));
		_addEntry("triumph", new String(new int[] {0x1f624}, 0, 1));
		_addEntry("trolleybus", new String(new int[] {0x1f68e}, 0, 1));
		_addEntry("trophy", new String(new int[] {0x1f3c6}, 0, 1));
		_addEntry("tropical_drink", new String(new int[] {0x1f379}, 0, 1));
		_addEntry("tropical_fish", new String(new int[] {0x1f420}, 0, 1));
		_addEntry("truck", new String(new int[] {0x1f69a}, 0, 1));
		_addEntry("trumpet", new String(new int[] {0x1f3ba}, 0, 1));
		_addEntry("tt", new String(new int[] {0x1f1f9,0x1f1f9}, 0, 2));
		_addEntry("tulip", new String(new int[] {0x1f337}, 0, 1));
		_addEntry("tumbler_glass", new String(new int[] {0x1f943}, 0, 1));
		_addEntry("turkey", new String(new int[] {0x1f983}, 0, 1));
		_addEntry("turkmenistan", new String(new int[] {0x1f1f9,0x1f1f2}, 0, 2));
		_addEntry("turtle", new String(new int[] {0x1f422}, 0, 1));
		_addEntry("tuvalu", new String(new int[] {0x1f1f9,0x1f1fb}, 0, 2));
		_addEntry("tuxedo_tone1", new String(new int[] {0x1f935,0x1f3fb}, 0, 2));
		_addEntry("tuxedo_tone2", new String(new int[] {0x1f935,0x1f3fc}, 0, 2));
		_addEntry("tuxedo_tone3", new String(new int[] {0x1f935,0x1f3fd}, 0, 2));
		_addEntry("tuxedo_tone4", new String(new int[] {0x1f935,0x1f3fe}, 0, 2));
		_addEntry("tuxedo_tone5", new String(new int[] {0x1f935,0x1f3ff}, 0, 2));
		_addEntry("tv", new String(new int[] {0x1f4fa}, 0, 1));
		_addEntry("tw", new String(new int[] {0x1f1f9,0x1f1fc}, 0, 2));
		_addEntry("twisted_rightwards_arrows", new String(new int[] {0x1f500}, 0, 1));
		_addEntry("two", new String(new int[] {0x0032,0x20e3}, 0, 2));
		_addEntry("two_hearts", new String(new int[] {0x1f495}, 0, 1));
		_addEntry("two_men_holding_hands", new String(new int[] {0x1f46c}, 0, 1));
		_addEntry("two_women_holding_hands", new String(new int[] {0x1f46d}, 0, 1));
		_addEntry("tz", new String(new int[] {0x1f1f9,0x1f1ff}, 0, 2));
		_addEntry("u5272", new String(new int[] {0x1f239}, 0, 1));
		_addEntry("u5408", new String(new int[] {0x1f234}, 0, 1));
		_addEntry("u55b6", new String(new int[] {0x1f23a}, 0, 1));
		_addEntry("u6307", new String(new int[] {0x1f22f}, 0, 1));
		_addEntry("u6708", new String(new int[] {0x1f237}, 0, 1));
		_addEntry("u6709", new String(new int[] {0x1f236}, 0, 1));
		_addEntry("u6e80", new String(new int[] {0x1f235}, 0, 1));
		_addEntry("u7121", new String(new int[] {0x1f21a}, 0, 1));
		_addEntry("u7533", new String(new int[] {0x1f238}, 0, 1));
		_addEntry("u7981", new String(new int[] {0x1f232}, 0, 1));
		_addEntry("u7a7a", new String(new int[] {0x1f233}, 0, 1));
		_addEntry("ua", new String(new int[] {0x1f1fa,0x1f1e6}, 0, 2));
		_addEntry("ug", new String(new int[] {0x1f1fa,0x1f1ec}, 0, 2));
		_addEntry("um", new String(new int[] {0x1f1fa,0x1f1f2}, 0, 2));
		_addEntry("umbrella", new String(new int[] {0x2614}, 0, 1));
		_addEntry("umbrella2", new String(new int[] {0x2602}, 0, 1));
		_addEntry("umbrella_on_ground", new String(new int[] {0x26f1}, 0, 1));
		_addEntry("unamused", new String(new int[] {0x1f612}, 0, 1));
		_addEntry("underage", new String(new int[] {0x1f51e}, 0, 1));
		_addEntry("unicorn", new String(new int[] {0x1f984}, 0, 1));
		_addEntry("unicorn_face", new String(new int[] {0x1f984}, 0, 1));
		_addEntry("united_nations", new String(new int[] {0x1f1fa,0x1f1f3}, 0, 2));
		_addEntry("unlock", new String(new int[] {0x1f513}, 0, 1));
		_addEntry("up", new String(new int[] {0x1f199}, 0, 1));
		_addEntry("upside_down", new String(new int[] {0x1f643}, 0, 1));
		_addEntry("upside_down_face", new String(new int[] {0x1f643}, 0, 1));
		_addEntry("urn", new String(new int[] {0x26b1}, 0, 1));
		_addEntry("us", new String(new int[] {0x1f1fa,0x1f1f8}, 0, 2));
		_addEntry("uy", new String(new int[] {0x1f1fa,0x1f1fe}, 0, 2));
		_addEntry("uz", new String(new int[] {0x1f1fa,0x1f1ff}, 0, 2));
		_addEntry("v", new String(new int[] {0x270c}, 0, 1));
		_addEntry("v_tone1", new String(new int[] {0x270c,0x1f3fb}, 0, 2));
		_addEntry("v_tone2", new String(new int[] {0x270c,0x1f3fc}, 0, 2));
		_addEntry("v_tone3", new String(new int[] {0x270c,0x1f3fd}, 0, 2));
		_addEntry("v_tone4", new String(new int[] {0x270c,0x1f3fe}, 0, 2));
		_addEntry("v_tone5", new String(new int[] {0x270c,0x1f3ff}, 0, 2));
		_addEntry("va", new String(new int[] {0x1f1fb,0x1f1e6}, 0, 2));
		_addEntry("vc", new String(new int[] {0x1f1fb,0x1f1e8}, 0, 2));
		_addEntry("ve", new String(new int[] {0x1f1fb,0x1f1ea}, 0, 2));
		_addEntry("vertical_traffic_light", new String(new int[] {0x1f6a6}, 0, 1));
	}
	private static void init29(){
		_addEntry("vg", new String(new int[] {0x1f1fb,0x1f1ec}, 0, 2));
		_addEntry("vhs", new String(new int[] {0x1f4fc}, 0, 1));
		_addEntry("vi", new String(new int[] {0x1f1fb,0x1f1ee}, 0, 2));
		_addEntry("vibration_mode", new String(new int[] {0x1f4f3}, 0, 1));
		_addEntry("video_camera", new String(new int[] {0x1f4f9}, 0, 1));
		_addEntry("video_game", new String(new int[] {0x1f3ae}, 0, 1));
		_addEntry("violin", new String(new int[] {0x1f3bb}, 0, 1));
		_addEntry("virgo", new String(new int[] {0x264d}, 0, 1));
		_addEntry("vn", new String(new int[] {0x1f1fb,0x1f1f3}, 0, 2));
		_addEntry("volcano", new String(new int[] {0x1f30b}, 0, 1));
		_addEntry("volleyball", new String(new int[] {0x1f3d0}, 0, 1));
		_addEntry("vs", new String(new int[] {0x1f19a}, 0, 1));
		_addEntry("vu", new String(new int[] {0x1f1fb,0x1f1fa}, 0, 2));
		_addEntry("vulcan", new String(new int[] {0x1f596}, 0, 1));
		_addEntry("vulcan_tone1", new String(new int[] {0x1f596,0x1f3fb}, 0, 2));
		_addEntry("vulcan_tone2", new String(new int[] {0x1f596,0x1f3fc}, 0, 2));
		_addEntry("vulcan_tone3", new String(new int[] {0x1f596,0x1f3fd}, 0, 2));
		_addEntry("vulcan_tone4", new String(new int[] {0x1f596,0x1f3fe}, 0, 2));
		_addEntry("vulcan_tone5", new String(new int[] {0x1f596,0x1f3ff}, 0, 2));
		_addEntry("walking", new String(new int[] {0x1f6b6}, 0, 1));
		_addEntry("walking_tone1", new String(new int[] {0x1f6b6,0x1f3fb}, 0, 2));
		_addEntry("walking_tone2", new String(new int[] {0x1f6b6,0x1f3fc}, 0, 2));
		_addEntry("walking_tone3", new String(new int[] {0x1f6b6,0x1f3fd}, 0, 2));
		_addEntry("walking_tone4", new String(new int[] {0x1f6b6,0x1f3fe}, 0, 2));
		_addEntry("walking_tone5", new String(new int[] {0x1f6b6,0x1f3ff}, 0, 2));
		_addEntry("waning_crescent_moon", new String(new int[] {0x1f318}, 0, 1));
		_addEntry("waning_gibbous_moon", new String(new int[] {0x1f316}, 0, 1));
		_addEntry("warning", new String(new int[] {0x26a0}, 0, 1));
		_addEntry("wastebasket", new String(new int[] {0x1f5d1}, 0, 1));
		_addEntry("watch", new String(new int[] {0x231a}, 0, 1));
		_addEntry("water_buffalo", new String(new int[] {0x1f403}, 0, 1));
		_addEntry("water_polo", new String(new int[] {0x1f93d}, 0, 1));
		_addEntry("water_polo_tone1", new String(new int[] {0x1f93d,0x1f3fb}, 0, 2));
		_addEntry("water_polo_tone2", new String(new int[] {0x1f93d,0x1f3fc}, 0, 2));
		_addEntry("water_polo_tone3", new String(new int[] {0x1f93d,0x1f3fd}, 0, 2));
		_addEntry("water_polo_tone4", new String(new int[] {0x1f93d,0x1f3fe}, 0, 2));
		_addEntry("water_polo_tone5", new String(new int[] {0x1f93d,0x1f3ff}, 0, 2));
		_addEntry("watermelon", new String(new int[] {0x1f349}, 0, 1));
		_addEntry("wave", new String(new int[] {0x1f44b}, 0, 1));
		_addEntry("wave_tone1", new String(new int[] {0x1f44b,0x1f3fb}, 0, 2));
		_addEntry("wave_tone2", new String(new int[] {0x1f44b,0x1f3fc}, 0, 2));
		_addEntry("wave_tone3", new String(new int[] {0x1f44b,0x1f3fd}, 0, 2));
		_addEntry("wave_tone4", new String(new int[] {0x1f44b,0x1f3fe}, 0, 2));
		_addEntry("wave_tone5", new String(new int[] {0x1f44b,0x1f3ff}, 0, 2));
		_addEntry("waving_black_flag", new String(new int[] {0x1f3f4}, 0, 1));
		_addEntry("waving_white_flag", new String(new int[] {0x1f3f3}, 0, 1));
		_addEntry("wavy_dash", new String(new int[] {0x3030}, 0, 1));
		_addEntry("waxing_crescent_moon", new String(new int[] {0x1f312}, 0, 1));
		_addEntry("waxing_gibbous_moon", new String(new int[] {0x1f314}, 0, 1));
		_addEntry("wc", new String(new int[] {0x1f6be}, 0, 1));
		_addEntry("weary", new String(new int[] {0x1f629}, 0, 1));
		_addEntry("wedding", new String(new int[] {0x1f492}, 0, 1));
		_addEntry("weight_lifter", new String(new int[] {0x1f3cb}, 0, 1));
		_addEntry("weight_lifter_tone1", new String(new int[] {0x1f3cb,0x1f3fb}, 0, 2));
		_addEntry("weight_lifter_tone2", new String(new int[] {0x1f3cb,0x1f3fc}, 0, 2));
		_addEntry("weight_lifter_tone3", new String(new int[] {0x1f3cb,0x1f3fd}, 0, 2));
		_addEntry("weight_lifter_tone4", new String(new int[] {0x1f3cb,0x1f3fe}, 0, 2));
		_addEntry("weight_lifter_tone5", new String(new int[] {0x1f3cb,0x1f3ff}, 0, 2));
		_addEntry("wf", new String(new int[] {0x1f1fc,0x1f1eb}, 0, 2));
		_addEntry("whale", new String(new int[] {0x1f433}, 0, 1));
		_addEntry("whale2", new String(new int[] {0x1f40b}, 0, 1));
		_addEntry("wheel_of_dharma", new String(new int[] {0x2638}, 0, 1));
		_addEntry("wheelchair", new String(new int[] {0x267f}, 0, 1));
		_addEntry("whisky", new String(new int[] {0x1f943}, 0, 1));
		_addEntry("white_check_mark", new String(new int[] {0x2705}, 0, 1));
		_addEntry("white_circle", new String(new int[] {0x26aa}, 0, 1));
		_addEntry("white_flower", new String(new int[] {0x1f4ae}, 0, 1));
		_addEntry("white_frowning_face", new String(new int[] {0x2639}, 0, 1));
		_addEntry("white_large_square", new String(new int[] {0x2b1c}, 0, 1));
		_addEntry("white_medium_small_square", new String(new int[] {0x25fd}, 0, 1));
		_addEntry("white_medium_square", new String(new int[] {0x25fb}, 0, 1));
		_addEntry("white_small_square", new String(new int[] {0x25ab}, 0, 1));
		_addEntry("white_square_button", new String(new int[] {0x1f533}, 0, 1));
		_addEntry("white_sun_behind_cloud", new String(new int[] {0x1f325}, 0, 1));
		_addEntry("white_sun_behind_cloud_with_rain", new String(new int[] {0x1f326}, 0, 1));
		_addEntry("white_sun_cloud", new String(new int[] {0x1f325}, 0, 1));
		_addEntry("white_sun_rain_cloud", new String(new int[] {0x1f326}, 0, 1));
		_addEntry("white_sun_small_cloud", new String(new int[] {0x1f324}, 0, 1));
		_addEntry("white_sun_with_small_cloud", new String(new int[] {0x1f324}, 0, 1));
		_addEntry("wilted_flower", new String(new int[] {0x1f940}, 0, 1));
		_addEntry("wilted_rose", new String(new int[] {0x1f940}, 0, 1));
		_addEntry("wind_blowing_face", new String(new int[] {0x1f32c}, 0, 1));
		_addEntry("wind_chime", new String(new int[] {0x1f390}, 0, 1));
		_addEntry("wine_glass", new String(new int[] {0x1f377}, 0, 1));
		_addEntry("wink", new String(new int[] {0x1f609}, 0, 1));
		_addEntry("wolf", new String(new int[] {0x1f43a}, 0, 1));
		_addEntry("woman", new String(new int[] {0x1f469}, 0, 1));
		_addEntry("woman_artist", new String(new int[] {0x1f469,0x1f3a8}, 0, 2));
		_addEntry("woman_artist_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f3a8}, 0, 3));
		_addEntry("woman_artist_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f3a8}, 0, 3));
		_addEntry("woman_artist_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f3a8}, 0, 3));
		_addEntry("woman_artist_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f3a8}, 0, 3));
		_addEntry("woman_artist_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f3a8}, 0, 3));
		_addEntry("woman_artist_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f3a8}, 0, 3));
		_addEntry("woman_artist_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f3a8}, 0, 3));
		_addEntry("woman_artist_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f3a8}, 0, 3));
		_addEntry("woman_artist_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f3a8}, 0, 3));
		_addEntry("woman_artist_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f3a8}, 0, 3));
		_addEntry("woman_astronaut", new String(new int[] {0x1f469,0x1f680}, 0, 2));
		_addEntry("woman_astronaut_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f680}, 0, 3));
		_addEntry("woman_astronaut_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f680}, 0, 3));
	}
	private static void init30(){
		_addEntry("woman_astronaut_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f680}, 0, 3));
		_addEntry("woman_astronaut_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f680}, 0, 3));
		_addEntry("woman_astronaut_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f680}, 0, 3));
		_addEntry("woman_astronaut_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f680}, 0, 3));
		_addEntry("woman_astronaut_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f680}, 0, 3));
		_addEntry("woman_astronaut_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f680}, 0, 3));
		_addEntry("woman_astronaut_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f680}, 0, 3));
		_addEntry("woman_astronaut_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f680}, 0, 3));
		_addEntry("woman_biking", new String(new int[] {0x1f6b4,0x2640}, 0, 2));
		_addEntry("woman_biking_dark_skin_tone", new String(new int[] {0x1f6b4,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_biking_light_skin_tone", new String(new int[] {0x1f6b4,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_biking_medium_dark_skin_tone", new String(new int[] {0x1f6b4,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_biking_medium_light_skin_tone", new String(new int[] {0x1f6b4,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_biking_medium_skin_tone", new String(new int[] {0x1f6b4,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_biking_tone1", new String(new int[] {0x1f6b4,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_biking_tone2", new String(new int[] {0x1f6b4,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_biking_tone3", new String(new int[] {0x1f6b4,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_biking_tone4", new String(new int[] {0x1f6b4,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_biking_tone5", new String(new int[] {0x1f6b4,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_bouncing_ball", new String(new int[] {0x26f9,0x2640}, 0, 2));
		_addEntry("woman_bouncing_ball_dark_skin_tone", new String(new int[] {0x26f9,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_bouncing_ball_light_skin_tone", new String(new int[] {0x26f9,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_bouncing_ball_medium_dark_skin_tone", new String(new int[] {0x26f9,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_bouncing_ball_medium_light_skin_tone", new String(new int[] {0x26f9,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_bouncing_ball_medium_skin_tone", new String(new int[] {0x26f9,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_bouncing_ball_tone1", new String(new int[] {0x26f9,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_bouncing_ball_tone2", new String(new int[] {0x26f9,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_bouncing_ball_tone3", new String(new int[] {0x26f9,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_bouncing_ball_tone4", new String(new int[] {0x26f9,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_bouncing_ball_tone5", new String(new int[] {0x26f9,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_bowing", new String(new int[] {0x1f647,0x2640}, 0, 2));
		_addEntry("woman_bowing_dark_skin_tone", new String(new int[] {0x1f647,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_bowing_light_skin_tone", new String(new int[] {0x1f647,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_bowing_medium_dark_skin_tone", new String(new int[] {0x1f647,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_bowing_medium_light_skin_tone", new String(new int[] {0x1f647,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_bowing_medium_skin_tone", new String(new int[] {0x1f647,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_bowing_tone1", new String(new int[] {0x1f647,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_bowing_tone2", new String(new int[] {0x1f647,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_bowing_tone3", new String(new int[] {0x1f647,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_bowing_tone4", new String(new int[] {0x1f647,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_bowing_tone5", new String(new int[] {0x1f647,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_cartwheeling", new String(new int[] {0x1f938,0x2640}, 0, 2));
		_addEntry("woman_cartwheeling_dark_skin_tone", new String(new int[] {0x1f938,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_cartwheeling_light_skin_tone", new String(new int[] {0x1f938,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_cartwheeling_medium_dark_skin_tone", new String(new int[] {0x1f938,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_cartwheeling_medium_light_skin_tone", new String(new int[] {0x1f938,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_cartwheeling_medium_skin_tone", new String(new int[] {0x1f938,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_cartwheeling_tone1", new String(new int[] {0x1f938,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_cartwheeling_tone2", new String(new int[] {0x1f938,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_cartwheeling_tone3", new String(new int[] {0x1f938,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_cartwheeling_tone4", new String(new int[] {0x1f938,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_cartwheeling_tone5", new String(new int[] {0x1f938,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_construction_worker", new String(new int[] {0x1f477,0x2640}, 0, 2));
		_addEntry("woman_construction_worker_dark_skin_tone", new String(new int[] {0x1f477,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_construction_worker_light_skin_tone", new String(new int[] {0x1f477,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_construction_worker_medium_dark_skin_tone", new String(new int[] {0x1f477,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_construction_worker_medium_light_skin_tone", new String(new int[] {0x1f477,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_construction_worker_medium_skin_tone", new String(new int[] {0x1f477,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_construction_worker_tone1", new String(new int[] {0x1f477,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_construction_worker_tone2", new String(new int[] {0x1f477,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_construction_worker_tone3", new String(new int[] {0x1f477,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_construction_worker_tone4", new String(new int[] {0x1f477,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_construction_worker_tone5", new String(new int[] {0x1f477,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_cook", new String(new int[] {0x1f469,0x1f373}, 0, 2));
		_addEntry("woman_cook_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f373}, 0, 3));
		_addEntry("woman_cook_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f373}, 0, 3));
		_addEntry("woman_cook_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f373}, 0, 3));
		_addEntry("woman_cook_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f373}, 0, 3));
		_addEntry("woman_cook_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f373}, 0, 3));
		_addEntry("woman_cook_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f373}, 0, 3));
		_addEntry("woman_cook_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f373}, 0, 3));
		_addEntry("woman_cook_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f373}, 0, 3));
		_addEntry("woman_cook_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f373}, 0, 3));
		_addEntry("woman_cook_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f373}, 0, 3));
		_addEntry("woman_detective", new String(new int[] {0x1f575,0x2640}, 0, 2));
		_addEntry("woman_detective_dark_skin_tone", new String(new int[] {0x1f575,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_detective_light_skin_tone", new String(new int[] {0x1f575,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_detective_medium_dark_skin_tone", new String(new int[] {0x1f575,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_detective_medium_light_skin_tone", new String(new int[] {0x1f575,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_detective_medium_skin_tone", new String(new int[] {0x1f575,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_detective_tone1", new String(new int[] {0x1f575,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_detective_tone2", new String(new int[] {0x1f575,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_detective_tone3", new String(new int[] {0x1f575,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_detective_tone4", new String(new int[] {0x1f575,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_detective_tone5", new String(new int[] {0x1f575,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_facepalming", new String(new int[] {0x1f926,0x2640}, 0, 2));
		_addEntry("woman_facepalming_dark_skin_tone", new String(new int[] {0x1f926,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_facepalming_light_skin_tone", new String(new int[] {0x1f926,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_facepalming_medium_dark_skin_tone", new String(new int[] {0x1f926,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_facepalming_medium_light_skin_tone", new String(new int[] {0x1f926,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_facepalming_medium_skin_tone", new String(new int[] {0x1f926,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_facepalming_tone1", new String(new int[] {0x1f926,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_facepalming_tone2", new String(new int[] {0x1f926,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_facepalming_tone3", new String(new int[] {0x1f926,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_facepalming_tone4", new String(new int[] {0x1f926,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_facepalming_tone5", new String(new int[] {0x1f926,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_factory_worker", new String(new int[] {0x1f469,0x1f3ed}, 0, 2));
		_addEntry("woman_factory_worker_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f3ed}, 0, 3));
		_addEntry("woman_factory_worker_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f3ed}, 0, 3));
		_addEntry("woman_factory_worker_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f3ed}, 0, 3));
		_addEntry("woman_factory_worker_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f3ed}, 0, 3));
	}
	private static void init31(){
		_addEntry("woman_factory_worker_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f3ed}, 0, 3));
		_addEntry("woman_factory_worker_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f3ed}, 0, 3));
		_addEntry("woman_factory_worker_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f3ed}, 0, 3));
		_addEntry("woman_factory_worker_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f3ed}, 0, 3));
		_addEntry("woman_factory_worker_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f3ed}, 0, 3));
		_addEntry("woman_factory_worker_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f3ed}, 0, 3));
		_addEntry("woman_farmer", new String(new int[] {0x1f469,0x1f33e}, 0, 2));
		_addEntry("woman_farmer_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f33e}, 0, 3));
		_addEntry("woman_farmer_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f33e}, 0, 3));
		_addEntry("woman_farmer_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f33e}, 0, 3));
		_addEntry("woman_farmer_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f33e}, 0, 3));
		_addEntry("woman_farmer_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f33e}, 0, 3));
		_addEntry("woman_farmer_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f33e}, 0, 3));
		_addEntry("woman_farmer_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f33e}, 0, 3));
		_addEntry("woman_farmer_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f33e}, 0, 3));
		_addEntry("woman_farmer_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f33e}, 0, 3));
		_addEntry("woman_farmer_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f33e}, 0, 3));
		_addEntry("woman_firefighter", new String(new int[] {0x1f469,0x1f692}, 0, 2));
		_addEntry("woman_firefighter_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f692}, 0, 3));
		_addEntry("woman_firefighter_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f692}, 0, 3));
		_addEntry("woman_firefighter_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f692}, 0, 3));
		_addEntry("woman_firefighter_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f692}, 0, 3));
		_addEntry("woman_firefighter_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f692}, 0, 3));
		_addEntry("woman_firefighter_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f692}, 0, 3));
		_addEntry("woman_firefighter_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f692}, 0, 3));
		_addEntry("woman_firefighter_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f692}, 0, 3));
		_addEntry("woman_firefighter_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f692}, 0, 3));
		_addEntry("woman_firefighter_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f692}, 0, 3));
		_addEntry("woman_frowning", new String(new int[] {0x1f64d,0x2640}, 0, 2));
		_addEntry("woman_frowning_dark_skin_tone", new String(new int[] {0x1f64d,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_frowning_light_skin_tone", new String(new int[] {0x1f64d,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_frowning_medium_dark_skin_tone", new String(new int[] {0x1f64d,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_frowning_medium_light_skin_tone", new String(new int[] {0x1f64d,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_frowning_medium_skin_tone", new String(new int[] {0x1f64d,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_frowning_tone1", new String(new int[] {0x1f64d,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_frowning_tone2", new String(new int[] {0x1f64d,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_frowning_tone3", new String(new int[] {0x1f64d,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_frowning_tone4", new String(new int[] {0x1f64d,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_frowning_tone5", new String(new int[] {0x1f64d,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_gesturing_no", new String(new int[] {0x1f645,0x2640}, 0, 2));
		_addEntry("woman_gesturing_no_dark_skin_tone", new String(new int[] {0x1f645,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_gesturing_no_light_skin_tone", new String(new int[] {0x1f645,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_gesturing_no_medium_dark_skin_tone", new String(new int[] {0x1f645,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_gesturing_no_medium_light_skin_tone", new String(new int[] {0x1f645,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_gesturing_no_medium_skin_tone", new String(new int[] {0x1f645,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_gesturing_no_tone1", new String(new int[] {0x1f645,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_gesturing_no_tone2", new String(new int[] {0x1f645,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_gesturing_no_tone3", new String(new int[] {0x1f645,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_gesturing_no_tone4", new String(new int[] {0x1f645,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_gesturing_no_tone5", new String(new int[] {0x1f645,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_gesturing_ok", new String(new int[] {0x1f646,0x2640}, 0, 2));
		_addEntry("woman_gesturing_ok_dark_skin_tone", new String(new int[] {0x1f646,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_gesturing_ok_light_skin_tone", new String(new int[] {0x1f646,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_gesturing_ok_medium_dark_skin_tone", new String(new int[] {0x1f646,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_gesturing_ok_medium_light_skin_tone", new String(new int[] {0x1f646,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_gesturing_ok_medium_skin_tone", new String(new int[] {0x1f646,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_gesturing_ok_tone1", new String(new int[] {0x1f646,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_gesturing_ok_tone2", new String(new int[] {0x1f646,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_gesturing_ok_tone3", new String(new int[] {0x1f646,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_gesturing_ok_tone4", new String(new int[] {0x1f646,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_gesturing_ok_tone5", new String(new int[] {0x1f646,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_getting_face_massage", new String(new int[] {0x1f486,0x2640}, 0, 2));
		_addEntry("woman_getting_face_massage_dark_skin_tone", new String(new int[] {0x1f486,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_getting_face_massage_light_skin_tone", new String(new int[] {0x1f486,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_getting_face_massage_medium_dark_skin_tone", new String(new int[] {0x1f486,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_getting_face_massage_medium_light_skin_tone", new String(new int[] {0x1f486,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_getting_face_massage_medium_skin_tone", new String(new int[] {0x1f486,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_getting_face_massage_tone1", new String(new int[] {0x1f486,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_getting_face_massage_tone2", new String(new int[] {0x1f486,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_getting_face_massage_tone3", new String(new int[] {0x1f486,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_getting_face_massage_tone4", new String(new int[] {0x1f486,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_getting_face_massage_tone5", new String(new int[] {0x1f486,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_getting_haircut", new String(new int[] {0x1f487,0x2640}, 0, 2));
		_addEntry("woman_getting_haircut_dark_skin_tone", new String(new int[] {0x1f487,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_getting_haircut_light_skin_tone", new String(new int[] {0x1f487,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_getting_haircut_medium_dark_skin_tone", new String(new int[] {0x1f487,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_getting_haircut_medium_light_skin_tone", new String(new int[] {0x1f487,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_getting_haircut_medium_skin_tone", new String(new int[] {0x1f487,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_getting_haircut_tone1", new String(new int[] {0x1f487,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_getting_haircut_tone2", new String(new int[] {0x1f487,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_getting_haircut_tone3", new String(new int[] {0x1f487,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_getting_haircut_tone4", new String(new int[] {0x1f487,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_getting_haircut_tone5", new String(new int[] {0x1f487,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_golfing", new String(new int[] {0x1f3cc,0x2640}, 0, 2));
		_addEntry("woman_golfing_dark_skin_tone", new String(new int[] {0x1f3cc,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_golfing_light_skin_tone", new String(new int[] {0x1f3cc,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_golfing_medium_dark_skin_tone", new String(new int[] {0x1f3cc,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_golfing_medium_light_skin_tone", new String(new int[] {0x1f3cc,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_golfing_medium_skin_tone", new String(new int[] {0x1f3cc,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_golfing_tone1", new String(new int[] {0x1f3cc,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_golfing_tone2", new String(new int[] {0x1f3cc,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_golfing_tone3", new String(new int[] {0x1f3cc,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_golfing_tone4", new String(new int[] {0x1f3cc,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_golfing_tone5", new String(new int[] {0x1f3cc,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_guard", new String(new int[] {0x1f482,0x2640}, 0, 2));
		_addEntry("woman_guard_dark_skin_tone", new String(new int[] {0x1f482,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_guard_light_skin_tone", new String(new int[] {0x1f482,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_guard_medium_dark_skin_tone", new String(new int[] {0x1f482,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_guard_medium_light_skin_tone", new String(new int[] {0x1f482,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_guard_medium_skin_tone", new String(new int[] {0x1f482,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_guard_tone1", new String(new int[] {0x1f482,0x1f3fb,0x2640}, 0, 3));
	}
	private static void init32(){
		_addEntry("woman_guard_tone2", new String(new int[] {0x1f482,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_guard_tone3", new String(new int[] {0x1f482,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_guard_tone4", new String(new int[] {0x1f482,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_guard_tone5", new String(new int[] {0x1f482,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_health_worker", new String(new int[] {0x1f469,0x2695}, 0, 2));
		_addEntry("woman_health_worker_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x2695}, 0, 3));
		_addEntry("woman_health_worker_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x2695}, 0, 3));
		_addEntry("woman_health_worker_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x2695}, 0, 3));
		_addEntry("woman_health_worker_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x2695}, 0, 3));
		_addEntry("woman_health_worker_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x2695}, 0, 3));
		_addEntry("woman_health_worker_tone1", new String(new int[] {0x1f469,0x1f3fb,0x2695}, 0, 3));
		_addEntry("woman_health_worker_tone2", new String(new int[] {0x1f469,0x1f3fc,0x2695}, 0, 3));
		_addEntry("woman_health_worker_tone3", new String(new int[] {0x1f469,0x1f3fd,0x2695}, 0, 3));
		_addEntry("woman_health_worker_tone4", new String(new int[] {0x1f469,0x1f3fe,0x2695}, 0, 3));
		_addEntry("woman_health_worker_tone5", new String(new int[] {0x1f469,0x1f3ff,0x2695}, 0, 3));
		_addEntry("woman_judge", new String(new int[] {0x1f469,0x2696}, 0, 2));
		_addEntry("woman_judge_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x2696}, 0, 3));
		_addEntry("woman_judge_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x2696}, 0, 3));
		_addEntry("woman_judge_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x2696}, 0, 3));
		_addEntry("woman_judge_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x2696}, 0, 3));
		_addEntry("woman_judge_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x2696}, 0, 3));
		_addEntry("woman_judge_tone1", new String(new int[] {0x1f469,0x1f3fb,0x2696}, 0, 3));
		_addEntry("woman_judge_tone2", new String(new int[] {0x1f469,0x1f3fc,0x2696}, 0, 3));
		_addEntry("woman_judge_tone3", new String(new int[] {0x1f469,0x1f3fd,0x2696}, 0, 3));
		_addEntry("woman_judge_tone4", new String(new int[] {0x1f469,0x1f3fe,0x2696}, 0, 3));
		_addEntry("woman_judge_tone5", new String(new int[] {0x1f469,0x1f3ff,0x2696}, 0, 3));
		_addEntry("woman_juggling", new String(new int[] {0x1f939,0x2640}, 0, 2));
		_addEntry("woman_juggling_dark_skin_tone", new String(new int[] {0x1f939,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_juggling_light_skin_tone", new String(new int[] {0x1f939,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_juggling_medium_dark_skin_tone", new String(new int[] {0x1f939,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_juggling_medium_light_skin_tone", new String(new int[] {0x1f939,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_juggling_medium_skin_tone", new String(new int[] {0x1f939,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_juggling_tone1", new String(new int[] {0x1f939,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_juggling_tone2", new String(new int[] {0x1f939,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_juggling_tone3", new String(new int[] {0x1f939,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_juggling_tone4", new String(new int[] {0x1f939,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_juggling_tone5", new String(new int[] {0x1f939,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_lifting_weights", new String(new int[] {0x1f3cb,0x2640}, 0, 2));
		_addEntry("woman_lifting_weights_dark_skin_tone", new String(new int[] {0x1f3cb,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_lifting_weights_light_skin_tone", new String(new int[] {0x1f3cb,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_lifting_weights_medium_dark_skin_tone", new String(new int[] {0x1f3cb,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_lifting_weights_medium_light_skin_tone", new String(new int[] {0x1f3cb,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_lifting_weights_medium_skin_tone", new String(new int[] {0x1f3cb,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_lifting_weights_tone1", new String(new int[] {0x1f3cb,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_lifting_weights_tone2", new String(new int[] {0x1f3cb,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_lifting_weights_tone3", new String(new int[] {0x1f3cb,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_lifting_weights_tone4", new String(new int[] {0x1f3cb,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_lifting_weights_tone5", new String(new int[] {0x1f3cb,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_mechanic", new String(new int[] {0x1f469,0x1f527}, 0, 2));
		_addEntry("woman_mechanic_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f527}, 0, 3));
		_addEntry("woman_mechanic_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f527}, 0, 3));
		_addEntry("woman_mechanic_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f527}, 0, 3));
		_addEntry("woman_mechanic_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f527}, 0, 3));
		_addEntry("woman_mechanic_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f527}, 0, 3));
		_addEntry("woman_mechanic_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f527}, 0, 3));
		_addEntry("woman_mechanic_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f527}, 0, 3));
		_addEntry("woman_mechanic_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f527}, 0, 3));
		_addEntry("woman_mechanic_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f527}, 0, 3));
		_addEntry("woman_mechanic_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f527}, 0, 3));
		_addEntry("woman_mountain_biking", new String(new int[] {0x1f6b5,0x2640}, 0, 2));
		_addEntry("woman_mountain_biking_dark_skin_tone", new String(new int[] {0x1f6b5,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_mountain_biking_light_skin_tone", new String(new int[] {0x1f6b5,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_mountain_biking_medium_dark_skin_tone", new String(new int[] {0x1f6b5,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_mountain_biking_medium_light_skin_tone", new String(new int[] {0x1f6b5,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_mountain_biking_medium_skin_tone", new String(new int[] {0x1f6b5,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_mountain_biking_tone1", new String(new int[] {0x1f6b5,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_mountain_biking_tone2", new String(new int[] {0x1f6b5,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_mountain_biking_tone3", new String(new int[] {0x1f6b5,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_mountain_biking_tone4", new String(new int[] {0x1f6b5,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_mountain_biking_tone5", new String(new int[] {0x1f6b5,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_office_worker", new String(new int[] {0x1f469,0x1f4bc}, 0, 2));
		_addEntry("woman_office_worker_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f4bc}, 0, 3));
		_addEntry("woman_office_worker_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f4bc}, 0, 3));
		_addEntry("woman_office_worker_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f4bc}, 0, 3));
		_addEntry("woman_office_worker_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f4bc}, 0, 3));
		_addEntry("woman_office_worker_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f4bc}, 0, 3));
		_addEntry("woman_office_worker_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f4bc}, 0, 3));
		_addEntry("woman_office_worker_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f4bc}, 0, 3));
		_addEntry("woman_office_worker_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f4bc}, 0, 3));
		_addEntry("woman_office_worker_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f4bc}, 0, 3));
		_addEntry("woman_office_worker_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f4bc}, 0, 3));
		_addEntry("woman_pilot", new String(new int[] {0x1f469,0x2708}, 0, 2));
		_addEntry("woman_pilot_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x2708}, 0, 3));
		_addEntry("woman_pilot_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x2708}, 0, 3));
		_addEntry("woman_pilot_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x2708}, 0, 3));
		_addEntry("woman_pilot_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x2708}, 0, 3));
		_addEntry("woman_pilot_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x2708}, 0, 3));
		_addEntry("woman_pilot_tone1", new String(new int[] {0x1f469,0x1f3fb,0x2708}, 0, 3));
		_addEntry("woman_pilot_tone2", new String(new int[] {0x1f469,0x1f3fc,0x2708}, 0, 3));
		_addEntry("woman_pilot_tone3", new String(new int[] {0x1f469,0x1f3fd,0x2708}, 0, 3));
		_addEntry("woman_pilot_tone4", new String(new int[] {0x1f469,0x1f3fe,0x2708}, 0, 3));
		_addEntry("woman_pilot_tone5", new String(new int[] {0x1f469,0x1f3ff,0x2708}, 0, 3));
		_addEntry("woman_playing_handball", new String(new int[] {0x1f93e,0x2640}, 0, 2));
		_addEntry("woman_playing_handball_dark_skin_tone", new String(new int[] {0x1f93e,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_playing_handball_light_skin_tone", new String(new int[] {0x1f93e,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_playing_handball_medium_dark_skin_tone", new String(new int[] {0x1f93e,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_playing_handball_medium_light_skin_tone", new String(new int[] {0x1f93e,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_playing_handball_medium_skin_tone", new String(new int[] {0x1f93e,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_playing_handball_tone1", new String(new int[] {0x1f93e,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_playing_handball_tone2", new String(new int[] {0x1f93e,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_playing_handball_tone3", new String(new int[] {0x1f93e,0x1f3fd,0x2640}, 0, 3));
	}
	private static void init33(){
		_addEntry("woman_playing_handball_tone4", new String(new int[] {0x1f93e,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_playing_handball_tone5", new String(new int[] {0x1f93e,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_playing_water_polo", new String(new int[] {0x1f93d,0x2640}, 0, 2));
		_addEntry("woman_playing_water_polo_dark_skin_tone", new String(new int[] {0x1f93d,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_playing_water_polo_light_skin_tone", new String(new int[] {0x1f93d,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_playing_water_polo_medium_dark_skin_tone", new String(new int[] {0x1f93d,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_playing_water_polo_medium_light_skin_tone", new String(new int[] {0x1f93d,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_playing_water_polo_medium_skin_tone", new String(new int[] {0x1f93d,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_playing_water_polo_tone1", new String(new int[] {0x1f93d,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_playing_water_polo_tone2", new String(new int[] {0x1f93d,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_playing_water_polo_tone3", new String(new int[] {0x1f93d,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_playing_water_polo_tone4", new String(new int[] {0x1f93d,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_playing_water_polo_tone5", new String(new int[] {0x1f93d,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_police_officer", new String(new int[] {0x1f46e,0x2640}, 0, 2));
		_addEntry("woman_police_officer_dark_skin_tone", new String(new int[] {0x1f46e,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_police_officer_light_skin_tone", new String(new int[] {0x1f46e,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_police_officer_medium_dark_skin_tone", new String(new int[] {0x1f46e,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_police_officer_medium_light_skin_tone", new String(new int[] {0x1f46e,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_police_officer_medium_skin_tone", new String(new int[] {0x1f46e,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_police_officer_tone1", new String(new int[] {0x1f46e,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_police_officer_tone2", new String(new int[] {0x1f46e,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_police_officer_tone3", new String(new int[] {0x1f46e,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_police_officer_tone4", new String(new int[] {0x1f46e,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_police_officer_tone5", new String(new int[] {0x1f46e,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_pouting", new String(new int[] {0x1f64e,0x2640}, 0, 2));
		_addEntry("woman_pouting_dark_skin_tone", new String(new int[] {0x1f64e,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_pouting_light_skin_tone", new String(new int[] {0x1f64e,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_pouting_medium_dark_skin_tone", new String(new int[] {0x1f64e,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_pouting_medium_light_skin_tone", new String(new int[] {0x1f64e,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_pouting_medium_skin_tone", new String(new int[] {0x1f64e,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_pouting_tone1", new String(new int[] {0x1f64e,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_pouting_tone2", new String(new int[] {0x1f64e,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_pouting_tone3", new String(new int[] {0x1f64e,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_pouting_tone4", new String(new int[] {0x1f64e,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_pouting_tone5", new String(new int[] {0x1f64e,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_raising_hand", new String(new int[] {0x1f64b,0x2640}, 0, 2));
		_addEntry("woman_raising_hand_dark_skin_tone", new String(new int[] {0x1f64b,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_raising_hand_light_skin_tone", new String(new int[] {0x1f64b,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_raising_hand_medium_dark_skin_tone", new String(new int[] {0x1f64b,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_raising_hand_medium_light_skin_tone", new String(new int[] {0x1f64b,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_raising_hand_medium_skin_tone", new String(new int[] {0x1f64b,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_raising_hand_tone1", new String(new int[] {0x1f64b,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_raising_hand_tone2", new String(new int[] {0x1f64b,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_raising_hand_tone3", new String(new int[] {0x1f64b,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_raising_hand_tone4", new String(new int[] {0x1f64b,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_raising_hand_tone5", new String(new int[] {0x1f64b,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_rowing_boat", new String(new int[] {0x1f6a3,0x2640}, 0, 2));
		_addEntry("woman_rowing_boat_dark_skin_tone", new String(new int[] {0x1f6a3,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_rowing_boat_light_skin_tone", new String(new int[] {0x1f6a3,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_rowing_boat_medium_dark_skin_tone", new String(new int[] {0x1f6a3,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_rowing_boat_medium_light_skin_tone", new String(new int[] {0x1f6a3,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_rowing_boat_medium_skin_tone", new String(new int[] {0x1f6a3,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_rowing_boat_tone1", new String(new int[] {0x1f6a3,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_rowing_boat_tone2", new String(new int[] {0x1f6a3,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_rowing_boat_tone3", new String(new int[] {0x1f6a3,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_rowing_boat_tone4", new String(new int[] {0x1f6a3,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_rowing_boat_tone5", new String(new int[] {0x1f6a3,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_running", new String(new int[] {0x1f3c3,0x2640}, 0, 2));
		_addEntry("woman_running_dark_skin_tone", new String(new int[] {0x1f3c3,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_running_light_skin_tone", new String(new int[] {0x1f3c3,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_running_medium_dark_skin_tone", new String(new int[] {0x1f3c3,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_running_medium_light_skin_tone", new String(new int[] {0x1f3c3,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_running_medium_skin_tone", new String(new int[] {0x1f3c3,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_running_tone1", new String(new int[] {0x1f3c3,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_running_tone2", new String(new int[] {0x1f3c3,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_running_tone3", new String(new int[] {0x1f3c3,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_running_tone4", new String(new int[] {0x1f3c3,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_running_tone5", new String(new int[] {0x1f3c3,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_scientist", new String(new int[] {0x1f469,0x1f52c}, 0, 2));
		_addEntry("woman_scientist_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f52c}, 0, 3));
		_addEntry("woman_scientist_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f52c}, 0, 3));
		_addEntry("woman_scientist_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f52c}, 0, 3));
		_addEntry("woman_scientist_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f52c}, 0, 3));
		_addEntry("woman_scientist_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f52c}, 0, 3));
		_addEntry("woman_scientist_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f52c}, 0, 3));
		_addEntry("woman_scientist_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f52c}, 0, 3));
		_addEntry("woman_scientist_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f52c}, 0, 3));
		_addEntry("woman_scientist_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f52c}, 0, 3));
		_addEntry("woman_scientist_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f52c}, 0, 3));
		_addEntry("woman_shrugging", new String(new int[] {0x1f937,0x2640}, 0, 2));
		_addEntry("woman_shrugging_dark_skin_tone", new String(new int[] {0x1f937,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_shrugging_light_skin_tone", new String(new int[] {0x1f937,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_shrugging_medium_dark_skin_tone", new String(new int[] {0x1f937,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_shrugging_medium_light_skin_tone", new String(new int[] {0x1f937,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_shrugging_medium_skin_tone", new String(new int[] {0x1f937,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_shrugging_tone1", new String(new int[] {0x1f937,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_shrugging_tone2", new String(new int[] {0x1f937,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_shrugging_tone3", new String(new int[] {0x1f937,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_shrugging_tone4", new String(new int[] {0x1f937,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_shrugging_tone5", new String(new int[] {0x1f937,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_singer", new String(new int[] {0x1f469,0x1f3a4}, 0, 2));
		_addEntry("woman_singer_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f3a4}, 0, 3));
		_addEntry("woman_singer_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f3a4}, 0, 3));
		_addEntry("woman_singer_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f3a4}, 0, 3));
		_addEntry("woman_singer_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f3a4}, 0, 3));
		_addEntry("woman_singer_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f3a4}, 0, 3));
		_addEntry("woman_singer_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f3a4}, 0, 3));
		_addEntry("woman_singer_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f3a4}, 0, 3));
		_addEntry("woman_singer_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f3a4}, 0, 3));
		_addEntry("woman_singer_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f3a4}, 0, 3));
		_addEntry("woman_singer_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f3a4}, 0, 3));
	}
	private static void init34(){
		_addEntry("woman_student", new String(new int[] {0x1f469,0x1f393}, 0, 2));
		_addEntry("woman_student_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f393}, 0, 3));
		_addEntry("woman_student_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f393}, 0, 3));
		_addEntry("woman_student_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f393}, 0, 3));
		_addEntry("woman_student_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f393}, 0, 3));
		_addEntry("woman_student_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f393}, 0, 3));
		_addEntry("woman_student_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f393}, 0, 3));
		_addEntry("woman_student_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f393}, 0, 3));
		_addEntry("woman_student_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f393}, 0, 3));
		_addEntry("woman_student_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f393}, 0, 3));
		_addEntry("woman_student_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f393}, 0, 3));
		_addEntry("woman_surfing", new String(new int[] {0x1f3c4,0x2640}, 0, 2));
		_addEntry("woman_surfing_dark_skin_tone", new String(new int[] {0x1f3c4,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_surfing_light_skin_tone", new String(new int[] {0x1f3c4,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_surfing_medium_dark_skin_tone", new String(new int[] {0x1f3c4,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_surfing_medium_light_skin_tone", new String(new int[] {0x1f3c4,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_surfing_medium_skin_tone", new String(new int[] {0x1f3c4,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_surfing_tone1", new String(new int[] {0x1f3c4,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_surfing_tone2", new String(new int[] {0x1f3c4,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_surfing_tone3", new String(new int[] {0x1f3c4,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_surfing_tone4", new String(new int[] {0x1f3c4,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_surfing_tone5", new String(new int[] {0x1f3c4,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_swimming", new String(new int[] {0x1f3ca,0x2640}, 0, 2));
		_addEntry("woman_swimming_dark_skin_tone", new String(new int[] {0x1f3ca,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_swimming_light_skin_tone", new String(new int[] {0x1f3ca,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_swimming_medium_dark_skin_tone", new String(new int[] {0x1f3ca,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_swimming_medium_light_skin_tone", new String(new int[] {0x1f3ca,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_swimming_medium_skin_tone", new String(new int[] {0x1f3ca,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_swimming_tone1", new String(new int[] {0x1f3ca,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_swimming_tone2", new String(new int[] {0x1f3ca,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_swimming_tone3", new String(new int[] {0x1f3ca,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_swimming_tone4", new String(new int[] {0x1f3ca,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_swimming_tone5", new String(new int[] {0x1f3ca,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_teacher", new String(new int[] {0x1f469,0x1f3eb}, 0, 2));
		_addEntry("woman_teacher_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f3eb}, 0, 3));
		_addEntry("woman_teacher_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f3eb}, 0, 3));
		_addEntry("woman_teacher_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f3eb}, 0, 3));
		_addEntry("woman_teacher_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f3eb}, 0, 3));
		_addEntry("woman_teacher_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f3eb}, 0, 3));
		_addEntry("woman_teacher_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f3eb}, 0, 3));
		_addEntry("woman_teacher_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f3eb}, 0, 3));
		_addEntry("woman_teacher_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f3eb}, 0, 3));
		_addEntry("woman_teacher_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f3eb}, 0, 3));
		_addEntry("woman_teacher_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f3eb}, 0, 3));
		_addEntry("woman_technologist", new String(new int[] {0x1f469,0x1f4bb}, 0, 2));
		_addEntry("woman_technologist_dark_skin_tone", new String(new int[] {0x1f469,0x1f3ff,0x1f4bb}, 0, 3));
		_addEntry("woman_technologist_light_skin_tone", new String(new int[] {0x1f469,0x1f3fb,0x1f4bb}, 0, 3));
		_addEntry("woman_technologist_medium_dark_skin_tone", new String(new int[] {0x1f469,0x1f3fe,0x1f4bb}, 0, 3));
		_addEntry("woman_technologist_medium_light_skin_tone", new String(new int[] {0x1f469,0x1f3fc,0x1f4bb}, 0, 3));
		_addEntry("woman_technologist_medium_skin_tone", new String(new int[] {0x1f469,0x1f3fd,0x1f4bb}, 0, 3));
		_addEntry("woman_technologist_tone1", new String(new int[] {0x1f469,0x1f3fb,0x1f4bb}, 0, 3));
		_addEntry("woman_technologist_tone2", new String(new int[] {0x1f469,0x1f3fc,0x1f4bb}, 0, 3));
		_addEntry("woman_technologist_tone3", new String(new int[] {0x1f469,0x1f3fd,0x1f4bb}, 0, 3));
		_addEntry("woman_technologist_tone4", new String(new int[] {0x1f469,0x1f3fe,0x1f4bb}, 0, 3));
		_addEntry("woman_technologist_tone5", new String(new int[] {0x1f469,0x1f3ff,0x1f4bb}, 0, 3));
		_addEntry("woman_tipping_hand", new String(new int[] {0x1f481,0x2640}, 0, 2));
		_addEntry("woman_tipping_hand_dark_skin_tone", new String(new int[] {0x1f481,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_tipping_hand_light_skin_tone", new String(new int[] {0x1f481,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_tipping_hand_medium_dark_skin_tone", new String(new int[] {0x1f481,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_tipping_hand_medium_light_skin_tone", new String(new int[] {0x1f481,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_tipping_hand_medium_skin_tone", new String(new int[] {0x1f481,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_tipping_hand_tone1", new String(new int[] {0x1f481,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_tipping_hand_tone2", new String(new int[] {0x1f481,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_tipping_hand_tone3", new String(new int[] {0x1f481,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_tipping_hand_tone4", new String(new int[] {0x1f481,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_tipping_hand_tone5", new String(new int[] {0x1f481,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_tone1", new String(new int[] {0x1f469,0x1f3fb}, 0, 2));
		_addEntry("woman_tone2", new String(new int[] {0x1f469,0x1f3fc}, 0, 2));
		_addEntry("woman_tone3", new String(new int[] {0x1f469,0x1f3fd}, 0, 2));
		_addEntry("woman_tone4", new String(new int[] {0x1f469,0x1f3fe}, 0, 2));
		_addEntry("woman_tone5", new String(new int[] {0x1f469,0x1f3ff}, 0, 2));
		_addEntry("woman_walking", new String(new int[] {0x1f6b6,0x2640}, 0, 2));
		_addEntry("woman_walking_dark_skin_tone", new String(new int[] {0x1f6b6,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_walking_light_skin_tone", new String(new int[] {0x1f6b6,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_walking_medium_dark_skin_tone", new String(new int[] {0x1f6b6,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_walking_medium_light_skin_tone", new String(new int[] {0x1f6b6,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_walking_medium_skin_tone", new String(new int[] {0x1f6b6,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_walking_tone1", new String(new int[] {0x1f6b6,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_walking_tone2", new String(new int[] {0x1f6b6,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_walking_tone3", new String(new int[] {0x1f6b6,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_walking_tone4", new String(new int[] {0x1f6b6,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_walking_tone5", new String(new int[] {0x1f6b6,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_wearing_turban", new String(new int[] {0x1f473,0x2640}, 0, 2));
		_addEntry("woman_wearing_turban_dark_skin_tone", new String(new int[] {0x1f473,0x1f3ff,0x2640}, 0, 3));
		_addEntry("woman_wearing_turban_light_skin_tone", new String(new int[] {0x1f473,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_wearing_turban_medium_dark_skin_tone", new String(new int[] {0x1f473,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_wearing_turban_medium_light_skin_tone", new String(new int[] {0x1f473,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_wearing_turban_medium_skin_tone", new String(new int[] {0x1f473,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_wearing_turban_tone1", new String(new int[] {0x1f473,0x1f3fb,0x2640}, 0, 3));
		_addEntry("woman_wearing_turban_tone2", new String(new int[] {0x1f473,0x1f3fc,0x2640}, 0, 3));
		_addEntry("woman_wearing_turban_tone3", new String(new int[] {0x1f473,0x1f3fd,0x2640}, 0, 3));
		_addEntry("woman_wearing_turban_tone4", new String(new int[] {0x1f473,0x1f3fe,0x2640}, 0, 3));
		_addEntry("woman_wearing_turban_tone5", new String(new int[] {0x1f473,0x1f3ff,0x2640}, 0, 3));
		_addEntry("womans_clothes", new String(new int[] {0x1f45a}, 0, 1));
		_addEntry("womans_hat", new String(new int[] {0x1f452}, 0, 1));
		_addEntry("women_with_bunny_ears_partying", new String(new int[] {0x1f46f,0x2640}, 0, 2));
		_addEntry("women_wrestling", new String(new int[] {0x1f93c,0x2640}, 0, 2));
		_addEntry("womens", new String(new int[] {0x1f6ba}, 0, 1));
		_addEntry("world_map", new String(new int[] {0x1f5fa}, 0, 1));
		_addEntry("worried", new String(new int[] {0x1f61f}, 0, 1));
		_addEntry("worship_symbol", new String(new int[] {0x1f6d0}, 0, 1));
	}
	private static void init35(){
		_addEntry("wrench", new String(new int[] {0x1f527}, 0, 1));
		_addEntry("wrestlers", new String(new int[] {0x1f93c}, 0, 1));
		_addEntry("wrestling", new String(new int[] {0x1f93c}, 0, 1));
		_addEntry("writing_hand", new String(new int[] {0x270d}, 0, 1));
		_addEntry("writing_hand_tone1", new String(new int[] {0x270d,0x1f3fb}, 0, 2));
		_addEntry("writing_hand_tone2", new String(new int[] {0x270d,0x1f3fc}, 0, 2));
		_addEntry("writing_hand_tone3", new String(new int[] {0x270d,0x1f3fd}, 0, 2));
		_addEntry("writing_hand_tone4", new String(new int[] {0x270d,0x1f3fe}, 0, 2));
		_addEntry("writing_hand_tone5", new String(new int[] {0x270d,0x1f3ff}, 0, 2));
		_addEntry("ws", new String(new int[] {0x1f1fc,0x1f1f8}, 0, 2));
		_addEntry("x", new String(new int[] {0x274c}, 0, 1));
		_addEntry("xk", new String(new int[] {0x1f1fd,0x1f1f0}, 0, 2));
		_addEntry("ye", new String(new int[] {0x1f1fe,0x1f1ea}, 0, 2));
		_addEntry("yellow_heart", new String(new int[] {0x1f49b}, 0, 1));
		_addEntry("yen", new String(new int[] {0x1f4b4}, 0, 1));
		_addEntry("yin_yang", new String(new int[] {0x262f}, 0, 1));
		_addEntry("yt", new String(new int[] {0x1f1fe,0x1f1f9}, 0, 2));
		_addEntry("yum", new String(new int[] {0x1f60b}, 0, 1));
		_addEntry("za", new String(new int[] {0x1f1ff,0x1f1e6}, 0, 2));
		_addEntry("zap", new String(new int[] {0x26a1}, 0, 1));
		_addEntry("zero", new String(new int[] {0x0030,0x20e3}, 0, 2));
		_addEntry("zipper_mouth", new String(new int[] {0x1f910}, 0, 1));
		_addEntry("zipper_mouth_face", new String(new int[] {0x1f910}, 0, 1));
		_addEntry("zm", new String(new int[] {0x1f1ff,0x1f1f2}, 0, 2));
		_addEntry("zw", new String(new int[] {0x1f1ff,0x1f1fc}, 0, 2));
		_addEntry("zzz", new String(new int[] {0x1f4a4}, 0, 1));
	}
	static{
		init1();
		init2();
		init3();
		init4();
		init5();
		init6();
		init7();
		init8();
		init9();
		init10();
		init11();
		init12();
		init13();
		init14();
		init15();
		init16();
		init17();
		init18();
		init19();
		init20();
		init21();
		init22();
		init23();
		init24();
		init25();
		init26();
		init27();
		init28();
		init29();
		init30();
		init31();
		init32();
		init33();
		init34();
		init35();
	}
//codepoint_max=0x1f9c0, length_max=4
	
	
	
}
